
This is a patch file against 0.2.13.

Change to directory gnupg-0.2.13 (or however you renamed it)
and give this command:

     zcat somepath/gnupg-0.2.14.diff.gz | patch -p1

It is a good idea to rename your current directory to gnupg-0.2.14 now.



Prereq: 0.2.13

diff -urN gnupg-0.2.13/VERSION gnupg-0.2.14/VERSION
--- gnupg-0.2.13/VERSION	Tue Mar 10 18:45:37 1998
+++ gnupg-0.2.14/VERSION	Thu Apr  2 12:04:59 1998
@@ -1 +1 @@
-0.2.13
+0.2.14

diff -urN gnupg-0.2.13/NEWS gnupg-0.2.14/NEWS
--- gnupg-0.2.13/NEWS	Tue Mar 10 18:45:26 1998
+++ gnupg-0.2.14/NEWS	Thu Apr  2 12:04:54 1998
@@ -1,3 +1,19 @@
+Noteworthy changes in version 0.2.14
+------------------------------------
+
+    * Changed the internal handling of keyrings.
+
+    * Add support to list PGP 5 keyrings with supkeys
+
+    * Timestamps of signatures are now verified.
+
+    * A expiration time can now be specified during key generation.
+
+    * Some speedups for Blowfish and SHA-1, rewrote SHA-1 transform.
+      Reduced the amount of random bytes needed for key generation in
+      some cases.
+
+
 Noteworthy changes in version 0.2.13
 ------------------------------------
 
diff -urN gnupg-0.2.13/THANKS gnupg-0.2.14/THANKS
--- gnupg-0.2.13/THANKS	Sun Mar  8 13:51:13 1998
+++ gnupg-0.2.14/THANKS	Thu Mar 19 16:41:33 1998
@@ -7,11 +7,13 @@
 Anand Kumria		wildfire@progsoc.uts.edu.au
 Daniel Eisenbud 	eisenbud@cs.swarthmore.edu
 Detlef Lannert		lannert@lannert.rz.uni-duesseldorf.de
+Ed Boraas		ecxjo@esperanto.org
 Ernst Molitor		ernst.molitor@uni-bonn.de
 Hendrik Buschkamp	buschkamp@rheumanet.org
 James Troup		J.J.Troup@scm.brad.ac.uk
 Jean-loup Gailly	gzip@prep.ai.mit.edu
 Jens Bachem		bachem@rrz.uni-koeln.de
+Marco d'Itri            md@linux.it
 Mark Adler		madler@alumni.caltech.edu
 Martin Schulte		schulte@thp.uni-koeln.de
 Peter Gutmann		pgut001@cs.auckland.ac.nz
@@ -21,6 +23,7 @@
 Walter Koch		walterk@ddorf.rhein-ruhr.de
 Werner Koch		werner.koch@guug.de
 Wim Vandeputte		bunbun@reptile.rug.ac.be
+
 
 Thanks to the German Unix User Group for providing FTP space and
 Martin Hamilton for hosting the mailing list.
diff -urN gnupg-0.2.13/TODO gnupg-0.2.14/TODO
--- gnupg-0.2.13/TODO	Tue Mar 10 17:10:59 1998
+++ gnupg-0.2.14/TODO	Thu Apr  2 12:04:49 1998
@@ -2,7 +2,7 @@
     * improve iobuf by reading more than one byte at once,
       this shoud espceially done for the buffer in the chain.
       Change the buffering to a mbuf like scheme? Need it for PSST anyway.
-    * add a way to difference between errors and eof in the underflow/flush
+    * add a way to distinguish between errors and eof in the underflow/flush
       function of iobuf.
     * add checking of armor trailers
     * remove all "Fixmes"
@@ -37,4 +37,15 @@
     * cleanup mainproc.c, much stuff is duplicated.
 
     * remove key management stuff from sign.c.
+
+    * add fingerprint/keyid hashing. We need a new field in PKC to
+      flag that we may have a cached signature for this (and use the address
+      of PKC to lookup the hash).
+
+    * change the misleading usage of public key certificate to public key data
+      or something like this.
+
+    * seckey_cert.c: merge all the check funtions into one.
+
+    * fix the problems with "\v" in gettext
 
diff -urN gnupg-0.2.13/checks/Makefile.am gnupg-0.2.14/checks/Makefile.am
--- gnupg-0.2.13/checks/Makefile.am	Tue Mar 10 18:14:11 1998
+++ gnupg-0.2.14/checks/Makefile.am	Wed Apr  1 18:56:01 1998
@@ -8,7 +8,8 @@
 
 
 TEST_FILES = pubring.asc secring.asc gnupg.asc plain-1 plain-2 plain-3o.asc \
-	     plain-1.asc plain-2.asc plain-3.asc
+	     plain-1.asc plain-2.asc plain-3.asc \
+	     pubring.pkr.asc secring.skr.asc
 
 DATA_FILES = data-500 data-9000 data-32000 data-80000
 
@@ -17,7 +18,8 @@
 
 check: prepared.stamp
 
-prepared.stamp: pubring.gpg secring.gpg gnupg.sig plain-3 $(DATA_FILES)
+prepared.stamp: pubring.gpg secring.gpg gnupg.sig plain-3 \
+		pubring.pkr secring.skr $(DATA_FILES)
 	@set -x; \
 	echo "def" | ../g10/gpg -v --no-operation; \
 	echo timestamp >./prepared.stamp
@@ -30,6 +32,10 @@
 	../g10/gpgm --yes --dearmor -o gnupg.sig gnupg.asc
 plain-3: plain-3o.asc
 	../g10/gpgm --yes --dearmor -o plain-3 plain-3o.asc
+pubring.pkr: pubring.pkr.asc
+	../g10/gpgm --yes --dearmor -o pubring.pkr pubring.pkr.asc
+secring.skr: secring.skr.asc
+	../g10/gpgm --yes --dearmor -o secring.skr secring.skr.asc
 
 data-500:
 	head -c 500 /dev/urandom >data-500
diff -urN gnupg-0.2.13/checks/Makefile.in gnupg-0.2.14/checks/Makefile.in
--- gnupg-0.2.13/checks/Makefile.in	Tue Mar 10 18:48:20 1998
+++ gnupg-0.2.14/checks/Makefile.in	Thu Apr  2 12:06:37 1998
@@ -99,7 +99,8 @@
 	armdetachm.test detachm.test genkey1024.test
 
 TEST_FILES = pubring.asc secring.asc gnupg.asc plain-1 plain-2 plain-3o.asc \
-	     plain-1.asc plain-2.asc plain-3.asc
+	     plain-1.asc plain-2.asc plain-3.asc \
+	     pubring.pkr.asc secring.skr.asc
 
 DATA_FILES = data-500 data-9000 data-32000 data-80000
 
@@ -221,7 +222,8 @@
 
 check: prepared.stamp
 
-prepared.stamp: pubring.gpg secring.gpg gnupg.sig plain-3 $(DATA_FILES)
+prepared.stamp: pubring.gpg secring.gpg gnupg.sig plain-3 \
+		pubring.pkr secring.skr $(DATA_FILES)
 	@set -x; \
 	echo "def" | ../g10/gpg -v --no-operation; \
 	echo timestamp >./prepared.stamp
@@ -234,6 +236,10 @@
 	../g10/gpgm --yes --dearmor -o gnupg.sig gnupg.asc
 plain-3: plain-3o.asc
 	../g10/gpgm --yes --dearmor -o plain-3 plain-3o.asc
+pubring.pkr: pubring.pkr.asc
+	../g10/gpgm --yes --dearmor -o pubring.pkr pubring.pkr.asc
+secring.skr: secring.skr.asc
+	../g10/gpgm --yes --dearmor -o secring.skr secring.skr.asc
 
 data-500:
 	head -c 500 /dev/urandom >data-500
diff -urN gnupg-0.2.13/checks/decrypt.test gnupg-0.2.14/checks/decrypt.test
--- gnupg-0.2.13/checks/decrypt.test	Tue Mar 10 18:33:10 1998
+++ gnupg-0.2.14/checks/decrypt.test	Thu Mar 19 16:25:36 1998
@@ -4,7 +4,7 @@
 
 #info Checking decryption of supplied files
 for i in $plain_files ; do
-    echo "$usrpass1" | run_gpg -v --passphrase-fd 0 -o y --yes $i.asc
+    echo "$usrpass1" | run_gpg  --passphrase-fd 0 -o y --yes $i.asc
     cmp $i y || error "$i: mismatch"
 done
 
diff -urN gnupg-0.2.13/checks/pubring.pkr.asc gnupg-0.2.14/checks/pubring.pkr.asc
--- gnupg-0.2.13/checks/pubring.pkr.asc	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.14/checks/pubring.pkr.asc	Tue Mar 17 18:14:32 1998
@@ -0,0 +1,28 @@
+This is a test pubring generated by pgp 5 beta
+
+Type Bits KeyID    Created    Expires    Algorithm       Use
+sec+  768 439F02CA 1998-03-17 ---------- DSS             Sign and Encrypt
+sub   768 CB879DE9 1998-03-17 ---------- Diffie-Hellman
+uid  pgp5 test <pgp5@dev.null>
+
+
+-----BEGIN PGP ARMORED FILE-----
+Version: GNUPG v0.2.13a (Linux)
+Comment: This is an alpha version!
+Comment: Use "gpgm --dearmor" for unpacking
+
+mQFCBDUOrE4RAwDbbxWAbWsheUJprK6VryMTpwDiYwMfL+92nrHqSfPqlpMWgDTia8qnpRSXbyEm
+Sppp/6/Ygp+N3n32Kznq7PjHXiuWLlZGvZMtzmvaMA17y0GY6oLBxS7rhASXIKa9hEUAoP+KBFly
+qNMdsK8j+ZO0A8rnImGrAwC1ddDme5iZFkTEWHhrtU97sEu2GDkSQB8HdX8CoRcrOz/B2WliF6qf
+BKhcZPFVBIhKNzjTfY7SEYAZk2zcsCm8elnwSLaGEzxKFNFBqKDNXP+a35spcqsHSGzDVw4VuKMD
+AJNnAP6skpHlhVAmecLZT9eRzVoOq1ivUIntK2Mh47qsL74q6BBwz2sviPU2Y3pDlbb6Ed0qJAXv
+dCT24hlfoGoXzkoDInkPJTJeL0gCnwmQPjvXFFd71Cvg5LaL4lIQLbABh7QZcGdwNSB0ZXN0IDxw
+Z3A1QGRldi5udWxsPrABA4kASwQQEQIACwUCNQ6sTgQLAwECAAoJENY0E25DnwLKxIoAoPSyM/Mw
+BogpyMU5YY+Sj74k3UIfAJ0RopQa8ciickDVzoSVPrGysrnOkLABZ7kAzQQ1DqxWEAMA/wVrlNsP
+qTxWZbUiMrUN8MjTFR2xUhuTw3cdvRgiVPUT/q1l1+I3CpopVBx/XuAkg5sHB80zc6pZg652YFV3
+dLoTceS7ridb5k23sHa2hZGCeTo6AdxIOy53giCPDP9FAAICAv9Oh5/OVxUqI+6hsp9ccOEhRA9N
+8aJzYDPjvCQyhgej2P1kTsBZqWIx0/PiMvIt+qqhT2YfyD68mHIBztScAXZKTnjroUPKl0+bkX09
+NbdyqojAkzhaCRKUzwnaHEfhi2WwAYeJAD8DBRg1DqxW1jQTbkOfAsoRAnaPAJ0Z/k6Y2ypgDhXo
+qBLeW7Lq/AKYEACeLTod6Nt117DkqDz9epmIqwWOE1ewAWc=
+=6BrN
+-----END PGP ARMORED FILE-----
diff -urN gnupg-0.2.13/checks/secring.skr.asc gnupg-0.2.14/checks/secring.skr.asc
--- gnupg-0.2.13/checks/secring.skr.asc	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.14/checks/secring.skr.asc	Tue Mar 17 18:15:17 1998
@@ -0,0 +1,27 @@
+This is a test secring generated by pgp 5 beta
+
+Type Bits KeyID    Created    Expires    Algorithm       Use
+sec+  768 439F02CA 1998-03-17 ---------- DSS             Sign and Encrypt
+sub   768 CB879DE9 1998-03-17 ---------- Diffie-Hellman                 
+uid  pgp5 test <pgp5@dev.null>
+
+There is no password on the key
+
+-----BEGIN PGP ARMORED FILE-----
+Version: GNUPG v0.2.13a (Linux)
+Comment: This is an alpha version!
+Comment: Use "gpgm --dearmor" for unpacking
+
+lQFbBDUOrE4RAwDbbxWAbWsheUJprK6VryMTpwDiYwMfL+92nrHqSfPqlpMWgDTia8qnpRSXbyEm
+Sppp/6/Ygp+N3n32Kznq7PjHXiuWLlZGvZMtzmvaMA17y0GY6oLBxS7rhASXIKa9hEUAoP+KBFly
+qNMdsK8j+ZO0A8rnImGrAwC1ddDme5iZFkTEWHhrtU97sEu2GDkSQB8HdX8CoRcrOz/B2WliF6qf
+BKhcZPFVBIhKNzjTfY7SEYAZk2zcsCm8elnwSLaGEzxKFNFBqKDNXP+a35spcqsHSGzDVw4VuKMD
+AJNnAP6skpHlhVAmecLZT9eRzVoOq1ivUIntK2Mh47qsL74q6BBwz2sviPU2Y3pDlbb6Ed0qJAXv
+dCT24hlfoGoXzkoDInkPJTJeL0gCnwmQPjvXFFd71Cvg5LaL4lIQLQAAn3GbgsWo+7E/hWakzstp
+TXzI2kDIDIm0GXBncDUgdGVzdCA8cGdwNUBkZXYubnVsbD6dAO8ENQ6sVhADAP8Fa5TbD6k8VmW1
+IjK1DfDI0xUdsVIbk8N3Hb0YIlT1E/6tZdfiNwqaKVQcf17gJIObBwfNM3OqWYOudmBVd3S6E3Hk
+u64nW+ZNt7B2toWRgnk6OgHcSDsud4Igjwz/RQACAgL/ToefzlcVKiPuobKfXHDhIUQPTfGic2Az
+47wkMoYHo9j9ZE7AWaliMdPz4jLyLfqqoU9mH8g+vJhyAc7UnAF2Sk5466FDypdPm5F9PTW3cqqI
+wJM4WgkSlM8J2hxH4YtlAADlG+pxFXNFuDPmcq6jL6dug2ikZ7hcHLAy7DddSS8OAA==
+=1UWo
+-----END PGP ARMORED FILE-----
diff -urN gnupg-0.2.13/cipher/ChangeLog gnupg-0.2.14/cipher/ChangeLog
--- gnupg-0.2.13/cipher/ChangeLog	Tue Mar 10 16:32:22 1998
+++ gnupg-0.2.14/cipher/ChangeLog	Wed Apr  1 16:38:54 1998
@@ -1,3 +1,19 @@
+Wed Apr  1 16:38:27 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* elgamla.c (elg_generate): Faster generation of x in some cases.
+
+Thu Mar 19 13:54:48 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* blowfish.c (blowfish_decode_cfb): changed XOR operation
+	(blowfish_encode_cfb): Ditto.
+
+Thu Mar 12 14:04:05 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* sha1.c (transform): Rewrote
+
+	* blowfish.c (encrypt): Unrolled for rounds == 16
+	(decrypt): Ditto.
+
 Tue Mar 10 16:32:08 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* rmd160.c (transform): Unrolled the loop.
diff -urN gnupg-0.2.13/cipher/Makefile.am gnupg-0.2.14/cipher/Makefile.am
--- gnupg-0.2.13/cipher/Makefile.am	Tue Mar  3 15:16:34 1998
+++ gnupg-0.2.14/cipher/Makefile.am	Wed Apr  1 18:44:23 1998
@@ -1,6 +1,6 @@
 ## Process this file with automake to produce Makefile.in
 
-INCLUDES =  -I$(top_srcdir)/include
+INCLUDES =  -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 EXTRA_DIST = @CIPHER_EXTRA_DIST@
 
 noinst_LIBRARIES = libcipher.a
diff -urN gnupg-0.2.13/cipher/Makefile.in gnupg-0.2.14/cipher/Makefile.in
--- gnupg-0.2.13/cipher/Makefile.in	Tue Mar 10 18:48:07 1998
+++ gnupg-0.2.14/cipher/Makefile.in	Thu Apr  2 12:06:23 1998
@@ -92,7 +92,7 @@
 ZLIBS = @ZLIBS@
 l = @l@
 
-INCLUDES =  -I$(top_srcdir)/include
+INCLUDES =  -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 EXTRA_DIST = @CIPHER_EXTRA_DIST@
 
 noinst_LIBRARIES = libcipher.a
diff -urN gnupg-0.2.13/cipher/blowfish.c gnupg-0.2.14/cipher/blowfish.c
--- gnupg-0.2.13/cipher/blowfish.c	Wed Mar  4 10:53:21 1998
+++ gnupg-0.2.14/cipher/blowfish.c	Thu Mar 19 16:24:07 1998
@@ -227,8 +227,7 @@
 
 
 
-
-
+#if BLOWFISH_ROUNDS != 16
 static inline u32
 function_F( BLOWFISH_context *bc, u32 x )
 {
@@ -248,48 +247,130 @@
 
     return ((bc->s0[a] + bc->s1[b]) ^ bc->s2[c] ) + bc->s3[d];
 }
+#endif
+
+#ifdef BIG_ENDIAN_HOST
+  #define F(x) ((( s0[((byte*)&x)[0]] + s1[((byte*)&x)[1]])	 \
+		   ^ s2[((byte*)&x)[2]]) + s3[((byte*)&x)[3]] )
+#else
+  #define F(x) ((( s0[((byte*)&x)[3]] + s1[((byte*)&x)[2]])	 \
+		   ^ s2[((byte*)&x)[1]]) + s3[((byte*)&x)[0]] )
+#endif
+#define R(l,r,i)  do { l ^= p[i]; r ^= F(l); } while(0)
 
 
 static void
 encrypt(  BLOWFISH_context *bc, u32 *ret_xl, u32 *ret_xr )
 {
-    u32 xl, xr, temp;
+  #if BLOWFISH_ROUNDS == 16
+    u32 xl, xr, *s0, *s1, *s2, *s3, *p;
+
+    xl = *ret_xl;
+    xr = *ret_xr;
+    p = bc->p;
+    s0 = bc->s0;
+    s1 = bc->s1;
+    s2 = bc->s2;
+    s3 = bc->s3;
+
+    R( xl, xr,	0);
+    R( xr, xl,	1);
+    R( xl, xr,	2);
+    R( xr, xl,	3);
+    R( xl, xr,	4);
+    R( xr, xl,	5);
+    R( xl, xr,	6);
+    R( xr, xl,	7);
+    R( xl, xr,	8);
+    R( xr, xl,	9);
+    R( xl, xr, 10);
+    R( xr, xl, 11);
+    R( xl, xr, 12);
+    R( xr, xl, 13);
+    R( xl, xr, 14);
+    R( xr, xl, 15);
+
+    xl ^= p[BLOWFISH_ROUNDS];
+    xr ^= p[BLOWFISH_ROUNDS+1];
+
+    *ret_xl = xr;
+    *ret_xr = xl;
+
+  #else
+    u32 xl, xr, temp, *p;
     int i;
 
     xl = *ret_xl;
     xr = *ret_xr;
+    p = bc->p;
 
     for(i=0; i < BLOWFISH_ROUNDS; i++ ) {
-	xl ^= bc->p[i];
+	xl ^= p[i];
 	xr ^= function_F(bc, xl);
 	temp = xl;
 	xl = xr;
 	xr = temp;
     }
-
     temp = xl;
     xl = xr;
     xr = temp;
 
-    xr ^= bc->p[BLOWFISH_ROUNDS];
-    xl ^= bc->p[BLOWFISH_ROUNDS+1];
+    xr ^= p[BLOWFISH_ROUNDS];
+    xl ^= p[BLOWFISH_ROUNDS+1];
 
     *ret_xl = xl;
     *ret_xr = xr;
+  #endif
 }
 
 
 static void
 decrypt(  BLOWFISH_context *bc, u32 *ret_xl, u32 *ret_xr )
 {
-    u32 xl, xr, temp;
+  #if BLOWFISH_ROUNDS == 16
+    u32 xl, xr, *s0, *s1, *s2, *s3, *p;
+
+    xl = *ret_xl;
+    xr = *ret_xr;
+    p = bc->p;
+    s0 = bc->s0;
+    s1 = bc->s1;
+    s2 = bc->s2;
+    s3 = bc->s3;
+
+    R( xl, xr, 17);
+    R( xr, xl, 16);
+    R( xl, xr, 15);
+    R( xr, xl, 14);
+    R( xl, xr, 13);
+    R( xr, xl, 12);
+    R( xl, xr, 11);
+    R( xr, xl, 10);
+    R( xl, xr,	9);
+    R( xr, xl,	8);
+    R( xl, xr,	7);
+    R( xr, xl,	6);
+    R( xl, xr,	5);
+    R( xr, xl,	4);
+    R( xl, xr,	3);
+    R( xr, xl,	2);
+
+    xl ^= p[1];
+    xr ^= p[0];
+
+    *ret_xl = xr;
+    *ret_xr = xl;
+
+  #else
+    u32 xl, xr, temp, *p;
     int i;
 
     xl = *ret_xl;
     xr = *ret_xr;
+    p = bc->p;
 
     for(i=BLOWFISH_ROUNDS+1; i > 1; i-- ) {
-	xl ^= bc->p[i];
+	xl ^= p[i];
 	xr ^= function_F(bc, xl);
 	temp = xl;
 	xl = xr;
@@ -300,13 +381,17 @@
     xl = xr;
     xr = temp;
 
-    xr ^= bc->p[1];
-    xl ^= bc->p[0];
+    xr ^= p[1];
+    xl ^= p[0];
 
     *ret_xl = xl;
     *ret_xr = xr;
+  #endif
 }
 
+#undef F
+#undef R
+
 static void
 encrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf )
 {
@@ -539,6 +624,7 @@
 					  byte *inbuf, unsigned nbytes)
 {
     unsigned n;
+    int is_aligned;
 
     if( c->count ) {  /* must make a full block first */
 	assert( c->count < BLOWFISH_BLOCKSIZE );
@@ -560,8 +646,26 @@
 	    return;
     }
     assert(!c->count);
+    is_aligned = !((ulong)inbuf % SIZEOF_UNSIGNED_LONG);
     while( nbytes >= BLOWFISH_BLOCKSIZE ) {
-	xorblock( outbuf, c->eniv, inbuf, BLOWFISH_BLOCKSIZE);
+	if( is_aligned ) {
+	  #if SIZEOF_UNSIGNED_LONG == BLOWFISH_BLOCKSIZE
+	    *(ulong*)outbuf = *(ulong*)c->eniv ^ *(ulong*)inbuf;
+	  #elif (2*SIZEOF_UNSIGNED_LONG) == BLOWFISH_BLOCKSIZE
+	    ((ulong*)outbuf)[0] = ((ulong*)c->eniv)[0] ^ ((ulong*)inbuf)[0];
+	    ((ulong*)outbuf)[1] = ((ulong*)c->eniv)[1] ^ ((ulong*)inbuf)[1];
+	  #elif (4*SIZEOF_UNSIGNED_LONG) == BLOWFISH_BLOCKSIZE
+	    ((ulong*)outbuf)[0] = ((ulong*)c->eniv)[0] ^ ((ulong*)inbuf)[0];
+	    ((ulong*)outbuf)[1] = ((ulong*)c->eniv)[1] ^ ((ulong*)inbuf)[1];
+	    ((ulong*)outbuf)[2] = ((ulong*)c->eniv)[2] ^ ((ulong*)inbuf)[2];
+	    ((ulong*)outbuf)[3] = ((ulong*)c->eniv)[3] ^ ((ulong*)inbuf)[3];
+	  #else
+	    #error Please remove this info line.
+	    xorblock( outbuf, c->eniv, inbuf, BLOWFISH_BLOCKSIZE);
+	  #endif
+	}
+	else  /* not aligned */
+	    xorblock( outbuf, c->eniv, inbuf, BLOWFISH_BLOCKSIZE);
 	memcpy( c->iv, outbuf, BLOWFISH_BLOCKSIZE);
 	encrypt_block( c, c->eniv, c->iv );
 	nbytes -= BLOWFISH_BLOCKSIZE;
@@ -583,6 +687,7 @@
 					  byte *inbuf, unsigned nbytes)
 {
     unsigned n;
+    int is_aligned;
 
     if( c->count ) {  /* must make a full block first */
 	assert( c->count < BLOWFISH_BLOCKSIZE );
@@ -605,9 +710,27 @@
     }
 
     assert(!c->count);
+    is_aligned = !((ulong)inbuf % SIZEOF_UNSIGNED_LONG);
     while( nbytes >= BLOWFISH_BLOCKSIZE ) {
 	memcpy( c->iv, inbuf, BLOWFISH_BLOCKSIZE);
-	xorblock( outbuf, c->eniv, inbuf, BLOWFISH_BLOCKSIZE);
+	if( is_aligned ) {
+	  #if SIZEOF_UNSIGNED_LONG == BLOWFISH_BLOCKSIZE
+	    *(ulong*)outbuf = *(ulong*)c->eniv ^ *(ulong*)inbuf;
+	  #elif (2*SIZEOF_UNSIGNED_LONG) == BLOWFISH_BLOCKSIZE
+	    ((ulong*)outbuf)[0] = ((ulong*)c->eniv)[0] ^ ((ulong*)inbuf)[0];
+	    ((ulong*)outbuf)[1] = ((ulong*)c->eniv)[1] ^ ((ulong*)inbuf)[1];
+	  #elif (4*SIZEOF_UNSIGNED_LONG) == BLOWFISH_BLOCKSIZE
+	    ((ulong*)outbuf)[0] = ((ulong*)c->eniv)[0] ^ ((ulong*)inbuf)[0];
+	    ((ulong*)outbuf)[1] = ((ulong*)c->eniv)[1] ^ ((ulong*)inbuf)[1];
+	    ((ulong*)outbuf)[2] = ((ulong*)c->eniv)[2] ^ ((ulong*)inbuf)[2];
+	    ((ulong*)outbuf)[3] = ((ulong*)c->eniv)[3] ^ ((ulong*)inbuf)[3];
+	  #else
+	    #error Please remove this info line.
+	    xorblock( outbuf, c->eniv, inbuf, BLOWFISH_BLOCKSIZE);
+	  #endif
+	}
+	else  /* not aligned */
+	    xorblock( outbuf, c->eniv, inbuf, BLOWFISH_BLOCKSIZE);
 	encrypt_block( c, c->eniv, c->iv );
 	nbytes -= BLOWFISH_BLOCKSIZE;
 	inbuf += BLOWFISH_BLOCKSIZE;
@@ -621,4 +744,5 @@
     }
 
 }
+
 
diff -urN gnupg-0.2.13/cipher/elgamal.c gnupg-0.2.14/cipher/elgamal.c
--- gnupg-0.2.13/cipher/elgamal.c	Tue Mar 10 14:01:48 1998
+++ gnupg-0.2.14/cipher/elgamal.c	Wed Apr  1 16:43:39 1998
@@ -126,6 +126,7 @@
     MPI y;
     MPI temp;
     unsigned qbits;
+    byte *rndbuf;
 
     p_min1 = mpi_alloc( (nbits+BITS_PER_MPI_LIMB-1)/BITS_PER_MPI_LIMB );
     temp   = mpi_alloc( (nbits+BITS_PER_MPI_LIMB-1)/BITS_PER_MPI_LIMB );
@@ -145,22 +146,33 @@
     /* select a random number which has these properties:
      *	 0 < x < p-1
      * This must be a very good random number because this is the
-     * secret part.  The prime is public and may be shared anyware,
-     * so a random generator level of 1 has been used for the prime
+     * secret part.  The prime is public and may be shared anyway,
+     * so a random generator level of 1 is used for the prime.
      */
     x = mpi_alloc_secure( nbits/BITS_PER_MPI_LIMB );
     if( DBG_CIPHER )
 	log_debug("choosing a random x ");
+    rndbuf = NULL;
     do {
-	byte *rndbuf;
 	if( DBG_CIPHER )
 	    fputc('.', stderr);
-	rndbuf = get_random_bits( nbits, 2, 1 );
+	if( rndbuf ) { /* change only some of the higher bits */
+	    if( nbits < 16 ) {/* should never happen ... */
+		m_free(rndbuf);
+		rndbuf = get_random_bits( nbits, 2, 1 );
+	    }
+	    else {
+		char *r = get_random_bits( 16, 2, 1 );
+		memcpy(rndbuf, r, 16 );
+		m_free(r);
+	    }
+	}
+	else
+	    rndbuf = get_random_bits( nbits, 2, 1 );
 	mpi_set_buffer( x, rndbuf, (nbits+7)/8, 0 );
-	m_free(rndbuf);
 	mpi_clear_highbit( x, nbits+1 );
-	log_mpidump("  x: ", x );
     } while( !( mpi_cmp_ui( x, 0 )>0 && mpi_cmp( x, p_min1 )<0 ) );
+    m_free(rndbuf);
 
     y = mpi_alloc(nbits/BITS_PER_MPI_LIMB);
     mpi_powm( y, g, x, p );
diff -urN gnupg-0.2.13/cipher/rmd160.c gnupg-0.2.14/cipher/rmd160.c
--- gnupg-0.2.13/cipher/rmd160.c	Tue Mar 10 16:32:07 1998
+++ gnupg-0.2.14/cipher/rmd160.c	Thu Mar 12 14:51:47 1998
@@ -172,23 +172,6 @@
 transform( RMD160_CONTEXT *hd, byte *data )
 {
 
-#define K0  0x00000000
-#define K1  0x5A827999
-#define K2  0x6ED9EBA1
-#define K3  0x8F1BBCDC
-#define K4  0xA953FD4E
-#define KK0 0x50A28BE6
-#define KK1 0x5C4DD124
-#define KK2 0x6D703EF3
-#define KK3 0x7A6D76E9
-#define KK4 0x00000000
-#define F0(x,y,z)   ( (x) ^ (y) ^ (z) )
-#define F1(x,y,z)   ( ((x) & (y)) | (~(x) & (z)) )
-#define F2(x,y,z)   ( ((x) | ~(y)) ^ (z) )
-#define F3(x,y,z)   ( ((x) & (z)) | ((y) & ~(z)) )
-#define F4(x,y,z)   ( (x) ^ ((y) | ~(z)) )
-/* fixme: we should remove the need for MOVE */
-#define MOVE  t = a; a = e; e = d; d = c; c = b; b = t;
 
     u32 a,b,c,d,e,aa,bb,cc,dd,ee,t;
   #ifdef BIG_ENDIAN_HOST
@@ -206,97 +189,113 @@
     u32 *x = (u32*)data;
   #endif
 
+
+#define K0  0x00000000
+#define K1  0x5A827999
+#define K2  0x6ED9EBA1
+#define K3  0x8F1BBCDC
+#define K4  0xA953FD4E
+#define KK0 0x50A28BE6
+#define KK1 0x5C4DD124
+#define KK2 0x6D703EF3
+#define KK3 0x7A6D76E9
+#define KK4 0x00000000
+#define F0(x,y,z)   ( (x) ^ (y) ^ (z) )
+#define F1(x,y,z)   ( ((x) & (y)) | (~(x) & (z)) )
+#define F2(x,y,z)   ( ((x) | ~(y)) ^ (z) )
+#define F3(x,y,z)   ( ((x) & (z)) | ((y) & ~(z)) )
+#define F4(x,y,z)   ( (x) ^ ((y) | ~(z)) )
+#define R(a,b,c,d,e,f,k,r,s) do { t = a + f(b,c,d) + k + x[r]; \
+				  a = rol(s,t) + e;	       \
+				  c = rol(10,c);	       \
+				} while(0)
+
     /* left lane */
     a = hd->h0;
     b = hd->h1;
     c = hd->h2;
     d = hd->h3;
     e = hd->h4;
-    /* 0 .. 15 */
-    t = a + F0(b,c,d) + x[ 0] + K0; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 1] + K0; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 2] + K0; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 3] + K0; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 4] + K0; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 5] + K0; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 6] + K0; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 7] + K0; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 8] + K0; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 9] + K0; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[10] + K0; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[11] + K0; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[12] + K0; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[13] + K0; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[14] + K0; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[15] + K0; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    /* 16 .. 32 */
-    t = a + F1(b,c,d) + x[ 7] + K1; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 4] + K1; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[13] + K1; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 1] + K1; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[10] + K1; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 6] + K1; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[15] + K1; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 3] + K1; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[12] + K1; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 0] + K1; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 9] + K1; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 5] + K1; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 2] + K1; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[14] + K1; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[11] + K1; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 8] + K1; a=rol(12,t)+e; c=rol(10,c); MOVE
-    /* 33 .. 47 */
-    t = a + F2(b,c,d) + x[ 3] + K2; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[10] + K2; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[14] + K2; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 4] + K2; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 9] + K2; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[15] + K2; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 8] + K2; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 1] + K2; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 2] + K2; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 7] + K2; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 0] + K2; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 6] + K2; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[13] + K2; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[11] + K2; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 5] + K2; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[12] + K2; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    /* 48 .. 63 */
-    t = a + F3(b,c,d) + x[ 1] + K3; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 9] + K3; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[11] + K3; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[10] + K3; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 0] + K3; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 8] + K3; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[12] + K3; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 4] + K3; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[13] + K3; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 3] + K3; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 7] + K3; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[15] + K3; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[14] + K3; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 5] + K3; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 6] + K3; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 2] + K3; a=rol(12,t)+e; c=rol(10,c); MOVE
-    /* 64 .. 79 */
-    t = a + F4(b,c,d) + x[ 4] + K4; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 0] + K4; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 5] + K4; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 9] + K4; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 7] + K4; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[12] + K4; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 2] + K4; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[10] + K4; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[14] + K4; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 1] + K4; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 3] + K4; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 8] + K4; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[11] + K4; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 6] + K4; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[15] + K4; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[13] + K4; a=rol( 6,t)+e; c=rol(10,c); MOVE
+    R( a, b, c, d, e, F0, K0,  0, 11 );
+    R( e, a, b, c, d, F0, K0,  1, 14 );
+    R( d, e, a, b, c, F0, K0,  2, 15 );
+    R( c, d, e, a, b, F0, K0,  3, 12 );
+    R( b, c, d, e, a, F0, K0,  4,  5 );
+    R( a, b, c, d, e, F0, K0,  5,  8 );
+    R( e, a, b, c, d, F0, K0,  6,  7 );
+    R( d, e, a, b, c, F0, K0,  7,  9 );
+    R( c, d, e, a, b, F0, K0,  8, 11 );
+    R( b, c, d, e, a, F0, K0,  9, 13 );
+    R( a, b, c, d, e, F0, K0, 10, 14 );
+    R( e, a, b, c, d, F0, K0, 11, 15 );
+    R( d, e, a, b, c, F0, K0, 12,  6 );
+    R( c, d, e, a, b, F0, K0, 13,  7 );
+    R( b, c, d, e, a, F0, K0, 14,  9 );
+    R( a, b, c, d, e, F0, K0, 15,  8 );
+    R( e, a, b, c, d, F1, K1,  7,  7 );
+    R( d, e, a, b, c, F1, K1,  4,  6 );
+    R( c, d, e, a, b, F1, K1, 13,  8 );
+    R( b, c, d, e, a, F1, K1,  1, 13 );
+    R( a, b, c, d, e, F1, K1, 10, 11 );
+    R( e, a, b, c, d, F1, K1,  6,  9 );
+    R( d, e, a, b, c, F1, K1, 15,  7 );
+    R( c, d, e, a, b, F1, K1,  3, 15 );
+    R( b, c, d, e, a, F1, K1, 12,  7 );
+    R( a, b, c, d, e, F1, K1,  0, 12 );
+    R( e, a, b, c, d, F1, K1,  9, 15 );
+    R( d, e, a, b, c, F1, K1,  5,  9 );
+    R( c, d, e, a, b, F1, K1,  2, 11 );
+    R( b, c, d, e, a, F1, K1, 14,  7 );
+    R( a, b, c, d, e, F1, K1, 11, 13 );
+    R( e, a, b, c, d, F1, K1,  8, 12 );
+    R( d, e, a, b, c, F2, K2,  3, 11 );
+    R( c, d, e, a, b, F2, K2, 10, 13 );
+    R( b, c, d, e, a, F2, K2, 14,  6 );
+    R( a, b, c, d, e, F2, K2,  4,  7 );
+    R( e, a, b, c, d, F2, K2,  9, 14 );
+    R( d, e, a, b, c, F2, K2, 15,  9 );
+    R( c, d, e, a, b, F2, K2,  8, 13 );
+    R( b, c, d, e, a, F2, K2,  1, 15 );
+    R( a, b, c, d, e, F2, K2,  2, 14 );
+    R( e, a, b, c, d, F2, K2,  7,  8 );
+    R( d, e, a, b, c, F2, K2,  0, 13 );
+    R( c, d, e, a, b, F2, K2,  6,  6 );
+    R( b, c, d, e, a, F2, K2, 13,  5 );
+    R( a, b, c, d, e, F2, K2, 11, 12 );
+    R( e, a, b, c, d, F2, K2,  5,  7 );
+    R( d, e, a, b, c, F2, K2, 12,  5 );
+    R( c, d, e, a, b, F3, K3,  1, 11 );
+    R( b, c, d, e, a, F3, K3,  9, 12 );
+    R( a, b, c, d, e, F3, K3, 11, 14 );
+    R( e, a, b, c, d, F3, K3, 10, 15 );
+    R( d, e, a, b, c, F3, K3,  0, 14 );
+    R( c, d, e, a, b, F3, K3,  8, 15 );
+    R( b, c, d, e, a, F3, K3, 12,  9 );
+    R( a, b, c, d, e, F3, K3,  4,  8 );
+    R( e, a, b, c, d, F3, K3, 13,  9 );
+    R( d, e, a, b, c, F3, K3,  3, 14 );
+    R( c, d, e, a, b, F3, K3,  7,  5 );
+    R( b, c, d, e, a, F3, K3, 15,  6 );
+    R( a, b, c, d, e, F3, K3, 14,  8 );
+    R( e, a, b, c, d, F3, K3,  5,  6 );
+    R( d, e, a, b, c, F3, K3,  6,  5 );
+    R( c, d, e, a, b, F3, K3,  2, 12 );
+    R( b, c, d, e, a, F4, K4,  4,  9 );
+    R( a, b, c, d, e, F4, K4,  0, 15 );
+    R( e, a, b, c, d, F4, K4,  5,  5 );
+    R( d, e, a, b, c, F4, K4,  9, 11 );
+    R( c, d, e, a, b, F4, K4,  7,  6 );
+    R( b, c, d, e, a, F4, K4, 12,  8 );
+    R( a, b, c, d, e, F4, K4,  2, 13 );
+    R( e, a, b, c, d, F4, K4, 10, 12 );
+    R( d, e, a, b, c, F4, K4, 14,  5 );
+    R( c, d, e, a, b, F4, K4,  1, 12 );
+    R( b, c, d, e, a, F4, K4,  3, 13 );
+    R( a, b, c, d, e, F4, K4,  8, 14 );
+    R( e, a, b, c, d, F4, K4, 11, 11 );
+    R( d, e, a, b, c, F4, K4,  6,  8 );
+    R( c, d, e, a, b, F4, K4, 15,  5 );
+    R( b, c, d, e, a, F4, K4, 13,  6 );
 
     aa = a; bb = b; cc = c; dd = d; ee = e;
 
@@ -306,91 +305,86 @@
     c = hd->h2;
     d = hd->h3;
     e = hd->h4;
-    /* 0 .. 15 */
-    t = a + F4(b,c,d) + x[ 5] + KK0; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[14] + KK0; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 7] + KK0; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 0] + KK0; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 9] + KK0; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 2] + KK0; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[11] + KK0; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 4] + KK0; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[13] + KK0; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 6] + KK0; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[15] + KK0; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 8] + KK0; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 1] + KK0; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[10] + KK0; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[ 3] + KK0; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F4(b,c,d) + x[12] + KK0; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    /* 16 .. 32 */
-    t = a + F3(b,c,d) + x[ 6] + KK1; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[11] + KK1; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 3] + KK1; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 7] + KK1; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 0] + KK1; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[13] + KK1; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 5] + KK1; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[10] + KK1; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[14] + KK1; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[15] + KK1; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 8] + KK1; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[12] + KK1; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 4] + KK1; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 9] + KK1; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 1] + KK1; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F3(b,c,d) + x[ 2] + KK1; a=rol(11,t)+e; c=rol(10,c); MOVE
-    /* 33 .. 47 */
-    t = a + F2(b,c,d) + x[15] + KK2; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 5] + KK2; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 1] + KK2; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 3] + KK2; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 7] + KK2; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[14] + KK2; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 6] + KK2; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 9] + KK2; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[11] + KK2; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 8] + KK2; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[12] + KK2; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 2] + KK2; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[10] + KK2; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 0] + KK2; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[ 4] + KK2; a=rol( 7,t)+e; c=rol(10,c); MOVE
-    t = a + F2(b,c,d) + x[13] + KK2; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    /* 48 .. 63 */
-    t = a + F1(b,c,d) + x[ 8] + KK3; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 6] + KK3; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 4] + KK3; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 1] + KK3; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 3] + KK3; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[11] + KK3; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[15] + KK3; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 0] + KK3; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 5] + KK3; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[12] + KK3; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 2] + KK3; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[13] + KK3; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 9] + KK3; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[ 7] + KK3; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[10] + KK3; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F1(b,c,d) + x[14] + KK3; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    /* 64 .. 79 */
-    t = a + F0(b,c,d) + x[12] + KK4; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[15] + KK4; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[10] + KK4; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 4] + KK4; a=rol( 9,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 1] + KK4; a=rol(12,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 5] + KK4; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 8] + KK4; a=rol(14,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 7] + KK4; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 6] + KK4; a=rol( 8,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 2] + KK4; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[13] + KK4; a=rol( 6,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[14] + KK4; a=rol( 5,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 0] + KK4; a=rol(15,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 3] + KK4; a=rol(13,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[ 9] + KK4; a=rol(11,t)+e; c=rol(10,c); MOVE
-    t = a + F0(b,c,d) + x[11] + KK4; a=rol(11,t)+e; c=rol(10,c); MOVE
+    R( a, b, c, d, e, F4, KK0,	5,  8);
+    R( e, a, b, c, d, F4, KK0, 14,  9);
+    R( d, e, a, b, c, F4, KK0,	7,  9);
+    R( c, d, e, a, b, F4, KK0,	0, 11);
+    R( b, c, d, e, a, F4, KK0,	9, 13);
+    R( a, b, c, d, e, F4, KK0,	2, 15);
+    R( e, a, b, c, d, F4, KK0, 11, 15);
+    R( d, e, a, b, c, F4, KK0,	4,  5);
+    R( c, d, e, a, b, F4, KK0, 13,  7);
+    R( b, c, d, e, a, F4, KK0,	6,  7);
+    R( a, b, c, d, e, F4, KK0, 15,  8);
+    R( e, a, b, c, d, F4, KK0,	8, 11);
+    R( d, e, a, b, c, F4, KK0,	1, 14);
+    R( c, d, e, a, b, F4, KK0, 10, 14);
+    R( b, c, d, e, a, F4, KK0,	3, 12);
+    R( a, b, c, d, e, F4, KK0, 12,  6);
+    R( e, a, b, c, d, F3, KK1,	6,  9);
+    R( d, e, a, b, c, F3, KK1, 11, 13);
+    R( c, d, e, a, b, F3, KK1,	3, 15);
+    R( b, c, d, e, a, F3, KK1,	7,  7);
+    R( a, b, c, d, e, F3, KK1,	0, 12);
+    R( e, a, b, c, d, F3, KK1, 13,  8);
+    R( d, e, a, b, c, F3, KK1,	5,  9);
+    R( c, d, e, a, b, F3, KK1, 10, 11);
+    R( b, c, d, e, a, F3, KK1, 14,  7);
+    R( a, b, c, d, e, F3, KK1, 15,  7);
+    R( e, a, b, c, d, F3, KK1,	8, 12);
+    R( d, e, a, b, c, F3, KK1, 12,  7);
+    R( c, d, e, a, b, F3, KK1,	4,  6);
+    R( b, c, d, e, a, F3, KK1,	9, 15);
+    R( a, b, c, d, e, F3, KK1,	1, 13);
+    R( e, a, b, c, d, F3, KK1,	2, 11);
+    R( d, e, a, b, c, F2, KK2, 15,  9);
+    R( c, d, e, a, b, F2, KK2,	5,  7);
+    R( b, c, d, e, a, F2, KK2,	1, 15);
+    R( a, b, c, d, e, F2, KK2,	3, 11);
+    R( e, a, b, c, d, F2, KK2,	7,  8);
+    R( d, e, a, b, c, F2, KK2, 14,  6);
+    R( c, d, e, a, b, F2, KK2,	6,  6);
+    R( b, c, d, e, a, F2, KK2,	9, 14);
+    R( a, b, c, d, e, F2, KK2, 11, 12);
+    R( e, a, b, c, d, F2, KK2,	8, 13);
+    R( d, e, a, b, c, F2, KK2, 12,  5);
+    R( c, d, e, a, b, F2, KK2,	2, 14);
+    R( b, c, d, e, a, F2, KK2, 10, 13);
+    R( a, b, c, d, e, F2, KK2,	0, 13);
+    R( e, a, b, c, d, F2, KK2,	4,  7);
+    R( d, e, a, b, c, F2, KK2, 13,  5);
+    R( c, d, e, a, b, F1, KK3,	8, 15);
+    R( b, c, d, e, a, F1, KK3,	6,  5);
+    R( a, b, c, d, e, F1, KK3,	4,  8);
+    R( e, a, b, c, d, F1, KK3,	1, 11);
+    R( d, e, a, b, c, F1, KK3,	3, 14);
+    R( c, d, e, a, b, F1, KK3, 11, 14);
+    R( b, c, d, e, a, F1, KK3, 15,  6);
+    R( a, b, c, d, e, F1, KK3,	0, 14);
+    R( e, a, b, c, d, F1, KK3,	5,  6);
+    R( d, e, a, b, c, F1, KK3, 12,  9);
+    R( c, d, e, a, b, F1, KK3,	2, 12);
+    R( b, c, d, e, a, F1, KK3, 13,  9);
+    R( a, b, c, d, e, F1, KK3,	9, 12);
+    R( e, a, b, c, d, F1, KK3,	7,  5);
+    R( d, e, a, b, c, F1, KK3, 10, 15);
+    R( c, d, e, a, b, F1, KK3, 14,  8);
+    R( b, c, d, e, a, F0, KK4, 12,  8);
+    R( a, b, c, d, e, F0, KK4, 15,  5);
+    R( e, a, b, c, d, F0, KK4, 10, 12);
+    R( d, e, a, b, c, F0, KK4,	4,  9);
+    R( c, d, e, a, b, F0, KK4,	1, 12);
+    R( b, c, d, e, a, F0, KK4,	5,  5);
+    R( a, b, c, d, e, F0, KK4,	8, 14);
+    R( e, a, b, c, d, F0, KK4,	7,  6);
+    R( d, e, a, b, c, F0, KK4,	6,  8);
+    R( c, d, e, a, b, F0, KK4,	2, 13);
+    R( b, c, d, e, a, F0, KK4, 13,  6);
+    R( a, b, c, d, e, F0, KK4, 14,  5);
+    R( e, a, b, c, d, F0, KK4,	0, 15);
+    R( d, e, a, b, c, F0, KK4,	3, 13);
+    R( c, d, e, a, b, F0, KK4,	9, 11);
+    R( b, c, d, e, a, F0, KK4, 11, 11);
 
 
     t	   = hd->h1 + d + cc;
diff -urN gnupg-0.2.13/cipher/sha1.c gnupg-0.2.14/cipher/sha1.c
--- gnupg-0.2.13/cipher/sha1.c	Mon Feb 23 13:12:57 1998
+++ gnupg-0.2.14/cipher/sha1.c	Thu Mar 12 15:40:25 1998
@@ -20,52 +20,6 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
  */
 
-/* I took the code for transform() from the Linux kernel
- * (/usr/src/linux/drivers/char/random.c) which has
- *
- * a) This notice:
- * ---------------
- * SHA transform algorithm, taken from code written by Peter Gutman,
- * and apparently in the public domain.
- *
- * b) This copyright notice:
- * -------------------------
- * Version 1.00, last modified 26-May-96
- *
- * Copyright Theodore Ts'o, 1994, 1995, 1996.  All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, and the entire permission notice in its entirety,
- *    including the disclaimer of warranties.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of the author may not be used to endorse or promote
- *    products derived from this software without specific prior
- *    written permission.
- *
- * ALTERNATIVELY, this product may be distributed under the terms of
- * the GNU Public License, in which case the provisions of the GPL are
- * required INSTEAD OF the above restrictions.	(This clause is
- * necessary due to a potential bad interaction between the GPL and
- * the restrictions contained in a BSD-style copyright.)
- *
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
- * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
- * DISCLAIMED.	IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
- * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
- * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
- * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
- * OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
 
 /*  Test vectors:
  *
@@ -87,17 +41,6 @@
 #include "sha1.h"
 
 
-/* The SHA f()-functions.  */
-#define f1(x,y,z)   ( z ^ ( x & ( y ^ z ) ) )		/* Rounds  0-19 */
-#define f2(x,y,z)   ( x ^ y ^ z )			/* Rounds 20-39 */
-#define f3(x,y,z)   ( ( x & y ) | ( z & ( x | y ) ) )	/* Rounds 40-59 */
-#define f4(x,y,z)   ( x ^ y ^ z )			/* Rounds 60-79 */
-
-/* The SHA Mysterious Constants */
-#define K1  0x5A827999L 				/* Rounds  0-19 */
-#define K2  0x6ED9EBA1L 				/* Rounds 20-39 */
-#define K3  0x8F1BBCDCL 				/* Rounds 40-59 */
-#define K4  0xCA62C1D6L 				/* Rounds 60-79 */
 
 
 #if defined(__GNUC__) && defined(__i386__)
@@ -116,15 +59,6 @@
 
 
 
-
-#define expand(W,i) ( W[ i & 15 ] = \
-		     rol( 1, ( W[ i & 15 ] ^ W[ (i - 14) & 15 ] ^ \
-				W[ (i - 8) & 15 ] ^ W[ (i - 3) & 15 ] ) ) )
-
-#define subRound(a, b, c, d, e, f, k, data) \
-    ( e += rol( 5, a ) + f( b, c, d ) + k + data, b = rol( 30, b ) )
-
-
 void
 sha1_init( SHA1_CONTEXT *hd )
 {
@@ -144,22 +78,22 @@
 static void
 transform( SHA1_CONTEXT *hd, byte *data )
 {
-    u32 A, B, C, D, E;	   /* Local vars */
-    u32 eData[ 16 ];	   /* Expanded data */
+    u32 a,b,c,d,e,tm;
+    u32 x[16];
 
-    /* Set up first buffer and local data buffer */
-    A = hd->h0;
-    B = hd->h1;
-    C = hd->h2;
-    D = hd->h3;
-    E = hd->h4;
+    /* get values from the chaining vars */
+    a = hd->h0;
+    b = hd->h1;
+    c = hd->h2;
+    d = hd->h3;
+    e = hd->h4;
 
   #ifdef BIG_ENDIAN_HOST
-    memcpy( eData, data, 64 );
+    memcpy( x, data, 64 );
   #else
     { int i;
       byte *p2;
-      for(i=0, p2=(byte*)eData; i < 16; i++, p2 += 4 ) {
+      for(i=0, p2=(byte*)x; i < 16; i++, p2 += 4 ) {
 	p2[3] = *data++;
 	p2[2] = *data++;
 	p2[1] = *data++;
@@ -168,97 +102,114 @@
     }
   #endif
 
-    /* Heavy mangling, in 4 sub-rounds of 20 iterations each. */
-    subRound( A, B, C, D, E, f1, K1, eData[  0 ] );
-    subRound( E, A, B, C, D, f1, K1, eData[  1 ] );
-    subRound( D, E, A, B, C, f1, K1, eData[  2 ] );
-    subRound( C, D, E, A, B, f1, K1, eData[  3 ] );
-    subRound( B, C, D, E, A, f1, K1, eData[  4 ] );
-    subRound( A, B, C, D, E, f1, K1, eData[  5 ] );
-    subRound( E, A, B, C, D, f1, K1, eData[  6 ] );
-    subRound( D, E, A, B, C, f1, K1, eData[  7 ] );
-    subRound( C, D, E, A, B, f1, K1, eData[  8 ] );
-    subRound( B, C, D, E, A, f1, K1, eData[  9 ] );
-    subRound( A, B, C, D, E, f1, K1, eData[ 10 ] );
-    subRound( E, A, B, C, D, f1, K1, eData[ 11 ] );
-    subRound( D, E, A, B, C, f1, K1, eData[ 12 ] );
-    subRound( C, D, E, A, B, f1, K1, eData[ 13 ] );
-    subRound( B, C, D, E, A, f1, K1, eData[ 14 ] );
-    subRound( A, B, C, D, E, f1, K1, eData[ 15 ] );
-    subRound( E, A, B, C, D, f1, K1, expand( eData, 16 ) );
-    subRound( D, E, A, B, C, f1, K1, expand( eData, 17 ) );
-    subRound( C, D, E, A, B, f1, K1, expand( eData, 18 ) );
-    subRound( B, C, D, E, A, f1, K1, expand( eData, 19 ) );
-
-    subRound( A, B, C, D, E, f2, K2, expand( eData, 20 ) );
-    subRound( E, A, B, C, D, f2, K2, expand( eData, 21 ) );
-    subRound( D, E, A, B, C, f2, K2, expand( eData, 22 ) );
-    subRound( C, D, E, A, B, f2, K2, expand( eData, 23 ) );
-    subRound( B, C, D, E, A, f2, K2, expand( eData, 24 ) );
-    subRound( A, B, C, D, E, f2, K2, expand( eData, 25 ) );
-    subRound( E, A, B, C, D, f2, K2, expand( eData, 26 ) );
-    subRound( D, E, A, B, C, f2, K2, expand( eData, 27 ) );
-    subRound( C, D, E, A, B, f2, K2, expand( eData, 28 ) );
-    subRound( B, C, D, E, A, f2, K2, expand( eData, 29 ) );
-    subRound( A, B, C, D, E, f2, K2, expand( eData, 30 ) );
-    subRound( E, A, B, C, D, f2, K2, expand( eData, 31 ) );
-    subRound( D, E, A, B, C, f2, K2, expand( eData, 32 ) );
-    subRound( C, D, E, A, B, f2, K2, expand( eData, 33 ) );
-    subRound( B, C, D, E, A, f2, K2, expand( eData, 34 ) );
-    subRound( A, B, C, D, E, f2, K2, expand( eData, 35 ) );
-    subRound( E, A, B, C, D, f2, K2, expand( eData, 36 ) );
-    subRound( D, E, A, B, C, f2, K2, expand( eData, 37 ) );
-    subRound( C, D, E, A, B, f2, K2, expand( eData, 38 ) );
-    subRound( B, C, D, E, A, f2, K2, expand( eData, 39 ) );
-
-    subRound( A, B, C, D, E, f3, K3, expand( eData, 40 ) );
-    subRound( E, A, B, C, D, f3, K3, expand( eData, 41 ) );
-    subRound( D, E, A, B, C, f3, K3, expand( eData, 42 ) );
-    subRound( C, D, E, A, B, f3, K3, expand( eData, 43 ) );
-    subRound( B, C, D, E, A, f3, K3, expand( eData, 44 ) );
-    subRound( A, B, C, D, E, f3, K3, expand( eData, 45 ) );
-    subRound( E, A, B, C, D, f3, K3, expand( eData, 46 ) );
-    subRound( D, E, A, B, C, f3, K3, expand( eData, 47 ) );
-    subRound( C, D, E, A, B, f3, K3, expand( eData, 48 ) );
-    subRound( B, C, D, E, A, f3, K3, expand( eData, 49 ) );
-    subRound( A, B, C, D, E, f3, K3, expand( eData, 50 ) );
-    subRound( E, A, B, C, D, f3, K3, expand( eData, 51 ) );
-    subRound( D, E, A, B, C, f3, K3, expand( eData, 52 ) );
-    subRound( C, D, E, A, B, f3, K3, expand( eData, 53 ) );
-    subRound( B, C, D, E, A, f3, K3, expand( eData, 54 ) );
-    subRound( A, B, C, D, E, f3, K3, expand( eData, 55 ) );
-    subRound( E, A, B, C, D, f3, K3, expand( eData, 56 ) );
-    subRound( D, E, A, B, C, f3, K3, expand( eData, 57 ) );
-    subRound( C, D, E, A, B, f3, K3, expand( eData, 58 ) );
-    subRound( B, C, D, E, A, f3, K3, expand( eData, 59 ) );
-
-    subRound( A, B, C, D, E, f4, K4, expand( eData, 60 ) );
-    subRound( E, A, B, C, D, f4, K4, expand( eData, 61 ) );
-    subRound( D, E, A, B, C, f4, K4, expand( eData, 62 ) );
-    subRound( C, D, E, A, B, f4, K4, expand( eData, 63 ) );
-    subRound( B, C, D, E, A, f4, K4, expand( eData, 64 ) );
-    subRound( A, B, C, D, E, f4, K4, expand( eData, 65 ) );
-    subRound( E, A, B, C, D, f4, K4, expand( eData, 66 ) );
-    subRound( D, E, A, B, C, f4, K4, expand( eData, 67 ) );
-    subRound( C, D, E, A, B, f4, K4, expand( eData, 68 ) );
-    subRound( B, C, D, E, A, f4, K4, expand( eData, 69 ) );
-    subRound( A, B, C, D, E, f4, K4, expand( eData, 70 ) );
-    subRound( E, A, B, C, D, f4, K4, expand( eData, 71 ) );
-    subRound( D, E, A, B, C, f4, K4, expand( eData, 72 ) );
-    subRound( C, D, E, A, B, f4, K4, expand( eData, 73 ) );
-    subRound( B, C, D, E, A, f4, K4, expand( eData, 74 ) );
-    subRound( A, B, C, D, E, f4, K4, expand( eData, 75 ) );
-    subRound( E, A, B, C, D, f4, K4, expand( eData, 76 ) );
-    subRound( D, E, A, B, C, f4, K4, expand( eData, 77 ) );
-    subRound( C, D, E, A, B, f4, K4, expand( eData, 78 ) );
-    subRound( B, C, D, E, A, f4, K4, expand( eData, 79 ) );
-
-    /* Build message digest */
-    hd->h0 += A;
-    hd->h1 += B;
-    hd->h2 += C;
-    hd->h3 += D;
-    hd->h4 += E;
+
+#define K1  0x5A827999L
+#define K2  0x6ED9EBA1L
+#define K3  0x8F1BBCDCL
+#define K4  0xCA62C1D6L
+#define F1(x,y,z)   ( z ^ ( x & ( y ^ z ) ) )
+#define F2(x,y,z)   ( x ^ y ^ z )
+#define F3(x,y,z)   ( ( x & y ) | ( z & ( x | y ) ) )
+#define F4(x,y,z)   ( x ^ y ^ z )
+
+
+#define M(i) ( tm =   x[i&0x0f] ^ x[(i-14)&0x0f] \
+		    ^ x[(i-8)&0x0f] ^ x[(i-3)&0x0f] \
+	       , (x[i&0x0f] = (tm << 1) | (tm >> 31)) )
+
+#define R(a,b,c,d,e,f,k,m)  do { e += rol( 5, a )     \
+				      + f( b, c, d )  \
+				      + k	      \
+				      + m;	      \
+				 b = rol( 30, b );    \
+			       } while(0)
+    R( a, b, c, d, e, F1, K1, x[ 0] );
+    R( e, a, b, c, d, F1, K1, x[ 1] );
+    R( d, e, a, b, c, F1, K1, x[ 2] );
+    R( c, d, e, a, b, F1, K1, x[ 3] );
+    R( b, c, d, e, a, F1, K1, x[ 4] );
+    R( a, b, c, d, e, F1, K1, x[ 5] );
+    R( e, a, b, c, d, F1, K1, x[ 6] );
+    R( d, e, a, b, c, F1, K1, x[ 7] );
+    R( c, d, e, a, b, F1, K1, x[ 8] );
+    R( b, c, d, e, a, F1, K1, x[ 9] );
+    R( a, b, c, d, e, F1, K1, x[10] );
+    R( e, a, b, c, d, F1, K1, x[11] );
+    R( d, e, a, b, c, F1, K1, x[12] );
+    R( c, d, e, a, b, F1, K1, x[13] );
+    R( b, c, d, e, a, F1, K1, x[14] );
+    R( a, b, c, d, e, F1, K1, x[15] );
+    R( e, a, b, c, d, F1, K1, M(16) );
+    R( d, e, a, b, c, F1, K1, M(17) );
+    R( c, d, e, a, b, F1, K1, M(18) );
+    R( b, c, d, e, a, F1, K1, M(19) );
+    R( a, b, c, d, e, F2, K2, M(20) );
+    R( e, a, b, c, d, F2, K2, M(21) );
+    R( d, e, a, b, c, F2, K2, M(22) );
+    R( c, d, e, a, b, F2, K2, M(23) );
+    R( b, c, d, e, a, F2, K2, M(24) );
+    R( a, b, c, d, e, F2, K2, M(25) );
+    R( e, a, b, c, d, F2, K2, M(26) );
+    R( d, e, a, b, c, F2, K2, M(27) );
+    R( c, d, e, a, b, F2, K2, M(28) );
+    R( b, c, d, e, a, F2, K2, M(29) );
+    R( a, b, c, d, e, F2, K2, M(30) );
+    R( e, a, b, c, d, F2, K2, M(31) );
+    R( d, e, a, b, c, F2, K2, M(32) );
+    R( c, d, e, a, b, F2, K2, M(33) );
+    R( b, c, d, e, a, F2, K2, M(34) );
+    R( a, b, c, d, e, F2, K2, M(35) );
+    R( e, a, b, c, d, F2, K2, M(36) );
+    R( d, e, a, b, c, F2, K2, M(37) );
+    R( c, d, e, a, b, F2, K2, M(38) );
+    R( b, c, d, e, a, F2, K2, M(39) );
+    R( a, b, c, d, e, F3, K3, M(40) );
+    R( e, a, b, c, d, F3, K3, M(41) );
+    R( d, e, a, b, c, F3, K3, M(42) );
+    R( c, d, e, a, b, F3, K3, M(43) );
+    R( b, c, d, e, a, F3, K3, M(44) );
+    R( a, b, c, d, e, F3, K3, M(45) );
+    R( e, a, b, c, d, F3, K3, M(46) );
+    R( d, e, a, b, c, F3, K3, M(47) );
+    R( c, d, e, a, b, F3, K3, M(48) );
+    R( b, c, d, e, a, F3, K3, M(49) );
+    R( a, b, c, d, e, F3, K3, M(50) );
+    R( e, a, b, c, d, F3, K3, M(51) );
+    R( d, e, a, b, c, F3, K3, M(52) );
+    R( c, d, e, a, b, F3, K3, M(53) );
+    R( b, c, d, e, a, F3, K3, M(54) );
+    R( a, b, c, d, e, F3, K3, M(55) );
+    R( e, a, b, c, d, F3, K3, M(56) );
+    R( d, e, a, b, c, F3, K3, M(57) );
+    R( c, d, e, a, b, F3, K3, M(58) );
+    R( b, c, d, e, a, F3, K3, M(59) );
+    R( a, b, c, d, e, F4, K4, M(60) );
+    R( e, a, b, c, d, F4, K4, M(61) );
+    R( d, e, a, b, c, F4, K4, M(62) );
+    R( c, d, e, a, b, F4, K4, M(63) );
+    R( b, c, d, e, a, F4, K4, M(64) );
+    R( a, b, c, d, e, F4, K4, M(65) );
+    R( e, a, b, c, d, F4, K4, M(66) );
+    R( d, e, a, b, c, F4, K4, M(67) );
+    R( c, d, e, a, b, F4, K4, M(68) );
+    R( b, c, d, e, a, F4, K4, M(69) );
+    R( a, b, c, d, e, F4, K4, M(70) );
+    R( e, a, b, c, d, F4, K4, M(71) );
+    R( d, e, a, b, c, F4, K4, M(72) );
+    R( c, d, e, a, b, F4, K4, M(73) );
+    R( b, c, d, e, a, F4, K4, M(74) );
+    R( a, b, c, d, e, F4, K4, M(75) );
+    R( e, a, b, c, d, F4, K4, M(76) );
+    R( d, e, a, b, c, F4, K4, M(77) );
+    R( c, d, e, a, b, F4, K4, M(78) );
+    R( b, c, d, e, a, F4, K4, M(79) );
+
+    /* update chainig vars */
+    hd->h0 += a;
+    hd->h1 += b;
+    hd->h2 += c;
+    hd->h3 += d;
+    hd->h4 += e;
 }
 
 
diff -urN gnupg-0.2.13/configure gnupg-0.2.14/configure
--- gnupg-0.2.13/configure	Tue Mar 10 18:46:55 1998
+++ gnupg-0.2.14/configure	Thu Apr  2 12:05:14 1998
@@ -567,7 +567,7 @@
 
 VERSION=`cat $srcdir/VERSION`
 PACKAGE=gnupg
-ALL_LINGUAS="de"
+ALL_LINGUAS="de it"
 
 
 cat >> confdefs.h <<EOF
@@ -1519,21 +1519,15 @@
 done
 
 
-G10_LOCALEDIR="$g10_prefix/$DATADIRNAME/locale"
-
-cat >> confdefs.h <<EOF
-#define G10_LOCALEDIR "$G10_LOCALEDIR"
-EOF
-
 
 
 echo $ac_n "checking for working const""... $ac_c" 1>&6
-echo "configure:1532: checking for working const" >&5
+echo "configure:1526: checking for working const" >&5
 if eval "test \"`echo '$''{'ac_cv_c_const'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1537 "configure"
+#line 1531 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -1582,7 +1576,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:1586: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1580: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_const=yes
 else
@@ -1603,21 +1597,21 @@
 fi
 
 echo $ac_n "checking for inline""... $ac_c" 1>&6
-echo "configure:1607: checking for inline" >&5
+echo "configure:1601: checking for inline" >&5
 if eval "test \"`echo '$''{'ac_cv_c_inline'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   ac_cv_c_inline=no
 for ac_kw in inline __inline__ __inline; do
   cat > conftest.$ac_ext <<EOF
-#line 1614 "configure"
+#line 1608 "configure"
 #include "confdefs.h"
 
 int main() {
 } $ac_kw foo() {
 ; return 0; }
 EOF
-if { (eval echo configure:1621: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1615: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_inline=$ac_kw; break
 else
@@ -1643,12 +1637,12 @@
 esac
 
 echo $ac_n "checking for size_t""... $ac_c" 1>&6
-echo "configure:1647: checking for size_t" >&5
+echo "configure:1641: checking for size_t" >&5
 if eval "test \"`echo '$''{'ac_cv_type_size_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1652 "configure"
+#line 1646 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -1676,12 +1670,12 @@
 fi
 
 echo $ac_n "checking return type of signal handlers""... $ac_c" 1>&6
-echo "configure:1680: checking return type of signal handlers" >&5
+echo "configure:1674: checking return type of signal handlers" >&5
 if eval "test \"`echo '$''{'ac_cv_type_signal'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1685 "configure"
+#line 1679 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #include <signal.h>
@@ -1698,7 +1692,7 @@
 int i;
 ; return 0; }
 EOF
-if { (eval echo configure:1702: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1696: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_type_signal=void
 else
@@ -1717,12 +1711,12 @@
 
 
 echo $ac_n "checking for sys_siglist declaration in signal.h or unistd.h""... $ac_c" 1>&6
-echo "configure:1721: checking for sys_siglist declaration in signal.h or unistd.h" >&5
+echo "configure:1715: checking for sys_siglist declaration in signal.h or unistd.h" >&5
 if eval "test \"`echo '$''{'ac_cv_decl_sys_siglist'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1726 "configure"
+#line 1720 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #include <signal.h>
@@ -1734,7 +1728,7 @@
 char *msg = *(sys_siglist + 1);
 ; return 0; }
 EOF
-if { (eval echo configure:1738: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1732: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_decl_sys_siglist=yes
 else
@@ -1759,14 +1753,14 @@
         echo "configure: warning: cross compiling; assuming little endianess" 1>&2
     fi
     echo $ac_n "checking endianess""... $ac_c" 1>&6
-echo "configure:1763: checking endianess" >&5
+echo "configure:1757: checking endianess" >&5
     if eval "test \"`echo '$''{'wk_cv_c_endian'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
    wk_cv_c_endian=unknown
         # See if sys/param.h defines the BYTE_ORDER macro.
         cat > conftest.$ac_ext <<EOF
-#line 1770 "configure"
+#line 1764 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
         #include <sys/param.h>
@@ -1777,11 +1771,11 @@
         #endif
 ; return 0; }
 EOF
-if { (eval echo configure:1781: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1775: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   # It does; now see whether it defined to BIG_ENDIAN or not.
         cat > conftest.$ac_ext <<EOF
-#line 1785 "configure"
+#line 1779 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
         #include <sys/param.h>
@@ -1792,7 +1786,7 @@
         #endif
 ; return 0; }
 EOF
-if { (eval echo configure:1796: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1790: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_c_endian=big
 else
@@ -1813,7 +1807,7 @@
             
 else
   cat > conftest.$ac_ext <<EOF
-#line 1817 "configure"
+#line 1811 "configure"
 #include "confdefs.h"
 main () {
               /* Are we little or big endian?  From Harbison&Steele.  */
@@ -1826,7 +1820,7 @@
               exit (u.c[sizeof (long) - 1] == 1);
               }
 EOF
-if { (eval echo configure:1830: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1824: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   wk_cv_c_endian=little
 else
@@ -1858,12 +1852,12 @@
 
 
  echo $ac_n "checking for byte typedef""... $ac_c" 1>&6
-echo "configure:1862: checking for byte typedef" >&5
+echo "configure:1856: checking for byte typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_byte'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1867 "configure"
+#line 1861 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1874,7 +1868,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1878: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1872: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_byte=yes
 else
@@ -1895,12 +1889,12 @@
     fi
   
  echo $ac_n "checking for ushort typedef""... $ac_c" 1>&6
-echo "configure:1899: checking for ushort typedef" >&5
+echo "configure:1893: checking for ushort typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_ushort'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1904 "configure"
+#line 1898 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1911,7 +1905,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1915: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1909: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_ushort=yes
 else
@@ -1932,12 +1926,12 @@
     fi
   
  echo $ac_n "checking for ulong typedef""... $ac_c" 1>&6
-echo "configure:1936: checking for ulong typedef" >&5
+echo "configure:1930: checking for ulong typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_ulong'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1941 "configure"
+#line 1935 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1948,7 +1942,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1952: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1946: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_ulong=yes
 else
@@ -1969,12 +1963,12 @@
     fi
   
  echo $ac_n "checking for u16 typedef""... $ac_c" 1>&6
-echo "configure:1973: checking for u16 typedef" >&5
+echo "configure:1967: checking for u16 typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_u16'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1978 "configure"
+#line 1972 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1985,7 +1979,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1989: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1983: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_u16=yes
 else
@@ -2006,12 +2000,12 @@
     fi
   
  echo $ac_n "checking for u32 typedef""... $ac_c" 1>&6
-echo "configure:2010: checking for u32 typedef" >&5
+echo "configure:2004: checking for u32 typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_u32'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2015 "configure"
+#line 2009 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -2022,7 +2016,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:2026: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:2020: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_u32=yes
 else
@@ -2044,7 +2038,7 @@
   
 
 echo $ac_n "checking size of unsigned short""... $ac_c" 1>&6
-echo "configure:2048: checking size of unsigned short" >&5
+echo "configure:2042: checking size of unsigned short" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_short'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2052,7 +2046,7 @@
   ac_cv_sizeof_unsigned_short=2
 else
   cat > conftest.$ac_ext <<EOF
-#line 2056 "configure"
+#line 2050 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -2063,7 +2057,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:2067: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2061: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_short=`cat conftestval`
 else
@@ -2083,7 +2077,7 @@
 
 
 echo $ac_n "checking size of unsigned int""... $ac_c" 1>&6
-echo "configure:2087: checking size of unsigned int" >&5
+echo "configure:2081: checking size of unsigned int" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_int'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2091,7 +2085,7 @@
   ac_cv_sizeof_unsigned_int=4
 else
   cat > conftest.$ac_ext <<EOF
-#line 2095 "configure"
+#line 2089 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -2102,7 +2096,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:2106: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2100: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_int=`cat conftestval`
 else
@@ -2122,7 +2116,7 @@
 
 
 echo $ac_n "checking size of unsigned long""... $ac_c" 1>&6
-echo "configure:2126: checking size of unsigned long" >&5
+echo "configure:2120: checking size of unsigned long" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2130,7 +2124,7 @@
   ac_cv_sizeof_unsigned_long=4
 else
   cat > conftest.$ac_ext <<EOF
-#line 2134 "configure"
+#line 2128 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -2141,7 +2135,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:2145: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2139: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_long=`cat conftestval`
 else
@@ -2170,12 +2164,12 @@
 
 
 echo $ac_n "checking for vprintf""... $ac_c" 1>&6
-echo "configure:2174: checking for vprintf" >&5
+echo "configure:2168: checking for vprintf" >&5
 if eval "test \"`echo '$''{'ac_cv_func_vprintf'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2179 "configure"
+#line 2173 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char vprintf(); below.  */
@@ -2198,7 +2192,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2202: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2196: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_vprintf=yes"
 else
@@ -2222,12 +2216,12 @@
 
 if test "$ac_cv_func_vprintf" != yes; then
 echo $ac_n "checking for _doprnt""... $ac_c" 1>&6
-echo "configure:2226: checking for _doprnt" >&5
+echo "configure:2220: checking for _doprnt" >&5
 if eval "test \"`echo '$''{'ac_cv_func__doprnt'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2231 "configure"
+#line 2225 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char _doprnt(); below.  */
@@ -2250,7 +2244,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2254: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2248: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func__doprnt=yes"
 else
@@ -2277,12 +2271,12 @@
 for ac_func in strerror stpcpy strlwr tcgetattr rand strtoul mlock mmap
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2281: checking for $ac_func" >&5
+echo "configure:2275: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2286 "configure"
+#line 2280 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2305,7 +2299,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2309: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2303: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2332,12 +2326,12 @@
 for ac_func in gettimeofday getrusage
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2336: checking for $ac_func" >&5
+echo "configure:2330: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2341 "configure"
+#line 2335 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2360,7 +2354,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2364: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2358: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2389,7 +2383,7 @@
 
 
 echo $ac_n "checking for random device""... $ac_c" 1>&6
-echo "configure:2393: checking for random device" >&5
+echo "configure:2387: checking for random device" >&5
 if eval "test \"`echo '$''{'ac_cv_have_dev_random'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2407,7 +2401,7 @@
 
 
 echo $ac_n "checking for mpi assembler functions""... $ac_c" 1>&6
-echo "configure:2411: checking for mpi assembler functions" >&5
+echo "configure:2405: checking for mpi assembler functions" >&5
 if test -f $srcdir/mpi/config.links ; then
     . $srcdir/mpi/config.links
      if test "x$wk_link_files_src" = "x"; then
@@ -2470,17 +2464,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2474: checking for $ac_hdr" >&5
+echo "configure:2468: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2479 "configure"
+#line 2473 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2484: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:2478: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2553,7 +2547,7 @@
 CIPHER_EXTRA_OBJS=""
 CIPHER_EXTRA_DIST=""
 echo $ac_n "checking for extra cipher modules""... $ac_c" 1>&6
-echo "configure:2557: checking for extra cipher modules" >&5
+echo "configure:2551: checking for extra cipher modules" >&5
 if eval "test \"`echo '$''{'ac_cv_have_rsa_cipher'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2574,12 +2568,12 @@
 
 
 echo $ac_n "checking for off_t""... $ac_c" 1>&6
-echo "configure:2578: checking for off_t" >&5
+echo "configure:2572: checking for off_t" >&5
 if eval "test \"`echo '$''{'ac_cv_type_off_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2583 "configure"
+#line 2577 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -2609,19 +2603,19 @@
 # The Ultrix 4.2 mips builtin alloca declared by alloca.h only works
 # for constant arguments.  Useless!
 echo $ac_n "checking for working alloca.h""... $ac_c" 1>&6
-echo "configure:2613: checking for working alloca.h" >&5
+echo "configure:2607: checking for working alloca.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_alloca_h'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2618 "configure"
+#line 2612 "configure"
 #include "confdefs.h"
 #include <alloca.h>
 int main() {
 char *p = alloca(2 * sizeof(int));
 ; return 0; }
 EOF
-if { (eval echo configure:2625: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2619: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   ac_cv_header_alloca_h=yes
 else
@@ -2642,12 +2636,12 @@
 fi
 
 echo $ac_n "checking for alloca""... $ac_c" 1>&6
-echo "configure:2646: checking for alloca" >&5
+echo "configure:2640: checking for alloca" >&5
 if eval "test \"`echo '$''{'ac_cv_func_alloca_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2651 "configure"
+#line 2645 "configure"
 #include "confdefs.h"
 
 #ifdef __GNUC__
@@ -2670,7 +2664,7 @@
 char *p = (char *) alloca(1);
 ; return 0; }
 EOF
-if { (eval echo configure:2674: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2668: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   ac_cv_func_alloca_works=yes
 else
@@ -2702,12 +2696,12 @@
 
 
 echo $ac_n "checking whether alloca needs Cray hooks""... $ac_c" 1>&6
-echo "configure:2706: checking whether alloca needs Cray hooks" >&5
+echo "configure:2700: checking whether alloca needs Cray hooks" >&5
 if eval "test \"`echo '$''{'ac_cv_os_cray'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2711 "configure"
+#line 2705 "configure"
 #include "confdefs.h"
 #if defined(CRAY) && ! defined(CRAY2)
 webecray
@@ -2732,12 +2726,12 @@
 if test $ac_cv_os_cray = yes; then
 for ac_func in _getb67 GETB67 getb67; do
   echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2736: checking for $ac_func" >&5
+echo "configure:2730: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2741 "configure"
+#line 2735 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2760,7 +2754,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2764: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2758: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2787,7 +2781,7 @@
 fi
 
 echo $ac_n "checking stack direction for C alloca""... $ac_c" 1>&6
-echo "configure:2791: checking stack direction for C alloca" >&5
+echo "configure:2785: checking stack direction for C alloca" >&5
 if eval "test \"`echo '$''{'ac_cv_c_stack_direction'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2795,7 +2789,7 @@
   ac_cv_c_stack_direction=0
 else
   cat > conftest.$ac_ext <<EOF
-#line 2799 "configure"
+#line 2793 "configure"
 #include "confdefs.h"
 find_stack_direction ()
 {
@@ -2814,7 +2808,7 @@
   exit (find_stack_direction() < 0);
 }
 EOF
-if { (eval echo configure:2818: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2812: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_c_stack_direction=1
 else
@@ -2839,17 +2833,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2843: checking for $ac_hdr" >&5
+echo "configure:2837: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2848 "configure"
+#line 2842 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2853: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:2847: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2878,12 +2872,12 @@
 for ac_func in getpagesize
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2882: checking for $ac_func" >&5
+echo "configure:2876: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2887 "configure"
+#line 2881 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2906,7 +2900,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2910: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2904: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2931,7 +2925,7 @@
 done
 
 echo $ac_n "checking for working mmap""... $ac_c" 1>&6
-echo "configure:2935: checking for working mmap" >&5
+echo "configure:2929: checking for working mmap" >&5
 if eval "test \"`echo '$''{'ac_cv_func_mmap_fixed_mapped'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2939,7 +2933,7 @@
   ac_cv_func_mmap_fixed_mapped=no
 else
   cat > conftest.$ac_ext <<EOF
-#line 2943 "configure"
+#line 2937 "configure"
 #include "confdefs.h"
 
 /* Thanks to Mike Haertel and Jim Avera for this test.
@@ -3079,7 +3073,7 @@
 }
 
 EOF
-if { (eval echo configure:3083: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:3077: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_func_mmap_fixed_mapped=yes
 else
@@ -3107,17 +3101,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:3111: checking for $ac_hdr" >&5
+echo "configure:3105: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3116 "configure"
+#line 3110 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3121: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3115: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3147,12 +3141,12 @@
 __argz_count __argz_stringify __argz_next
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3151: checking for $ac_func" >&5
+echo "configure:3145: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3156 "configure"
+#line 3150 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3175,7 +3169,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3179: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3173: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3204,12 +3198,12 @@
      for ac_func in stpcpy
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3208: checking for $ac_func" >&5
+echo "configure:3202: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3213 "configure"
+#line 3207 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3232,7 +3226,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3236: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3230: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3266,19 +3260,19 @@
 
    if test $ac_cv_header_locale_h = yes; then
     echo $ac_n "checking for LC_MESSAGES""... $ac_c" 1>&6
-echo "configure:3270: checking for LC_MESSAGES" >&5
+echo "configure:3264: checking for LC_MESSAGES" >&5
 if eval "test \"`echo '$''{'am_cv_val_LC_MESSAGES'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3275 "configure"
+#line 3269 "configure"
 #include "confdefs.h"
 #include <locale.h>
 int main() {
 return LC_MESSAGES
 ; return 0; }
 EOF
-if { (eval echo configure:3282: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3276: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   am_cv_val_LC_MESSAGES=yes
 else
@@ -3299,7 +3293,7 @@
     fi
   fi
    echo $ac_n "checking whether NLS is requested""... $ac_c" 1>&6
-echo "configure:3303: checking whether NLS is requested" >&5
+echo "configure:3297: checking whether NLS is requested" >&5
         # Check whether --enable-nls or --disable-nls was given.
 if test "${enable_nls+set}" = set; then
   enableval="$enable_nls"
@@ -3319,7 +3313,7 @@
 EOF
 
       echo $ac_n "checking whether included gettext is requested""... $ac_c" 1>&6
-echo "configure:3323: checking whether included gettext is requested" >&5
+echo "configure:3317: checking whether included gettext is requested" >&5
       # Check whether --with-included-gettext or --without-included-gettext was given.
 if test "${with_included_gettext+set}" = set; then
   withval="$with_included_gettext"
@@ -3338,17 +3332,17 @@
 
         ac_safe=`echo "libintl.h" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for libintl.h""... $ac_c" 1>&6
-echo "configure:3342: checking for libintl.h" >&5
+echo "configure:3336: checking for libintl.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3347 "configure"
+#line 3341 "configure"
 #include "confdefs.h"
 #include <libintl.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3352: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3346: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3365,19 +3359,19 @@
 if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
   echo "$ac_t""yes" 1>&6
   echo $ac_n "checking for gettext in libc""... $ac_c" 1>&6
-echo "configure:3369: checking for gettext in libc" >&5
+echo "configure:3363: checking for gettext in libc" >&5
 if eval "test \"`echo '$''{'gt_cv_func_gettext_libc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3374 "configure"
+#line 3368 "configure"
 #include "confdefs.h"
 #include <libintl.h>
 int main() {
 return (int) gettext ("")
 ; return 0; }
 EOF
-if { (eval echo configure:3381: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3375: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   gt_cv_func_gettext_libc=yes
 else
@@ -3393,7 +3387,7 @@
 
            if test "$gt_cv_func_gettext_libc" != "yes"; then
              echo $ac_n "checking for bindtextdomain in -lintl""... $ac_c" 1>&6
-echo "configure:3397: checking for bindtextdomain in -lintl" >&5
+echo "configure:3391: checking for bindtextdomain in -lintl" >&5
 ac_lib_var=`echo intl'_'bindtextdomain | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3401,7 +3395,7 @@
   ac_save_LIBS="$LIBS"
 LIBS="-lintl  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 3405 "configure"
+#line 3399 "configure"
 #include "confdefs.h"
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
@@ -3412,7 +3406,7 @@
 bindtextdomain()
 ; return 0; }
 EOF
-if { (eval echo configure:3416: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3410: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
 else
@@ -3428,19 +3422,19 @@
 if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
   echo "$ac_t""yes" 1>&6
   echo $ac_n "checking for gettext in libintl""... $ac_c" 1>&6
-echo "configure:3432: checking for gettext in libintl" >&5
+echo "configure:3426: checking for gettext in libintl" >&5
 if eval "test \"`echo '$''{'gt_cv_func_gettext_libintl'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3437 "configure"
+#line 3431 "configure"
 #include "confdefs.h"
 
 int main() {
 return (int) gettext ("")
 ; return 0; }
 EOF
-if { (eval echo configure:3444: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3438: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   gt_cv_func_gettext_libintl=yes
 else
@@ -3468,7 +3462,7 @@
               # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3472: checking for $ac_word" >&5
+echo "configure:3466: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3502,12 +3496,12 @@
                 for ac_func in dcgettext
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3506: checking for $ac_func" >&5
+echo "configure:3500: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3511 "configure"
+#line 3505 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3530,7 +3524,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3534: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3528: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3557,7 +3551,7 @@
                 # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3561: checking for $ac_word" >&5
+echo "configure:3555: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3589,7 +3583,7 @@
                 # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3593: checking for $ac_word" >&5
+echo "configure:3587: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3621,7 +3615,7 @@
 fi
 
                 cat > conftest.$ac_ext <<EOF
-#line 3625 "configure"
+#line 3619 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -3629,7 +3623,7 @@
                                return _nl_msg_cat_cntr
 ; return 0; }
 EOF
-if { (eval echo configure:3633: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3627: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   CATOBJEXT=.gmo
                    DATADIRNAME=share
@@ -3652,7 +3646,7 @@
 
         if test "$CATOBJEXT" = "NONE"; then
           echo $ac_n "checking whether catgets can be used""... $ac_c" 1>&6
-echo "configure:3656: checking whether catgets can be used" >&5
+echo "configure:3650: checking whether catgets can be used" >&5
           # Check whether --with-catgets or --without-catgets was given.
 if test "${with_catgets+set}" = set; then
   withval="$with_catgets"
@@ -3665,7 +3659,7 @@
 
           if test "$nls_cv_use_catgets" = "yes"; then
                         echo $ac_n "checking for main in -li""... $ac_c" 1>&6
-echo "configure:3669: checking for main in -li" >&5
+echo "configure:3663: checking for main in -li" >&5
 ac_lib_var=`echo i'_'main | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3673,14 +3667,14 @@
   ac_save_LIBS="$LIBS"
 LIBS="-li  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 3677 "configure"
+#line 3671 "configure"
 #include "confdefs.h"
 
 int main() {
 main()
 ; return 0; }
 EOF
-if { (eval echo configure:3684: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3678: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
 else
@@ -3708,12 +3702,12 @@
 fi
 
             echo $ac_n "checking for catgets""... $ac_c" 1>&6
-echo "configure:3712: checking for catgets" >&5
+echo "configure:3706: checking for catgets" >&5
 if eval "test \"`echo '$''{'ac_cv_func_catgets'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3717 "configure"
+#line 3711 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char catgets(); below.  */
@@ -3736,7 +3730,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3740: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3734: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_catgets=yes"
 else
@@ -3758,7 +3752,7 @@
                # Extract the first word of "gencat", so it can be a program name with args.
 set dummy gencat; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3762: checking for $ac_word" >&5
+echo "configure:3756: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GENCAT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3790,7 +3784,7 @@
                  # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3794: checking for $ac_word" >&5
+echo "configure:3788: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3823,7 +3817,7 @@
                    # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3827: checking for $ac_word" >&5
+echo "configure:3821: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3858,7 +3852,7 @@
                  # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3862: checking for $ac_word" >&5
+echo "configure:3856: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3916,7 +3910,7 @@
         # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3920: checking for $ac_word" >&5
+echo "configure:3914: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3950,7 +3944,7 @@
         # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3954: checking for $ac_word" >&5
+echo "configure:3948: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3982,7 +3976,7 @@
         # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3986: checking for $ac_word" >&5
+echo "configure:3980: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -4072,7 +4066,7 @@
        LINGUAS=
      else
        echo $ac_n "checking for catalogs to be installed""... $ac_c" 1>&6
-echo "configure:4076: checking for catalogs to be installed" >&5
+echo "configure:4070: checking for catalogs to be installed" >&5
        NEW_LINGUAS=
        for lang in ${LINGUAS=$ALL_LINGUAS}; do
          case "$ALL_LINGUAS" in
@@ -4100,17 +4094,17 @@
    if test "$CATOBJEXT" = ".cat"; then
      ac_safe=`echo "linux/version.h" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for linux/version.h""... $ac_c" 1>&6
-echo "configure:4104: checking for linux/version.h" >&5
+echo "configure:4098: checking for linux/version.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 4109 "configure"
+#line 4103 "configure"
 #include "confdefs.h"
 #include <linux/version.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:4114: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:4108: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -4174,6 +4168,12 @@
    sed -e "/^#/d" -e "/^\$/d" -e "s,.*, $posrcprefix& \\\\," -e "\$s/\(.*\) \\\\/\1/" \
         < $srcdir/po/POTFILES.in > po/POTFILES
   
+G10_LOCALEDIR="$g10_prefix/$DATADIRNAME/locale"
+
+cat >> confdefs.h <<EOF
+#define G10_LOCALEDIR "$G10_LOCALEDIR"
+EOF
+
  if test "x$wk_link_files_src" = "x"; then
         wk_link_files_src="$nls_cv_header_libgt"
         wk_link_files_dst="$nls_cv_header_intl "
@@ -4356,7 +4356,6 @@
 s%@INSTALL_PROGRAM@%$INSTALL_PROGRAM%g
 s%@INSTALL_DATA@%$INSTALL_DATA%g
 s%@CPP@%$CPP%g
-s%@G10_LOCALEDIR@%$G10_LOCALEDIR%g
 s%@MPI_EXTRA_ASM_OBJS@%$MPI_EXTRA_ASM_OBJS%g
 s%@ENABLE_LOCAL_ZLIB_TRUE@%$ENABLE_LOCAL_ZLIB_TRUE%g
 s%@ENABLE_LOCAL_ZLIB_FALSE@%$ENABLE_LOCAL_ZLIB_FALSE%g
@@ -4385,6 +4384,7 @@
 s%@GT_YES@%$GT_YES%g
 s%@MKINSTALLDIRS@%$MKINSTALLDIRS%g
 s%@l@%$l%g
+s%@G10_LOCALEDIR@%$G10_LOCALEDIR%g
 
 CEOF
 EOF
diff -urN gnupg-0.2.13/configure.in gnupg-0.2.14/configure.in
--- gnupg-0.2.13/configure.in	Tue Mar 10 16:45:13 1998
+++ gnupg-0.2.14/configure.in	Thu Apr  2 11:34:27 1998
@@ -21,7 +21,7 @@
 
 VERSION=`cat $srcdir/VERSION`
 PACKAGE=gnupg
-ALL_LINGUAS="de"
+ALL_LINGUAS="de it"
 AC_SUBST(VERSION)
 AC_SUBST(PACKAGE)
 AC_DEFINE_UNQUOTED(VERSION, "$VERSION")
@@ -99,9 +99,6 @@
 AC_HEADER_STDC
 AC_CHECK_HEADERS(unistd.h)
 
-G10_LOCALEDIR="$g10_prefix/$DATADIRNAME/locale"
-AC_SUBST(G10_LOCALEDIR)
-AC_DEFINE_UNQUOTED(G10_LOCALEDIR, "$G10_LOCALEDIR")
 
 
 dnl Checks for typedefs, structures, and compiler characteristics.
@@ -210,6 +207,9 @@
 AC_SUBST(CIPHER_EXTRA_DIST)
 
 AM_GNU_GETTEXT
+G10_LOCALEDIR="$g10_prefix/$DATADIRNAME/locale"
+AC_SUBST(G10_LOCALEDIR)
+AC_DEFINE_UNQUOTED(G10_LOCALEDIR, "$G10_LOCALEDIR")
 WK_LINK_FILES($nls_cv_header_libgt, $nls_cv_header_intl )
 
 WK_DO_LINK_FILES
diff -urN gnupg-0.2.13/doc/Makefile.am gnupg-0.2.14/doc/Makefile.am
--- gnupg-0.2.13/doc/Makefile.am	Thu Feb 26 09:20:37 1998
+++ gnupg-0.2.14/doc/Makefile.am	Sat Mar 21 14:33:01 1998
@@ -11,3 +11,23 @@
 		     >$@,$$$$ && mv -f $@,$$$$ $@\
 		    || rm -f $@,$$$$
 
+
+
+%.txt : %.sgml
+	 sgml2txt -c latin $*
+
+%.html : %.sgml
+	 sgml2html -l deutsch -c latin $*
+
+%.dvi : %.sgml
+	-rm $*.sgml.tmp
+	mv $*.sgml $*.sgml.tmp
+	sed -e '/<!entity/  s/"IGNORE">/"INCLUDE">/' $*.sgml.tmp >$*.sgml
+	sgml2latex -b -l deutsch -c latin $* ; mv $*.sgml.tmp $*.sgml
+
+%.ps : %.sgml
+	-rm $*.sgml.tmp
+	mv $*.sgml $*.sgml.tmp
+	sed -e '/<!entity/  s/"IGNORE">/"INCLUDE">/' $*.sgml.tmp >$*.sgml
+	sgml2latex -b -l deutsch -c latin -o ps $* ; mv $*.sgml.tmp $*.sgml
+
diff -urN gnupg-0.2.13/doc/Makefile.in gnupg-0.2.14/doc/Makefile.in
--- gnupg-0.2.13/doc/Makefile.in	Tue Mar 10 18:48:18 1998
+++ gnupg-0.2.14/doc/Makefile.in	Thu Apr  2 12:06:34 1998
@@ -236,6 +236,24 @@
 		     >$@,$$$$ && mv -f $@,$$$$ $@\
 		    || rm -f $@,$$$$
 
+%.txt : %.sgml
+	 sgml2txt -c latin $*
+
+%.html : %.sgml
+	 sgml2html -l deutsch -c latin $*
+
+%.dvi : %.sgml
+	-rm $*.sgml.tmp
+	mv $*.sgml $*.sgml.tmp
+	sed -e '/<!entity/  s/"IGNORE">/"INCLUDE">/' $*.sgml.tmp >$*.sgml
+	sgml2latex -b -l deutsch -c latin $* ; mv $*.sgml.tmp $*.sgml
+
+%.ps : %.sgml
+	-rm $*.sgml.tmp
+	mv $*.sgml $*.sgml.tmp
+	sed -e '/<!entity/  s/"IGNORE">/"INCLUDE">/' $*.sgml.tmp >$*.sgml
+	sgml2latex -b -l deutsch -c latin -o ps $* ; mv $*.sgml.tmp $*.sgml
+
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
 .NOEXPORT:
diff -urN gnupg-0.2.13/g10/ChangeLog gnupg-0.2.14/g10/ChangeLog
--- gnupg-0.2.13/g10/ChangeLog	Tue Mar 10 17:02:19 1998
+++ gnupg-0.2.14/g10/ChangeLog	Thu Apr  2 10:47:26 1998
@@ -1,3 +1,54 @@
+Thu Apr  2 10:38:16 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* keygen.c (generate_keypair): Add valid_days stuff.
+	* trustdb.c (check_trust): Add check for valid_days.
+
+Wed Apr  1 16:15:58 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* keygen.c (generate_keypair): Addional question whether the
+	selected large keysize is really needed.
+
+Wed Apr  1 15:56:33 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* seckey-cert.c (protect_secret_key): merged protect_xxx to here.
+
+Wed Apr  1 10:34:46 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* Makefile.am (g10maint.c): Changed creation rule, so that it works
+	on FreeBSD (missing CFLAGS).
+
+	* parse-packet.c (parse_subkey): Removed.
+
+Thu Mar 19 15:22:36 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* ringedit.c (keyring_enum): Fixed problem with reading too
+	many packets. Add support to read secret keyrings.
+
+	* getkey.c (scan_keyring): Removed
+	(lookup): New to replace scan_keyring.
+	(scan_secret_keyring): Removed.
+	(lookup_skc): New.
+
+Wed Mar 18 11:47:34 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* ringedit.c (enum_keyblocks): New read mode 11.
+
+	* keyid.c (elg_fingerprint_md): New and changed all other functions
+	to call this if the packet version is 4 or above.
+
+Tue Mar 17 20:46:16 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* parse-packet.c (parse_certificate): Add listing support for subkeys.
+
+Tue Mar 17 20:32:22 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* armor.c (is_armored): Allow marker packet.
+
+Thu Mar 12 13:36:49 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* trustdb.c (check_trust): Checks timestamp of pubkey.
+	* sig-check. (do_check): Compares timestamps.
+
 Tue Mar 10 17:01:56 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* g10.c (main): Add call to init_signals.
diff -urN gnupg-0.2.13/g10/Makefile.am gnupg-0.2.14/g10/Makefile.am
--- gnupg-0.2.13/g10/Makefile.am	Tue Mar 10 17:02:35 1998
+++ gnupg-0.2.14/g10/Makefile.am	Wed Apr  1 18:44:42 1998
@@ -1,6 +1,6 @@
 ## Process this file with automake to produce Makefile.in
 
-INCLUDES = -I$(top_srcdir)/include
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 EXTRA_DIST = OPTIONS  pubring.asc
 OMIT_DEPENDENCIES = zlib.h zconf.h
 BUILT_SOURCES = g10maint.c
@@ -67,7 +67,7 @@
 LDADD = @INTLLIBS@ $(needed_libs) @ZLIBS@
 
 g10maint.c : g10.c
-	    $(CPP) $(DEFS) $(INCLUDES) -DIS_G10MAINT  $<  > $@ || rm $@
+	    $(CPP) $(CFLAGS) $(DEFS) $(INCLUDES) -DIS_G10MAINT $< > $@ || rm $@
 
 $(PROGRAMS): $(needed_libs)
 
diff -urN gnupg-0.2.13/g10/Makefile.in gnupg-0.2.14/g10/Makefile.in
--- gnupg-0.2.13/g10/Makefile.in	Tue Mar 10 18:48:15 1998
+++ gnupg-0.2.14/g10/Makefile.in	Thu Apr  2 12:06:31 1998
@@ -92,7 +92,7 @@
 ZLIBS = @ZLIBS@
 l = @l@
 
-INCLUDES = -I$(top_srcdir)/include
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 EXTRA_DIST = OPTIONS  pubring.asc
 OMIT_DEPENDENCIES = zlib.h zconf.h
 BUILT_SOURCES = g10maint.c
@@ -618,7 +618,8 @@
 	../include/../cipher/sha1.h ../include/../cipher/md5.h \
 	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
 	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	filter.h ../include/util.h trustdb.h options.h main.h
+	filter.h ../include/util.h trustdb.h options.h main.h \
+	../include/i18n.h
 verify.o: verify.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
 	../include/cipher.h ../include/../cipher/md.h \
@@ -694,7 +695,7 @@
 
 
 g10maint.c : g10.c
-	    $(CPP) $(DEFS) $(INCLUDES) -DIS_G10MAINT  $<  > $@ || rm $@
+	    $(CPP) $(CFLAGS) $(DEFS) $(INCLUDES) -DIS_G10MAINT $< > $@ || rm $@
 
 $(PROGRAMS): $(needed_libs)
 
diff -urN gnupg-0.2.13/g10/armor.c gnupg-0.2.14/g10/armor.c
--- gnupg-0.2.13/g10/armor.c	Sat Mar  7 11:56:22 1998
+++ gnupg-0.2.14/g10/armor.c	Wed Apr  1 15:04:41 1998
@@ -150,6 +150,7 @@
 	return 1; /* invalid packet: assume it is armored */
     pkttype =  ctb & 0x40 ? (ctb & 0x3f) : ((ctb>>2)&0xf);
     switch( pkttype ) {
+      case PKT_MARKER:
       case PKT_PUBLIC_CERT:
       case PKT_SECRET_CERT:
       case PKT_PUBKEY_ENC:
@@ -651,8 +652,6 @@
     size_t n, nn;
     fhdr_state_t state = afx->parse_state;
     unsigned emplines = afx->empty;
-
-    size = 100; /* FIXME: only used for testing (remove it)  */
 
     len = 2;	/* reserve 2 bytes for the length header */
     size -= 3;	/* and 1 for empline handling and 2 for the term header */
diff -urN gnupg-0.2.13/g10/build-packet.c gnupg-0.2.14/g10/build-packet.c
--- gnupg-0.2.13/g10/build-packet.c	Mon Mar  9 20:14:52 1998
+++ gnupg-0.2.14/g10/build-packet.c	Wed Apr  1 15:35:51 1998
@@ -267,31 +267,31 @@
 	mpi_write(a, skc->d.elg.p );
 	mpi_write(a, skc->d.elg.g );
 	mpi_write(a, skc->d.elg.y );
-	if( skc->d.elg.is_protected ) {
+	if( skc->is_protected ) {
 	    iobuf_put(a, 0xff );
-	    iobuf_put(a, skc->d.elg.protect.algo );
-	    iobuf_put(a, skc->d.elg.protect.s2k );
-	    iobuf_put(a, skc->d.elg.protect.hash );
-	    if( skc->d.elg.protect.s2k == 1
-		|| skc->d.elg.protect.s2k == 3 )
-		iobuf_write(a, skc->d.elg.protect.salt, 8 );
-	    if( skc->d.elg.protect.s2k == 3 )
-		iobuf_put(a, skc->d.elg.protect.count );
-	    iobuf_write(a, skc->d.elg.protect.iv, 8 );
+	    iobuf_put(a, skc->protect.algo );
+	    iobuf_put(a, skc->protect.s2k );
+	    iobuf_put(a, skc->protect.hash );
+	    if( skc->protect.s2k == 1
+		|| skc->protect.s2k == 3 )
+		iobuf_write(a, skc->protect.salt, 8 );
+	    if( skc->protect.s2k == 3 )
+		iobuf_put(a, skc->protect.count );
+	    iobuf_write(a, skc->protect.iv, 8 );
 	}
 	else
 	    iobuf_put(a, 0 );
 
 	mpi_write(a, skc->d.elg.x );
-	write_16(a, skc->d.elg.csum );
+	write_16(a, skc->csum );
     }
     else if( skc->pubkey_algo == PUBKEY_ALGO_RSA ) {
 	mpi_write(a, skc->d.rsa.rsa_n );
 	mpi_write(a, skc->d.rsa.rsa_e );
-	if( skc->d.rsa.is_protected ) {
-	    assert( skc->d.rsa.protect_algo == CIPHER_ALGO_BLOWFISH );
-	    iobuf_put(a, skc->d.rsa.protect_algo );
-	    iobuf_write(a, skc->d.rsa.protect.blowfish.iv, 8 );
+	if( skc->is_protected ) {
+	    assert( skc->protect.algo == CIPHER_ALGO_BLOWFISH );
+	    iobuf_put(a, skc->protect.algo );
+	    iobuf_write(a, skc->protect.iv, 8 );
 	}
 	else
 	    iobuf_put(a, 0 );
@@ -299,7 +299,7 @@
 	mpi_write(a, skc->d.rsa.rsa_p );
 	mpi_write(a, skc->d.rsa.rsa_q );
 	mpi_write(a, skc->d.rsa.rsa_u );
-	write_16(a, skc->d.rsa.csum );
+	write_16(a, skc->csum );
     }
     else {
 	rc = G10ERR_PUBKEY_ALGO;
diff -urN gnupg-0.2.13/g10/cipher.c gnupg-0.2.14/g10/cipher.c
--- gnupg-0.2.13/g10/cipher.c	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.14/g10/cipher.c	Wed Apr  1 15:05:15 1998
@@ -47,10 +47,10 @@
     cipher_filter_context_t *cfx = opaque;
     int rc=0;
 
-    if( control == IOBUFCTRL_UNDERFLOW ) { /* decrypted */
-	rc = -1; /* FIXME:*/
+    if( control == IOBUFCTRL_UNDERFLOW ) { /* decrypt */
+	rc = -1; /* not yet used */
     }
-    else if( control == IOBUFCTRL_FLUSH ) { /* encrypted */
+    else if( control == IOBUFCTRL_FLUSH ) { /* encrypt */
 	assert(a);
 	if( !cfx->header ) {
 	    PACKET pkt;
diff -urN gnupg-0.2.13/g10/compress.c gnupg-0.2.14/g10/compress.c
--- gnupg-0.2.13/g10/compress.c	Thu Mar  5 13:38:19 1998
+++ gnupg-0.2.14/g10/compress.c	Wed Apr  1 15:10:24 1998
@@ -147,7 +147,7 @@
 	    log_debug("inflate returned: avail_in=%u, avail_out=%u, zrc=%d\n",
 		   (unsigned)zs->avail_in, (unsigned)zs->avail_out, zrc);
 	if( zrc == Z_STREAM_END )
-	    rc = -1; /* eof FIXME: return remaining bytes until EOF */
+	    rc = -1; /* eof */
 	else if( zrc != Z_OK ) {
 	    if( zs->msg )
 		log_fatal("zlib inflate problem: %s\n", zs->msg );
diff -urN gnupg-0.2.13/g10/g10.c gnupg-0.2.14/g10/g10.c
--- gnupg-0.2.13/g10/g10.c	Tue Mar 10 17:01:55 1998
+++ gnupg-0.2.14/g10/g10.c	Wed Apr  1 15:12:56 1998
@@ -31,6 +31,7 @@
 #include <string.h>
 #include <unistd.h>
 
+
 #include "packet.h"
 #include "iobuf.h"
 #include "memory.h"
@@ -99,7 +100,7 @@
   #endif
     { 'o', "output",    2, N_("use as output file")},
     { 'v', "verbose",   0, N_("verbose") },
-    { 'n', "dry-run",   0, N_("don't make any changes") },
+    { 'n', "dry-run",   0, N_("do not make any changes") },
     { 500, "batch",     0, N_("batch mode: never ask")},
     { 501, "yes",       0, N_("assume yes on most questions")},
     { 502, "no",        0, N_("assume no on most questions")},
@@ -275,7 +276,7 @@
 static void
 i18n_init(void)
 {
-  #ifdef HAVE_LIBINTL
+  #ifdef ENABLE_NLS
     #ifdef HAVE_LC_MESSAGES
        setlocale( LC_MESSAGES, "" );
     #else
@@ -634,8 +635,10 @@
 	    /* reading data and passphrase form stdin:
 	     * we assume the first line is the passphrase, so
 	     * we better should read it now.
+	     *
+	     * We should do it here, but for now it is not needed.
+	     * Anyway, this password scheme is not quite good
 	     */
-	    /* FIXME: doit */
 	}
     }
 
diff -urN gnupg-0.2.13/g10/g10maint.c gnupg-0.2.14/g10/g10maint.c
--- gnupg-0.2.13/g10/g10maint.c	Tue Mar 10 17:03:17 1998
+++ gnupg-0.2.14/g10/g10maint.c	Wed Apr  1 15:58:25 1998
@@ -91,6 +91,9 @@
  
 
  
+
+
+ 
  
 
  
@@ -108,6 +111,9 @@
  
 
 
+ 
+
+
 
 
 
@@ -3759,6 +3765,7 @@
 # 32 "g10.c" 2
 
 
+
 # 1 "packet.h" 1
  
 
@@ -4827,6 +4834,7 @@
 
 typedef struct {
     u32     keyid[2];	     
+    byte    version;
     byte    pubkey_algo;     
     union {
       struct {
@@ -4906,24 +4914,24 @@
     byte    hdrbytes;	     
     byte    version;
     byte    pubkey_algo;     
+    byte is_protected;	 
+			 
+			 
+			 
+    struct {
+	byte algo;   
+	byte s2k;
+	byte hash;
+	byte salt[8];
+	byte count;
+	byte iv[8];  
+    } protect;
     union {
       struct {
 	MPI p;		     
 	MPI g;		     
 	MPI y;		     
 	MPI x;		     
-	u16 csum;	     
-	byte is_protected;   
-			     
-	struct {
-	    byte algo;	 
-	    byte s2k;
-	    byte hash;
-	    byte salt[8];
-	    byte count;
-	    byte iv[8];  
-	} protect;	     
-
       } elg;
       struct {
 	MPI p;		     
@@ -4931,18 +4939,6 @@
 	MPI g;		     
 	MPI y;		     
 	MPI x;		     
-	u16 csum;	     
-	byte is_protected;   
-			     
-	struct {
-	    byte algo;	 
-	    byte s2k;
-	    byte hash;
-	    byte salt[8];
-	    byte count;
-	    byte iv[8];  
-	} protect;	     
-
       } dsa;
       struct {
 	MPI rsa_n;	     
@@ -4951,19 +4947,9 @@
 	MPI rsa_p;	     
 	MPI rsa_q;	     
 	MPI rsa_u;	     
-	u16 csum;	     
-	byte is_protected;   
-			     
-	byte protect_algo;   
-	union { 	     
-	  struct {
-	    byte iv[8];      
-			     
-
-	  } blowfish;
-	} protect;
       } rsa;
     } d;
+    u16 csum;		 
 } PKT_secret_cert;
 
 
@@ -5088,7 +5074,7 @@
 			int sigclass, int digest_algo );
 
 
-# 34 "g10.c" 2
+# 35 "g10.c" 2
 
 
 
@@ -5180,6 +5166,7 @@
 
 
 
+
 # 24 "../include/util.h" 2
 
 
@@ -5269,7 +5256,7 @@
 void add_to_strlist( STRLIST *list, const char *string );
 STRLIST strlist_prev( STRLIST head, STRLIST node );
 STRLIST strlist_last( STRLIST node );
-char *memistr( char *buf, size_t buflen, const char *sub );
+const char *memistr( const char *buf, size_t buflen, const char *sub );
 char *mem2str( char *, const void *, size_t);
 char *trim_spaces( char *string );
 int string_count_chr( const char *string, int c );
@@ -5294,7 +5281,7 @@
 
 
 
-# 37 "g10.c" 2
+# 38 "g10.c" 2
 
 # 1 "main.h" 1
  
@@ -5376,6 +5363,7 @@
     ulong offset;     
     unsigned count;   
     IOBUF  fp;	      
+    int secret;       
     PACKET *pkt;      
 };
 typedef struct keyblock_pos_struct KBPOS;
@@ -5426,8 +5414,8 @@
 void add_keyring( const char *name );
 const char *get_keyring( int sequence );
 void add_secret_keyring( const char *name );
-void cache_public_cert( PKT_public_cert *pkc );
-void cache_user_id( PKT_user_id *uid, u32 *keyid );
+ 
+
 int get_pubkey( PKT_public_cert *pkc, u32 *keyid );
 int get_pubkey_byname( PKT_public_cert *pkc, const char *name );
 int get_seckey( PKT_secret_cert *skc, u32 *keyid );
@@ -5578,7 +5566,7 @@
 void init_signals(void);
 
 
-# 38 "g10.c" 2
+# 39 "g10.c" 2
 
 # 1 "options.h" 1
  
@@ -5651,7 +5639,7 @@
 
 
 
-# 39 "g10.c" 2
+# 40 "g10.c" 2
 
 
 
@@ -5710,7 +5698,7 @@
 int sign_private_data(void);
 
 
-# 44 "g10.c" 2
+# 45 "g10.c" 2
 
 # 1 "../include/ttyio.h" 1
  
@@ -5743,7 +5731,7 @@
 
 
 
-# 45 "g10.c" 2
+# 46 "g10.c" 2
 
 # 1 "../include/i18n.h" 1
  
@@ -5871,14 +5859,181 @@
 
 
 
-# 36 "../include/i18n.h"
 
   
+# 1 "../libintl.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+struct _msg_ent
+{
+  const char *_msg;
+  int _msg_number;
+};
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+ 
+
+
+extern char *gettext  (const char *__msgid)  ;
+extern char *gettext__  (const char *__msgid)  ;
+
+ 
+
+extern char *dgettext  (const char *__domainname, const char *__msgid)  ;
+extern char *dgettext__  (const char *__domainname,
+				 const char *__msgid)  ;
+
+ 
+
+extern char *dcgettext  (const char *__domainname, const char *__msgid,
+				int __category)  ;
+extern char *dcgettext__  (const char *__domainname,
+				  const char *__msgid, int __category)  ;
+
+
+ 
+
+
+extern char *textdomain  (const char *__domainname)  ;
+extern char *textdomain__  (const char *__domainname)  ;
+
+ 
+
+extern char *bindtextdomain  (const char *__domainname,
+				  const char *__dirname)  ;
+extern char *bindtextdomain__  (const char *__domainname,
+				    const char *__dirname)  ;
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+extern int _nl_msg_cat_cntr;
+
+
+# 163 "../libintl.h"
+
+
+
+# 174 "../libintl.h"
+
+
+ 
+
+
+
+
+
+
+# 29 "../include/i18n.h" 2
+
+  
+  
+    
   
 
 
 
-# 46 "g10.c" 2
+
+
+
+
+
+# 47 "g10.c" 2
 
 # 1 "status.h" 1
  
@@ -5924,7 +6079,7 @@
 
 
 
-# 47 "g10.c" 2
+# 48 "g10.c" 2
 
 
 
@@ -5934,15 +6089,15 @@
 
 static ARGPARSE_OPTS opts[] = {
 
-    { 300, ((void *)0) , 0, ( "\vCommands:\n " )  },
+    { 300, ((void *)0) , 0, (  "\vCommands:\n "  )   },
 
   
-# 67 "g10.c"
+# 68 "g10.c"
 
-    { 551, "list-keys", 0, ( "list keys" ) },
-    { 552, "list-sigs", 0, ( "list keys and signatures" ) },
-    { 508, "check-sigs",0, ( "check key signatures" ) },
-    { 515, "fingerprint", 0, ( "list keys and fingerprints" ) },
+    { 551, "list-keys", 0, (  "list keys"  )  },
+    { 552, "list-sigs", 0, (  "list keys and signatures"  )  },
+    { 508, "check-sigs",0, (  "check key signatures"  )  },
+    { 515, "fingerprint", 0, (  "list keys and fingerprints"  )  },
   
 
 
@@ -5951,18 +6106,18 @@
 
 
 
-    { 537, "export"          , 0, ( "export keys" )  },
-    { 530, "import",      0     , ( "import/merge keys" ) },
-    { 521, "list-packets",0,( "list only the sequence of packets" ) },
+    { 537, "export"          , 0, (  "export keys"  )   },
+    { 530, "import",      0     , (  "import/merge keys"  )  },
+    { 521, "list-packets",0,(  "list only the sequence of packets"  )  },
   
-    { 546, "dearmor", 0, ( "De-Armor a file or stdin" )  },
-    { 547, "enarmor", 0, ( "En-Armor a file or stdin" )  },
-    { 516, "print-mds" , 0, ( "print all message digests" ) },
+    { 546, "dearmor", 0, (  "De-Armor a file or stdin"  )   },
+    { 547, "enarmor", 0, (  "En-Armor a file or stdin"  )   },
+    { 516, "print-mds" , 0, (  "print all message digests"  )  },
     { 513, "gen-prime" , 0, "\r" },
     { 548, "gen-random" , 0, "\r" },
   
 
-    { 301, ((void *)0) , 0, ( "\v\nOptions:\n " )  },
+    { 301, ((void *)0) , 0, (  "\v\nOptions:\n "  )   },
 
   
 
@@ -5971,22 +6126,22 @@
 
 
 
-    { 'o', "output",    2, ( "use as output file" ) },
-    { 'v', "verbose",   0, ( "verbose" )  },
-    { 'n', "dry-run",   0, ( "don't make any changes" )  },
-    { 500, "batch",     0, ( "batch mode: never ask" ) },
-    { 501, "yes",       0, ( "assume yes on most questions" ) },
-    { 502, "no",        0, ( "assume no on most questions" ) },
-    { 509, "keyring"   ,2, ( "add this keyring to the list of keyrings" ) },
-    { 517, "secret-keyring" ,2, ( "add this secret keyring to the list" ) },
-    { 518, "options"   , 2, ( "read options from file" ) },
-
-    { 510, "debug"     ,4|16, ( "set debugging flags" ) },
-    { 511, "debug-all" ,0, ( "enable full debugging" ) },
-    { 512, "status-fd" ,1, ( "write status info to this fd" )  },
-    { 534, "no-comment", 0,   ( "do not write comment packets" ) },
-    { 535, "completes-needed", 1, ( "(default is 1)" ) },
-    { 536, "marginals-needed", 1, ( "(default is 3)" ) },
+    { 'o', "output",    2, (  "use as output file"  )  },
+    { 'v', "verbose",   0, (  "verbose"  )   },
+    { 'n', "dry-run",   0, (  "do not make any changes"  )   },
+    { 500, "batch",     0, (  "batch mode: never ask"  )  },
+    { 501, "yes",       0, (  "assume yes on most questions"  )  },
+    { 502, "no",        0, (  "assume no on most questions"  )  },
+    { 509, "keyring"   ,2, (  "add this keyring to the list of keyrings"  )  },
+    { 517, "secret-keyring" ,2, (  "add this secret keyring to the list"  )  },
+    { 518, "options"   , 2, (  "read options from file"  )  },
+
+    { 510, "debug"     ,4|16, (  "set debugging flags"  )  },
+    { 511, "debug-all" ,0, (  "enable full debugging"  )  },
+    { 512, "status-fd" ,1, (  "write status info to this fd"  )   },
+    { 534, "no-comment", 0,   (  "do not write comment packets"  )  },
+    { 535, "completes-needed", 1, (  "(default is 1)"  )  },
+    { 536, "marginals-needed", 1, (  "(default is 3)"  )  },
   
 
 
@@ -6069,23 +6224,23 @@
 
 
 	break;
-      case 13: p = "0.2.12a" ; break;
+      case 13: p = "0.2.13a" ; break;
       case 17: p = "Linux" ; break;
       case 19: p =
-	    ( "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n" ) ;
+	    (__extension__	({	char *__result;	if (__builtin_constant_p (      "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"    ,   5  );	__result;	}))    ;
 	break;
       case 1:
       case 40:	p =
 	  
-	    ( "Usage: gpgm [options] [files] (-h for help)" ) ;
+	    (__extension__	({	char *__result;	if (__builtin_constant_p (      "Usage: gpgm [options] [files] (-h for help)"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "Usage: gpgm [options] [files] (-h for help)"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "Usage: gpgm [options] [files] (-h for help)"    ,   5  );	__result;	}))    ;
 	  
 
 
 	break;
       case 41:	p =
 	  
-	    ( "Syntax: gpgm [options] [files]\n"
-	      "GNUPG maintenance utility\n" ) ;
+	    (__extension__	({	char *__result;	if (__builtin_constant_p (      "Syntax: gpgm [options] [files]\n"
+	      "GNUPG maintenance utility\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "Syntax: gpgm [options] [files]\n" 	      "GNUPG maintenance utility\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "Syntax: gpgm [options] [files]\n" 	      "GNUPG maintenance utility\n"    ,   5  );	__result;	}))    ;
 	  
 
 
@@ -6150,15 +6305,21 @@
 i18n_init(void)
 {
   
-# 286 "g10.c"
+    
+       setlocale( 5 , "" );
+    
+
 
+    bindtextdomain( "gnupg" , "/usr/local//locale"  );
+    textdomain( "gnupg"  );
+  
 }
 
 static void
 wrong_args( const char *text)
 {
   
-    fputs(( "usage: gpgm [options] " ) ,((_IO_FILE*)(&_IO_stderr_))  );
+    fputs((__extension__	({	char *__result;	if (__builtin_constant_p (      "usage: gpgm [options] "    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "usage: gpgm [options] "    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "usage: gpgm [options] "    ,   5  );	__result;	}))    ,((_IO_FILE*)(&_IO_stderr_))  );
   
 
 
@@ -6200,7 +6361,7 @@
 	     || ( cmd == aClearsign && new_cmd == aSign )  )
 	cmd = aClearsign;
     else {
-	log_error(( "conflicting commands\n" ) );
+	log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "conflicting commands\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "conflicting commands\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "conflicting commands\n"    ,   5  );	__result;	}))    );
 	g10_exit(2);
     }
 
@@ -6213,15 +6374,15 @@
 check_opts(void)
 {
     if( !opt.def_cipher_algo || check_cipher_algo(opt.def_cipher_algo) )
-	log_error(( "selected cipher algorithm is invalid\n" ) );
+	log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "selected cipher algorithm is invalid\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "selected cipher algorithm is invalid\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "selected cipher algorithm is invalid\n"    ,   5  );	__result;	}))    );
     if( !opt.def_pubkey_algo || check_pubkey_algo(opt.def_pubkey_algo) )
-	log_error(( "selected pubkey algorithm is invalid\n" ) );
+	log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "selected pubkey algorithm is invalid\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "selected pubkey algorithm is invalid\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "selected pubkey algorithm is invalid\n"    ,   5  );	__result;	}))    );
     if( !opt.def_digest_algo || check_digest_algo(opt.def_digest_algo) )
-	log_error(( "selected digest algorithm is invalid\n" ) );
+	log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "selected digest algorithm is invalid\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "selected digest algorithm is invalid\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "selected digest algorithm is invalid\n"    ,   5  );	__result;	}))    );
     if( opt.completes_needed < 1 )
-	log_error(( "completes-needed must be greater than 0\n" ) );
+	log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "completes-needed must be greater than 0\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "completes-needed must be greater than 0\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "completes-needed must be greater than 0\n"    ,   5  );	__result;	}))    );
     if( opt.marginals_needed < 2 )
-	log_error(( "marginals-needed must be greater than 1\n" ) );
+	log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "marginals-needed must be greater than 1\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "marginals-needed must be greater than 1\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "marginals-needed must be greater than 1\n"    ,   5  );	__result;	}))    );
 }
 
 
@@ -6255,7 +6416,7 @@
     secmem_init( 0 );	    
     log_set_name("gpgm");
   
-# 397 "g10.c"
+# 398 "g10.c"
 
     i18n_init();
     opt.compress = -1;  
@@ -6309,18 +6470,18 @@
 	if( !configfp ) {
 	    if( default_config ) {
 		if( parse_debug )
-		    log_info(( "note: no default option file '%s'\n" ) ,
+		    log_info((__extension__	({	char *__result;	if (__builtin_constant_p (      "note: no default option file '%s'\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "note: no default option file '%s'\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "note: no default option file '%s'\n"    ,   5  );	__result;	}))    ,
 							    configname );
 	    }
 	    else {
-		log_error(( "option file '%s': %s\n" ) ,
+		log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "option file '%s': %s\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "option file '%s': %s\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "option file '%s': %s\n"    ,   5  );	__result;	}))    ,
 				    configname, strerror(errno) );
 		g10_exit(1);
 	    }
 	    m_free(configname); configname = ((void *)0) ;
 	}
 	if( parse_debug && configname )
-	    log_info(( "reading options from '%s'\n" ) , configname );
+	    log_info((__extension__	({	char *__result;	if (__builtin_constant_p (      "reading options from '%s'\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "reading options from '%s'\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "reading options from '%s'\n"    ,   5  );	__result;	}))    , configname );
 	default_config = 0;
     }
 
@@ -6329,7 +6490,7 @@
 	switch( pargs.r_opt ) {
 
 	
-# 511 "g10.c"
+# 512 "g10.c"
 
 
 	
@@ -6457,7 +6618,9 @@
 
 
 
-	     
+
+
+
 	}
     }
 
@@ -6476,19 +6639,19 @@
       default: rc = init_trustdb(1, trustdb_name ); break;
     }
     if( rc )
-	log_error(( "failed to initialize the TrustDB: %s\n" ) , g10_errstr(rc));
+	log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "failed to initialize the TrustDB: %s\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "failed to initialize the TrustDB: %s\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "failed to initialize the TrustDB: %s\n"    ,   5  );	__result;	}))    , g10_errstr(rc));
 
 
     switch( cmd ) {
       case aStore:  
 	if( argc > 1 )
-	    wrong_args(( "--store [filename]" ) );
+	    wrong_args((__extension__	({	char *__result;	if (__builtin_constant_p (      "--store [filename]"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "--store [filename]"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "--store [filename]"    ,   5  );	__result;	}))    );
 	if( (rc = encode_store(fname)) )
 	    log_error("%s: store failed: %s\n",
 				 print_fname_stdin(fname), g10_errstr(rc) );
 	break;
     
-# 772 "g10.c"
+# 775 "g10.c"
 
 
       case aCheckKeys:
@@ -6504,7 +6667,7 @@
 	    std_key_list( (argc && **argv)? 1:0, argv );
 	else if( argc == 2 ) {  
 	    if( access( argv[1], 4  ) ) {
-		log_error(( "can't open %s: %s\n" ) ,
+		log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "can't open %s: %s\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "can't open %s: %s\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "can't open %s: %s\n"    ,   5  );	__result;	}))    ,
 			       print_fname_stdin(argv[1]), strerror(errno));
 	    }
 	    else {
@@ -6515,7 +6678,7 @@
 	    }
 	}
 	else
-	    wrong_args(( "-k[v][v][v][c] [userid] [keyring]" )  );
+	    wrong_args((__extension__	({	char *__result;	if (__builtin_constant_p (      "-k[v][v][v][c] [userid] [keyring]"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "-k[v][v][v][c] [userid] [keyring]"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "-k[v][v][v][c] [userid] [keyring]"    ,   5  );	__result;	}))     );
 	break;
 
     
@@ -6562,7 +6725,7 @@
 	    wrong_args("--dearmor [file]");
 	rc = dearmor_file( argc? *argv: ((void *)0)  );
 	if( rc )
-	    log_error(( "dearmoring failed: %s\n" ) , g10_errstr(rc));
+	    log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "dearmoring failed: %s\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "dearmoring failed: %s\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "dearmoring failed: %s\n"    ,   5  );	__result;	}))    , g10_errstr(rc));
 	break;
 
       case aEnArmor:
@@ -6570,7 +6733,7 @@
 	    wrong_args("--enarmor [file]");
 	rc = enarmor_file( argc? *argv: ((void *)0)  );
 	if( rc )
-	    log_error(( "enarmoring failed: %s\n" ) , g10_errstr(rc));
+	    log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "enarmoring failed: %s\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "enarmoring failed: %s\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "enarmoring failed: %s\n"    ,   5  );	__result;	}))    , g10_errstr(rc));
 	break;
 
 
@@ -6651,9 +6814,9 @@
       default:
 	 
 	if( argc > 1 )
-	    wrong_args(( "[filename]" ) );
+	    wrong_args((__extension__	({	char *__result;	if (__builtin_constant_p (      "[filename]"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "[filename]"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "[filename]"    ,   5  );	__result;	}))    );
 	if( !(a = iobuf_open(fname)) )
-	    log_error(( "can't open '%s'\n" ) , print_fname_stdin(fname));
+	    log_error((__extension__	({	char *__result;	if (__builtin_constant_p (      "can't open '%s'\n"    ))	{	static char *__translation__;	static int __catalog_counter__;	if (! __translation__ || __catalog_counter__ != _nl_msg_cat_cntr) {	__translation__ =	dcgettext__ (  ((void *)0)   ,       "can't open '%s'\n"    ,   5  );	__catalog_counter__ = _nl_msg_cat_cntr;	}	__result = __translation__;	}	else	__result = dcgettext__ (  ((void *)0)   ,       "can't open '%s'\n"    ,   5  );	__result;	}))    , print_fname_stdin(fname));
 	else {
 	    if( !opt.no_armor ) {
 		if( use_armor_filter( a ) ) {
diff -urN gnupg-0.2.13/g10/getkey.c gnupg-0.2.14/g10/getkey.c
--- gnupg-0.2.13/g10/getkey.c	Mon Mar  9 13:07:42 1998
+++ gnupg-0.2.14/g10/getkey.c	Wed Apr  1 15:14:12 1998
@@ -68,10 +68,10 @@
 static int pkc_cache_entries;	/* number of entries in pkc cache */
 
 
-static int scan_keyring( PKT_public_cert *pkc, u32 *keyid,
-			 const char *name, const char *filename );
-static int scan_secret_keyring( PKT_secret_cert *skc, u32 *keyid,
-				const char *name, const char *filename);
+static int lookup( PKT_public_cert *pkc,
+		   int mode,  u32 *keyid, const char *name );
+static int lookup_skc( PKT_secret_cert *skc,
+		   int mode,  u32 *keyid, const char *name );
 
 /* note this function may be called before secure memory is
  * available */
@@ -81,8 +81,6 @@
     STRLIST sl;
     int rc;
 
-    /* FIXME: check wether this one is available etc */
-    /* maybe we should do this later */
     if( *name != '/' ) { /* do tilde expansion etc */
 	char *p ;
 
@@ -101,7 +99,7 @@
     sl->next = keyrings;
     keyrings = sl;
 
-    /* FIXME: We should remove much out of this module and
+    /* fixme: We should remove much out of this module and
      * combine it with the keyblock stuff from ringedit.c
      * For now we will simple add the filename as keyblock resource
      */
@@ -131,8 +129,6 @@
     STRLIST sl;
     int rc;
 
-    /* FIXME: check wether this one is available etc */
-    /* my be we should do this later */
     if( *name != '/' ) { /* do tilde expansion etc */
 	char *p ;
 
@@ -151,7 +147,7 @@
     sl->next = secret_keyrings;
     secret_keyrings = sl;
 
-    /* FIXME: We should remove much out of this mpdule and
+    /* fixme: We should remove much out of this mpdule and
      * combine it with the keyblock stuff from ringedit.c
      * For now we will simple add the filename as keyblock resource
      */
@@ -161,7 +157,7 @@
 }
 
 
-void
+static void
 cache_public_cert( PKT_public_cert *pkc )
 {
     pkc_cache_entry_t ce;
@@ -214,7 +210,7 @@
     for(r=user_id_db; r; r = r->next )
 	if( r->keyid[0] == keyid[0] && r->keyid[1] == keyid[1] ) {
 	    if( DBG_CACHE )
-		log_debug("cache_user_id: already in cache\n");
+	       log_debug("cache_user_id: already in cache\n");
 	    return;
 	}
 
@@ -241,7 +237,6 @@
     int internal = 0;
     int rc = 0;
     pkc_cache_entry_t ce;
-    STRLIST sl;
 
 
     /* lets see wether we checked the keyid already */
@@ -249,14 +244,13 @@
 	if( kl->keyid[0] == keyid[0] && kl->keyid[1] == keyid[1] )
 	    return G10ERR_NO_PUBKEY; /* already checked and not found */
 
-    /* 1. Try to get it from our cache */
+    /* Try to get it from our cache */
     for( ce = pkc_cache; ce; ce = ce->next )
 	if( ce->keyid[0] == keyid[0] && ce->keyid[1] == keyid[1] ) {
 	    if( pkc )
 		copy_public_cert( pkc, ce->pkc );
 	    return 0;
 	}
-
     /* more init stuff */
     if( !pkc ) {
 	pkc = m_alloc_clear( sizeof *pkc );
@@ -264,14 +258,12 @@
     }
 
 
-    /* 2. Try to get it from the keyrings */
-    for(sl = keyrings; sl; sl = sl->next )
-	if( !scan_keyring( pkc, keyid, NULL, sl->d ) )
-	    goto leave;
-
-    /* 3. Try to get it from a key server */
+    /* do a lookup */
+    rc = lookup( pkc, 11, keyid, NULL );
+    if( !rc )
+	goto leave;
 
-    /* 4. not found: store it for future reference */
+    /* not found: store it for future reference */
     kl = m_alloc( sizeof *kl );
     kl->keyid[0] = keyid[0];
     kl->keyid[1] = keyid[1];
@@ -288,6 +280,32 @@
 }
 
 
+static int
+hextobyte( const byte *s )
+{
+    int c;
+
+    if( *s >= '0' && *s <= '9' )
+	c = 16 * (*s - '0');
+    else if( *s >= 'A' && *s <= 'F' )
+	c = 16 * (10 + *s - 'A');
+    else if( *s >= 'a' && *s <= 'f' )
+	c = 16 * (10 + *s - 'a');
+    else
+	return -1;
+    s++;
+    if( *s >= '0' && *s <= '9' )
+	c += *s - '0';
+    else if( *s >= 'A' && *s <= 'F' )
+	c += 10 + *s - 'A';
+    else if( *s >= 'a' && *s <= 'f' )
+	c += 10 + *s - 'a';
+    else
+	return -1;
+    return c;
+}
+
+
 /****************
  * Try to get the pubkey by the userid. This functions looks for the
  * first pubkey certificate which has the given name in a user_id.
@@ -302,26 +320,30 @@
  *   (Not yet implemented)
  * - If the username starts with a left angle, we assume it is a complete
  *   email address and look only at this part.
+ * - If the username starts with a '.', we assume it is the ending
+ *   part of an email address
+ * - If the username starts with an '@', we assume it is a part of an
+ *   email address
  * - If the userid start with an '=' an exact compare is done; this may
  *   also follow the keyid in which case both parts are matched.
- *   (Not yet implemented)
- *
+ * - If the userid starts with a '*' a case insensitive substring search is
+ *   done (This is also the default).
  */
 int
 get_pubkey_byname( PKT_public_cert *pkc, const char *name )
 {
     int internal = 0;
     int rc = 0;
-    STRLIST sl;
     const char *s;
     u32 keyid[2] = {0}; /* init to avoid compiler warning */
-    int use_keyid=0;
+    byte fprint[20];
+    int mode = 0;
 
     /* check what kind of name it is */
     for(s = name; *s && isspace(*s); s++ )
 	;
-    if( isdigit( *s ) ) { /* a keyid */
-	int i;
+    if( isdigit( *s ) ) { /* a keyid or a fingerprint */
+	int i, j;
 	char buf[9];
 
 	if( *s == '0' && s[1] == 'x' && isxdigit(s[2]) )
@@ -334,7 +356,7 @@
 	    if( i==9 )
 		s++;
 	    keyid[1] = strtoul( s, NULL, 16 );
-	    use_keyid++;
+	    mode = 10;
 	}
 	else if( i == 16 || (i == 17 && *s == '0') ) { /* complete keyid */
 	    if( i==17 )
@@ -342,51 +364,73 @@
 	    mem2str(buf, s, 9 );
 	    keyid[0] = strtoul( buf, NULL, 16 );
 	    keyid[1] = strtoul( s+8, NULL, 16 );
-	    return get_pubkey( pkc, keyid );
+	    mode = 11;
+	}
+	else if( i == 32 || ( i == 33 && *s == '0' ) ) { /* md5 fingerprint */
+	    if( i==33 )
+		s++;
+	    memset(fprint+16, 4, 0);
+	    for(j=0; !rc && j < 16; j++, s+=2 ) {
+		int c = hextobyte( s );
+		if( c == -1 )
+		    rc = G10ERR_INV_USER_ID;
+		else
+		    fprint[j] = c;
+	    }
+	    mode = 16;
+	}
+	else if( i == 40 || ( i == 41 && *s == '0' ) ) { /* sha1/rmd160 fprint*/
+	    if( i==33 )
+		s++;
+	    for(j=0; !rc && j < 20; j++, s+=2 ) {
+		int c = hextobyte( s );
+		if( c == -1 )
+		    rc = G10ERR_INV_USER_ID;
+		else
+		    fprint[j] = c;
+	    }
+	    mode = 20;
 	}
 	else
 	    rc = G10ERR_INV_USER_ID;
     }
+    else if( *s == '=' ) { /* exact search */
+	mode = 1;
+	s++;
+    }
+    else if( *s == '*' ) { /* substring search */
+	mode = 2;
+	s++;
+    }
     else if( *s == '<' ) { /* an email address */
-	/* for now handled like a substring */
-	/* a keyserver might use this for quicker access */
+	mode = 3;
     }
-    else if( *s == '=' ) { /* exact search */
-	rc = G10ERR_INV_USER_ID; /* nox yet implemented */
+    else if( *s == '@' ) { /* a part of an email address */
+	mode = 4;
+	s++;
+    }
+    else if( *s == '.' ) { /* an email address, compare from end */
+	mode = 5;
+	s++;
     }
     else if( *s == '#' ) { /* use local id */
-	rc = G10ERR_INV_USER_ID; /* nox yet implemented */
-    }
-    else if( *s == '*' ) { /* substring search */
-	name++;
+	rc = G10ERR_INV_USER_ID; /* not yet implemented */
     }
     else if( !*s )  /* empty string */
 	rc = G10ERR_INV_USER_ID;
+    else
+	mode = 2;
 
     if( rc )
 	goto leave;
 
-
-
     if( !pkc ) {
 	pkc = m_alloc_clear( sizeof *pkc );
 	internal++;
     }
 
-    /* 2. Try to get it from the keyrings */
-    for(sl = keyrings; sl; sl = sl->next )
-	if( use_keyid ) {
-	    if( !scan_keyring( pkc, keyid, name, sl->d ) )
-		goto leave;
-	}
-	else {
-	    if( !scan_keyring( pkc, NULL, name, sl->d ) )
-		goto leave;
-	}
-    /* 3. Try to get it from a key server */
-
-    /* 4. not found: store it for future reference */
-    rc = G10ERR_NO_PUBKEY;
+    rc = mode < 16? lookup( pkc, mode, keyid, name )
+		  : lookup( pkc, mode, keyid, fprint );
 
   leave:
     if( internal )
@@ -401,23 +445,16 @@
 int
 get_seckey( PKT_secret_cert *skc, u32 *keyid )
 {
-    STRLIST sl;
-    int rc=0;
+    int rc;
 
-    for(sl = secret_keyrings; sl; sl = sl->next )
-	if( !(rc=scan_secret_keyring( skc, keyid, NULL, sl->d )) )
-	    goto found;
-    /* fixme: look at other places */
-    goto leave;
-
-  found:
-    /* get the secret key (this may prompt for a passprase to
-     * unlock the secret key
-     */
-    if( (rc = check_secret_key( skc )) )
-	goto leave;
+    rc = lookup_skc( skc, 11, keyid, NULL );
+    if( !rc ) {
+	/* check the secret key (this may prompt for a passprase to
+	 * unlock the secret key
+	 */
+	rc = check_secret_key( skc );
+    }
 
-  leave:
     return rc;
 }
 
@@ -430,18 +467,10 @@
 seckey_available( u32 *keyid )
 {
     PKT_secret_cert *skc;
-    STRLIST sl;
-    int rc=0;
+    int rc;
 
     skc = m_alloc_clear( sizeof *skc );
-    for(sl = secret_keyrings; sl; sl = sl->next )
-	if( !(rc=scan_secret_keyring( skc, keyid, NULL, sl->d )) )
-	    goto found;
-    /* fixme: look at other places */
-    goto leave;
-
-  found:
-  leave:
+    rc = lookup_skc( skc, 11, keyid, NULL );
     free_secret_cert( skc );
     return rc;
 }
@@ -455,286 +484,293 @@
 int
 get_seckey_byname( PKT_secret_cert *skc, const char *name, int unprotect )
 {
-    STRLIST sl;
-    int rc=0;
+    int rc;
 
-    for(sl = secret_keyrings; sl; sl = sl->next )
-	if( !(rc=scan_secret_keyring( skc, NULL, name, sl->d ) ) )
-	    goto found;
-    /* fixme: look at other places */
-    goto leave;
-
-  found:
-    /* get the secret key (this may prompt for a passprase to
-     * unlock the secret key
-     */
-    if( unprotect )
-	if( (rc = check_secret_key( skc )) )
-	    goto leave;
+    /* fixme: add support for compare_name */
+    rc = lookup_skc( skc, name? 2:15, NULL, name );
+    if( !rc && unprotect )
+	rc = check_secret_key( skc );
 
-  leave:
     return rc;
 }
 
 
+static int
+compare_name( const char *uid, size_t uidlen, const char *name, int mode )
+{
+    int i;
+
+    if( mode == 1 ) {  /* exact match */
+	for(i=0; name[i] && uidlen; i++, uidlen-- )
+	    if( uid[i] != name[i] )
+		break;
+	if( !uidlen && !name[i] )
+	    return 0; /* found */
+    }
+    else if( mode == 2 ) { /* case insensitive substring */
+	if( memistr( uid, uidlen, name ) )
+	    return 0;
+    }
+    else if( mode == 3 ) { /* case insensitive email address */
+	/* FIXME: not yet implemented */
+	if( memistr( uid, uidlen, name ) )
+	    return 0;
+    }
+    else if( mode == 4 ) { /* email substring */
+	/* FIXME: not yet implemented */
+	if( memistr( uid, uidlen, name ) )
+	    return 0;
+    }
+    else if( mode == 5 ) { /* email from end */
+	/* FIXME: not yet implemented */
+	if( memistr( uid, uidlen, name ) )
+	    return 0;
+    }
+    else
+	BUG();
 
+    return -1; /* not found */
+}
 
 
 /****************
- * scan the keyring and look for either the keyid or the name.
- * If both, keyid and name are given, look for keyid but use only
- * the low word of it (name is only used as a flag to indicate this mode
- * of operation).
+ * Lookup a key by scanning all keyrings
+ *   mode 1 = lookup by NAME (exact)
+ *	  2 = lookup by NAME (substring)
+ *	  3 = lookup by NAME (email address)
+ *	  4 = email address (substring)
+ *	  5 = email address (compare from end)
+ *	 10 = lookup by short KEYID (don't care about keyid[0])
+ *	 11 = lookup by long  KEYID
+ *	 15 = Get the first key.
+ *	 16 = lookup by 16 byte fingerprint which is stored in NAME
+ *	 20 = lookup by 20 byte fingerprint which is stored in NAME
+ * Caller must provide an empty PKC, if the pubkey_algo is filled in, only
+ * a key of this algo will be returned.
  */
 static int
-scan_keyring( PKT_public_cert *pkc, u32 *keyid,
-	      const char *name, const char *filename )
+lookup( PKT_public_cert *pkc, int mode,  u32 *keyid, const char *name )
 {
-    compress_filter_context_t cfx;
-    int rc=0;
-    int found = 0;
-    IOBUF a;
-    PACKET pkt;
-    int save_mode;
-    u32 akeyid[2];
-    PKT_public_cert *last_pk = NULL;
-    int shortkeyid;
-
-    shortkeyid = keyid && name;
-    if( shortkeyid )
-	name = NULL; /* not used anymore */
-
-    if( !(a = iobuf_open( filename ) ) ) {
-	log_debug("scan_keyring: can't open '%s'\n", filename );
-	return G10ERR_KEYRING_OPEN;
-    }
-
-    if( !DBG_CACHE )
-	;
-    else if( shortkeyid )
-	log_debug("scan_keyring %s for %08lx\n",  filename, (ulong)keyid[1] );
-    else if( name )
-	log_debug("scan_keyring %s for '%s'\n",  filename, name );
-    else if( keyid )
-	log_debug("scan_keyring %s for %08lx %08lx\n",  filename,
-					     (ulong)keyid[0], (ulong)keyid[1] );
-    else
-	log_debug("scan_keyring %s (all)\n",  filename );
+    int rc;
+    KBNODE keyblock = NULL;
+    KBPOS kbpos;
 
-    save_mode = set_packet_list_mode(0);
-    init_packet(&pkt);
-    while( (rc=parse_packet(a, &pkt)) != -1 ) {
-	if( rc )
-	    ; /* e.g. unknown packet */
-	else if( keyid && found && pkt.pkttype == PKT_PUBLIC_CERT ) {
-	    log_error("Hmmm, pubkey without an user id in '%s'\n", filename);
-	    goto leave;
-	}
-	else if( pkt.pkttype == PKT_COMPRESSED ) {
-	    memset( &cfx, 0, sizeof cfx );
-	    if( pkt.pkt.compressed->algorithm == 1 )
-		cfx.pgpmode = 1;
-	    else if( pkt.pkt.compressed->algorithm != 2  ){
-		rc = G10ERR_COMPR_ALGO;
-		log_error("compressed keyring: %s\n", g10_errstr(rc) );
-		break;
-	    }
+    rc = enum_keyblocks( 0, &kbpos, &keyblock );
+    if( rc ) {
+	if( rc == -1 )
+	    rc = G10ERR_NO_PUBKEY;
+	else if( rc )
+	    log_error("enum_keyblocks(open) failed: %s\n", g10_errstr(rc) );
+	goto leave;
+    }
 
-	    pkt.pkt.compressed->buf = NULL;
-	    iobuf_push_filter( a, compress_filter, &cfx );
-	}
-	else if( keyid && pkt.pkttype == PKT_PUBLIC_CERT ) {
-	    switch( pkt.pkt.public_cert->pubkey_algo ) {
-	      case PUBKEY_ALGO_ELGAMAL:
-	      case PUBKEY_ALGO_DSA:
-	      case PUBKEY_ALGO_RSA:
-		keyid_from_pkc( pkt.pkt.public_cert, akeyid );
-		if( (shortkeyid || akeyid[0] == keyid[0])
-		    && akeyid[1] == keyid[1] ) {
-		    copy_public_cert( pkc, pkt.pkt.public_cert );
-		    found++;
-		}
-		break;
-	      default:
-		log_error("cannot handle pubkey algo %d\n",
-				     pkt.pkt.public_cert->pubkey_algo);
-	    }
-	}
-	else if( keyid && found && pkt.pkttype == PKT_USER_ID ) {
-	    cache_user_id( pkt.pkt.user_id, keyid );
-	    goto leave;
-	}
-	else if( name && pkt.pkttype == PKT_PUBLIC_CERT ) {
-	    if( last_pk )
-		free_public_cert(last_pk);
-	    last_pk = pkt.pkt.public_cert;
-	    pkt.pkt.public_cert = NULL;
-	}
-	else if( name && pkt.pkttype == PKT_USER_ID ) {
-	    if( memistr( pkt.pkt.user_id->name, pkt.pkt.user_id->len, name )) {
-		if( !last_pk )
-		    log_error("Ooops: no pubkey for userid '%.*s'\n",
-				pkt.pkt.user_id->len, pkt.pkt.user_id->name);
-		else if( pkc->pubkey_algo &&
-			 pkc->pubkey_algo != last_pk->pubkey_algo )
-		    log_info("skipping id '%.*s': want algo %d, found %d\n",
-				pkt.pkt.user_id->len, pkt.pkt.user_id->name,
-				pkc->pubkey_algo, last_pk->pubkey_algo );
-		else {
-		    copy_public_cert( pkc, last_pk );
-		    goto leave;
+    while( !(rc = enum_keyblocks( 1, &kbpos, &keyblock )) ) {
+	KBNODE k, kk;
+	if( mode < 10 ) { /* name lookup */
+	    for(k=keyblock; k; k = k->next ) {
+		if( k->pkt->pkttype == PKT_USER_ID
+		    && !compare_name( k->pkt->pkt.user_id->name,
+				      k->pkt->pkt.user_id->len, name, mode)) {
+		    /* we found a matching name, look for the key */
+		    for(kk=keyblock; kk; kk = kk->next )
+			if( (	 kk->pkt->pkttype == PKT_PUBLIC_CERT
+			      || kk->pkt->pkttype == PKT_PUBKEY_SUBCERT )
+			    && ( !pkc->pubkey_algo
+				 || pkc->pubkey_algo
+				    == kk->pkt->pkt.public_cert->pubkey_algo))
+			break;
+		    if( kk ) {
+			u32 aki[2];
+			keyid_from_pkc( kk->pkt->pkt.public_cert, aki );
+			cache_user_id( k->pkt->pkt.user_id, aki );
+			k = kk;
+			break;
+		    }
+		    else
+			log_error("No key for userid\n");
 		}
 	    }
 	}
-	else if( !keyid && !name && pkt.pkttype == PKT_PUBLIC_CERT ) {
-	    if( last_pk )
-		free_public_cert(last_pk);
-	    last_pk = pkt.pkt.public_cert;
-	    pkt.pkt.public_cert = NULL;
-	}
-	else if( !keyid && !name && pkt.pkttype == PKT_USER_ID ) {
-	    if( !last_pk )
-		log_error("Ooops: no pubkey for userid '%.*s'\n",
-			    pkt.pkt.user_id->len, pkt.pkt.user_id->name);
-	    else {
-		if( last_pk->pubkey_algo == PUBKEY_ALGO_ELGAMAL
-		    || last_pk->pubkey_algo == PUBKEY_ALGO_DSA
-		    || last_pk->pubkey_algo == PUBKEY_ALGO_RSA ) {
-		     keyid_from_pkc( last_pk, akeyid );
-		     cache_user_id( pkt.pkt.user_id, akeyid );
-		}
-		cache_public_cert( last_pk );
+	else { /* keyid or fingerprint lookup */
+	    for(k=keyblock; k; k = k->next ) {
+		if(    k->pkt->pkttype == PKT_PUBLIC_CERT
+		    || k->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
+		    if( mode == 10 || mode == 11 ) {
+			u32 aki[2];
+			keyid_from_pkc( k->pkt->pkt.public_cert, aki );
+			if( aki[1] == keyid[1]
+			    && ( mode == 10 || aki[0] == keyid[0] )
+			    && ( !pkc->pubkey_algo
+				 || pkc->pubkey_algo
+				    == k->pkt->pkt.public_cert->pubkey_algo) ){
+			    /* cache the userid */
+			    for(kk=keyblock; kk; kk = kk->next )
+				if( kk->pkt->pkttype == PKT_USER_ID )
+				    break;
+			    if( kk )
+				cache_user_id( kk->pkt->pkt.user_id, aki );
+			    else
+				log_error("No userid for key\n");
+			    break; /* found */
+			}
+		    }
+		    else if( mode == 15 ) { /* get the first key */
+			if( !pkc->pubkey_algo
+			    || pkc->pubkey_algo
+				  == k->pkt->pkt.public_cert->pubkey_algo )
+			    break;
+		    }
+		    else if( mode == 16 || mode == 20 ) {
+			size_t an;
+			byte *afp = fingerprint_from_pkc(
+					k->pkt->pkt.public_cert, &an );
+			if( an == mode && !memcmp( afp, name, an)
+			    && ( !pkc->pubkey_algo
+				 || pkc->pubkey_algo
+				    == k->pkt->pkt.public_cert->pubkey_algo) ) {
+			    m_free(afp);
+			    break;
+			}
+			m_free(afp);
+		    }
+		    else
+			BUG();
+		} /* end compare public keys */
 	    }
 	}
-	free_packet(&pkt);
-    }
-    rc = G10ERR_NO_PUBKEY;
+	if( k ) { /* found */
+	    assert(    k->pkt->pkttype == PKT_PUBLIC_CERT
+		    || k->pkt->pkttype == PKT_PUBKEY_SUBCERT );
+	    copy_public_cert( pkc, k->pkt->pkt.public_cert );
+	    break; /* enumeration */
+	}
+	release_kbnode( keyblock );
+	keyblock = NULL;
+    }
+    if( rc == -1 )
+	rc = G10ERR_NO_PUBKEY;
+    else if( rc )
+	log_error("enum_keyblocks(read) failed: %s\n", g10_errstr(rc));
 
   leave:
-    if( last_pk )
-	free_public_cert(last_pk);
-    free_packet(&pkt);
-    iobuf_close(a);
-    set_packet_list_mode(save_mode);
+    enum_keyblocks( 2, &kbpos, &keyblock ); /* close */
+    release_kbnode( keyblock );
     return rc;
 }
 
-
 /****************
- * This is the function to get a secret key. We use an extra function,
- * so that we can easily add special handling for secret keyrings
- * PKT returns the secret key certificate.
+ * Ditto for secret keys
  */
 static int
-scan_secret_keyring( PKT_secret_cert *skc, u32 *keyid,
-		     const char *name, const char *filename )
+lookup_skc( PKT_secret_cert *skc, int mode,  u32 *keyid, const char *name )
 {
-    int rc=0;
-    int found = 0;
-    IOBUF a;
-    PACKET pkt;
-    int save_mode;
-    u32 akeyid[2];
-    PKT_secret_cert *last_pk = NULL;
-    int get_first;
-    u32 dummy_keyid[2];
-
-    get_first = !keyid && !name;
-    if( get_first )
-	keyid = dummy_keyid;
-
-    if( !(a = iobuf_open( filename ) ) ) {
-	log_debug("scan_secret_keyring: can't open '%s'\n", filename );
-	return G10ERR_KEYRING_OPEN;
-    }
-
-    save_mode = set_packet_list_mode(0);
-    init_packet(&pkt);
-    while( (rc=parse_packet(a, &pkt)) != -1 ) {
-	if( rc )
-	    ; /* e.g. unknown packet */
-	else if( keyid && found && pkt.pkttype == PKT_SECRET_CERT ) {
-	    log_error("Hmmm, seckey without an user id in '%s'\n", filename);
-	    goto leave;
-	}
-	else if( keyid && pkt.pkttype == PKT_SECRET_CERT ) {
-	    switch( pkt.pkt.secret_cert->pubkey_algo ) {
-	      case PUBKEY_ALGO_ELGAMAL:
-	      case PUBKEY_ALGO_DSA:
-	      case PUBKEY_ALGO_RSA:
-		if( get_first ) {
-		    copy_secret_cert( skc, pkt.pkt.secret_cert );
-		    found++;
-		}
-		else {
-		    keyid_from_skc( pkt.pkt.secret_cert, akeyid );
-		    if( (akeyid[0] == keyid[0] && akeyid[1] == keyid[1]) ) {
-			copy_secret_cert( skc, pkt.pkt.secret_cert );
-			found++;
+    int rc;
+    KBNODE keyblock = NULL;
+    KBPOS kbpos;
+
+    rc = enum_keyblocks( 5 /* open secret */, &kbpos, &keyblock );
+    if( rc ) {
+	if( rc == -1 )
+	    rc = G10ERR_NO_PUBKEY;
+	else if( rc )
+	    log_error("enum_keyblocks(open secret) failed: %s\n", g10_errstr(rc) );
+	goto leave;
+    }
+
+    while( !(rc = enum_keyblocks( 1, &kbpos, &keyblock )) ) {
+	KBNODE k, kk;
+	if( mode < 10 ) { /* name lookup */
+	    for(k=keyblock; k; k = k->next ) {
+		if( k->pkt->pkttype == PKT_USER_ID
+		    && !compare_name( k->pkt->pkt.user_id->name,
+				      k->pkt->pkt.user_id->len, name, mode)) {
+		    /* we found a matching name, look for the key */
+		    for(kk=keyblock; kk; kk = kk->next )
+			if( (	 kk->pkt->pkttype == PKT_SECRET_CERT
+			      || kk->pkt->pkttype == PKT_SECKEY_SUBCERT )
+			    && ( !skc->pubkey_algo
+				 || skc->pubkey_algo
+				    == kk->pkt->pkt.secret_cert->pubkey_algo))
+			break;
+		    if( kk ) {
+			u32 aki[2];
+			keyid_from_skc( kk->pkt->pkt.secret_cert, aki );
+			cache_user_id( k->pkt->pkt.user_id, aki );
+			k = kk;
+			break;
 		    }
-		}
-		break;
-	      default:
-		log_error("cannot handle pubkey algo %d\n",
-				     pkt.pkt.secret_cert->pubkey_algo);
-	    }
-	}
-	else if( keyid && found && pkt.pkttype == PKT_USER_ID ) {
-	    goto leave;
-	}
-	else if( name && pkt.pkttype == PKT_SECRET_CERT ) {
-	    if( last_pk )
-		free_secret_cert(last_pk);
-	    last_pk = pkt.pkt.secret_cert;
-	    pkt.pkt.secret_cert = NULL;
-	}
-	else if( name && pkt.pkttype == PKT_USER_ID ) {
-	    if( memistr( pkt.pkt.user_id->name, pkt.pkt.user_id->len, name )) {
-		if( !last_pk )
-		    log_error("Ooops: no seckey for userid '%.*s'\n",
-				pkt.pkt.user_id->len, pkt.pkt.user_id->name);
-		else if( skc->pubkey_algo &&
-			 skc->pubkey_algo != last_pk->pubkey_algo )
-		    log_info("skipping id '%.*s': want algo %d, found %d\n",
-				pkt.pkt.user_id->len, pkt.pkt.user_id->name,
-				skc->pubkey_algo, last_pk->pubkey_algo );
-		else {
-		    copy_secret_cert( skc, last_pk );
-		    goto leave;
+		    else
+			log_error("No key for userid (in skc)\n");
 		}
 	    }
 	}
-	else if( !keyid && !name && pkt.pkttype == PKT_SECRET_CERT ) {
-	    if( last_pk )
-		free_secret_cert(last_pk);
-	    last_pk = pkt.pkt.secret_cert;
-	    pkt.pkt.secret_cert = NULL;
-	}
-	else if( !keyid && !name && pkt.pkttype == PKT_USER_ID ) {
-	    if( !last_pk )
-		log_error("Ooops: no seckey for userid '%.*s'\n",
-			    pkt.pkt.user_id->len, pkt.pkt.user_id->name);
-	    else {
-		if( last_pk->pubkey_algo == PUBKEY_ALGO_ELGAMAL
-		   || last_pk->pubkey_algo == PUBKEY_ALGO_DSA
-		   || last_pk->pubkey_algo == PUBKEY_ALGO_RSA ) {
-		    keyid_from_skc( last_pk, akeyid );
-		    cache_user_id( pkt.pkt.user_id, akeyid );
-		}
+	else { /* keyid or fingerprint lookup */
+	    for(k=keyblock; k; k = k->next ) {
+		if(    k->pkt->pkttype == PKT_SECRET_CERT
+		    || k->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
+		    if( mode == 10 || mode == 11 ) {
+			u32 aki[2];
+			keyid_from_skc( k->pkt->pkt.secret_cert, aki );
+			if( aki[1] == keyid[1]
+			    && ( mode == 10 || aki[0] == keyid[0] )
+			    && ( !skc->pubkey_algo
+				 || skc->pubkey_algo
+				    == k->pkt->pkt.secret_cert->pubkey_algo) ){
+			    /* cache the userid */
+			    for(kk=keyblock; kk; kk = kk->next )
+				if( kk->pkt->pkttype == PKT_USER_ID )
+				    break;
+			    if( kk )
+				cache_user_id( kk->pkt->pkt.user_id, aki );
+			    else
+				log_error("No userid for key\n");
+			    break; /* found */
+			}
+		    }
+		    else if( mode == 15 ) { /* get the first key */
+			if( !skc->pubkey_algo
+			    || skc->pubkey_algo
+				  == k->pkt->pkt.secret_cert->pubkey_algo )
+			    break;
+		    }
+		    else if( mode == 16 || mode == 20 ) {
+			size_t an;
+			byte *afp = fingerprint_from_skc(
+					k->pkt->pkt.secret_cert, &an );
+			if( an == mode && !memcmp( afp, name, an)
+			    && ( !skc->pubkey_algo
+				 || skc->pubkey_algo
+				    == k->pkt->pkt.secret_cert->pubkey_algo) ) {
+			    m_free(afp);
+			    break;
+			}
+			m_free(afp);
+		    }
+		    else
+			BUG();
+		} /* end compare secret keys */
 	    }
 	}
-	free_packet(&pkt);
-    }
-    rc = G10ERR_NO_SECKEY;
+	if( k ) { /* found */
+	    assert(    k->pkt->pkttype == PKT_SECRET_CERT
+		    || k->pkt->pkttype == PKT_SECKEY_SUBCERT );
+	    copy_secret_cert( skc, k->pkt->pkt.secret_cert );
+	    break; /* enumeration */
+	}
+	release_kbnode( keyblock );
+	keyblock = NULL;
+    }
+    if( rc == -1 )
+	rc = G10ERR_NO_PUBKEY;
+    else if( rc )
+	log_error("enum_keyblocks(read) failed: %s\n", g10_errstr(rc));
 
   leave:
-    if( last_pk )
-	free_secret_cert(last_pk);
-    free_packet(&pkt);
-    iobuf_close(a);
-    set_packet_list_mode(save_mode);
+    enum_keyblocks( 2, &kbpos, &keyblock ); /* close */
+    release_kbnode( keyblock );
     return rc;
 }
+
 
 
 /****************
diff -urN gnupg-0.2.13/g10/import.c gnupg-0.2.14/g10/import.c
--- gnupg-0.2.13/g10/import.c	Sat Mar  7 11:56:51 1998
+++ gnupg-0.2.14/g10/import.c	Wed Apr  1 15:19:14 1998
@@ -580,7 +580,7 @@
  *
  * o compare the signatures: If we already have this signature, check
  *   that they compare okay; if not, issue a warning and ask the user.
- *   FIXME: add the check, that we don` have duplicate signatures and the
+ *   FIXME: add the check, that we don't have duplicate signatures and the
  *   warning in cases that the old/new signatures don't match.
  * o Simply add the signature.	Can't verify here because we may not have
  *   the signatures public key yet; verification is done when putting it
diff -urN gnupg-0.2.13/g10/keydb.h gnupg-0.2.14/g10/keydb.h
--- gnupg-0.2.13/g10/keydb.h	Tue Mar  3 10:17:59 1998
+++ gnupg-0.2.14/g10/keydb.h	Thu Mar 19 15:39:26 1998
@@ -52,6 +52,7 @@
     ulong offset;    /* position information */
     unsigned count;  /* length of the keyblock in packets */
     IOBUF  fp;	     /* used by enum_keyblocks */
+    int secret;      /* working on a secret keyring */
     PACKET *pkt;     /* ditto */
 };
 typedef struct keyblock_pos_struct KBPOS;
@@ -102,8 +103,8 @@
 void add_keyring( const char *name );
 const char *get_keyring( int sequence );
 void add_secret_keyring( const char *name );
-void cache_public_cert( PKT_public_cert *pkc );
-void cache_user_id( PKT_user_id *uid, u32 *keyid );
+/*void cache_public_cert( PKT_public_cert *pkc );
+void cache_user_id( PKT_user_id *uid, u32 *keyid );*/
 int get_pubkey( PKT_public_cert *pkc, u32 *keyid );
 int get_pubkey_byname( PKT_public_cert *pkc, const char *name );
 int get_seckey( PKT_secret_cert *skc, u32 *keyid );
diff -urN gnupg-0.2.13/g10/keygen.c gnupg-0.2.14/g10/keygen.c
--- gnupg-0.2.13/g10/keygen.c	Wed Mar  4 10:57:15 1998
+++ gnupg-0.2.14/g10/keygen.c	Thu Apr  2 11:12:07 1998
@@ -34,11 +34,6 @@
 #include "keydb.h"
 #include "i18n.h"
 
-#if 0
-  #define TEST_ALGO  1
-  #define TEST_NBITS 256
-  #define TEST_UID   "Karl Test"
-#endif
 
 #if defined(HAVE_RSA_CIPHER) && 0
   #define ENABLE_RSA_KEYGEN 1
@@ -136,7 +131,7 @@
 
 static int
 gen_elg(unsigned nbits, KBNODE pub_root, KBNODE sec_root, DEK *dek,
-	byte *salt, PKT_secret_cert **ret_skc )
+	byte *salt, PKT_secret_cert **ret_skc, u16 valid_days )
 {
     int rc;
     int i;
@@ -152,7 +147,7 @@
     skc = m_alloc_clear( sizeof *skc );
     pkc = m_alloc_clear( sizeof *pkc );
     skc->timestamp = pkc->timestamp = make_timestamp();
-    skc->valid_days = pkc->valid_days = 0; /* fixme: make it configurable*/
+    skc->valid_days = pkc->valid_days = valid_days;
     skc->pubkey_algo = pkc->pubkey_algo = PUBKEY_ALGO_ELGAMAL;
 		       pkc->d.elg.p = pk.p;
 		       pkc->d.elg.g = pk.g;
@@ -161,19 +156,19 @@
     skc->d.elg.g = sk.g;
     skc->d.elg.y = sk.y;
     skc->d.elg.x = sk.x;
-    skc->d.elg.is_protected = 0;
-    skc->d.elg.protect.algo = 0;
+    skc->is_protected = 0;
+    skc->protect.algo = 0;
 
-    skc->d.elg.csum = checksum_mpi( skc->d.elg.x );
+    skc->csum = checksum_mpi( skc->d.elg.x );
     /* return an unprotected version of the skc */
     *ret_skc = copy_secret_cert( NULL, skc );
 
     if( dek ) {
-	skc->d.elg.protect.algo = CIPHER_ALGO_BLOWFISH;
-	skc->d.elg.protect.s2k	= 1;
-	skc->d.elg.protect.hash = DIGEST_ALGO_RMD160;
-	memcpy(skc->d.elg.protect.salt, salt, 8);
-	randomize_buffer(skc->d.elg.protect.iv, 8, 1);
+	skc->protect.algo = CIPHER_ALGO_BLOWFISH;
+	skc->protect.s2k  = 1;
+	skc->protect.hash = DIGEST_ALGO_RMD160;
+	memcpy(skc->protect.salt, salt, 8);
+	randomize_buffer(skc->protect.iv, 8, 1);
 	rc = protect_secret_key( skc, dek );
 	if( rc ) {
 	    log_error("protect_secret_key failed: %s\n", g10_errstr(rc) );
@@ -206,7 +201,7 @@
 #ifdef ENABLE_RSA_KEYGEN
 static int
 gen_rsa(unsigned nbits, KBNODE pub_root, KBNODE sec_root, DEK *dek,
-	byte *salt, PKT_secret_cert **ret_skc )
+	byte *salt, PKT_secret_cert **ret_skc, u16 valid_days )
 {
     int rc;
     PACKET *pkt;
@@ -220,7 +215,7 @@
     skc = m_alloc_clear( sizeof *skc );
     pkc = m_alloc_clear( sizeof *pkc );
     skc->timestamp = pkc->timestamp = make_timestamp();
-    skc->valid_days = pkc->valid_days = 0; /* fixme: make it configurable*/
+    skc->valid_days = pkc->valid_days = valid_days;
     skc->pubkey_algo = pkc->pubkey_algo = PUBKEY_ALGO_RSA;
 		       memset(&pkc->mfx, 0, sizeof pkc->mfx);
 		       pkc->d.rsa.rsa_n = pk.n;
@@ -270,7 +265,7 @@
 
 static int
 gen_dsa(unsigned nbits, KBNODE pub_root, KBNODE sec_root, DEK *dek,
-	 byte *salt, PKT_secret_cert **ret_skc )
+	 byte *salt, PKT_secret_cert **ret_skc, u16 valid_days )
 {
     return G10ERR_GENERAL;
 }
@@ -278,6 +273,34 @@
 
 
 /****************
+ * check valid days:
+ * return 0 on error or the multiplier
+ */
+static int
+check_valid_days( const char *s )
+{
+    if( !isdigit(*s) )
+	return 0;
+    for( s++; *s; s++)
+	if( !isdigit(*s) )
+	    break;
+    if( !*s )
+	return 1;
+    if( s[1] )
+	return 0; /* e.g. "2323wc" */
+    if( *s == 'd' || *s == 'D' )
+	return 1;
+    if( *s == 'w' || *s == 'W' )
+	return 7;
+    if( *s == 'm' || *s == 'M' )
+	return 30;
+    if( *s == 'y' || *s == 'Y' )
+	return 365;
+    return 0;
+}
+
+
+/****************
  * Generate a keypair
  */
 void
@@ -297,8 +320,8 @@
     int algo;
     const char *algo_name;
     char *aname, *acomment, *amail;
+    int valid_days=0;
 
-#ifndef TEST_ALGO
     if( opt.batch || opt.answer_yes || opt.answer_no ) {
 	log_error(_("Key generation can only be used in interactive mode\n"));
 	return;
@@ -310,21 +333,16 @@
   #ifdef ENABLE_RSA_KEYGEN
     tty_printf(_("   (3) RSA cannot be used in the U.S.\n"));
   #endif
-#endif
 
     for(;;) {
-      #ifdef TEST_ALGO
-	algo = TEST_ALGO;
+      #ifdef ENABLE_RSA_KEYGEN
+	answer = tty_get(_("Your selection? (1,2,3) "));
       #else
-	#ifdef ENABLE_RSA_KEYGEN
-	  answer = tty_get(_("Your selection? (1,2,3) "));
-       #else
-	  answer = tty_get(_("Your selection? (1,2) "));
-       #endif
+	answer = tty_get(_("Your selection? (1,2) "));
+      #endif
 	tty_kill_prompt();
 	algo = *answer? atoi(answer): 1;
 	m_free(answer);
-      #endif
 	if( algo == 1 ) {
 	    algo = PUBKEY_ALGO_ELGAMAL;
 	    algo_name = "ElGamal";
@@ -333,7 +351,7 @@
 	else if( algo == 2 ) {
 	    algo = PUBKEY_ALGO_DSA;
 	    algo_name = "DSA";
-	    tty_printf(_("Sorry; DSA is not yet supported.\n"));
+	    tty_printf(_("Sorry; DSA key generation is not yet supported.\n"));
 	}
       #ifdef ENABLE_RSA_KEYGEN
 	else if( algo == 3 ) {
@@ -351,14 +369,10 @@
 		 "              default keysize is 1024 bits\n"
 		 "    highest suggested keysize is 2048 bits\n"), algo_name );
     for(;;) {
-      #ifdef TEST_NBITS
-	nbits = TEST_NBITS;
-      #else
 	answer = tty_get(_("What keysize do you want? (1024) "));
 	tty_kill_prompt();
 	nbits = *answer? atoi(answer): 1024;
 	m_free(answer);
-      #endif
 	if( algo == PUBKEY_ALGO_DSA && (nbits < 512 || nbits > 1024) )
 	    tty_printf(_("DSA does only allow keysizes from 512 to 1024\n"));
 	else if( nbits < 768 )
@@ -377,6 +391,15 @@
 	    }
 	    m_free(answer);
 	}
+	else if( nbits > 1536 ) {
+	    answer = tty_get(_("Do you really need such a large keysize? "));
+	    tty_kill_prompt();
+	    if( answer_is_yes(answer) ) {
+		m_free(answer);
+		break;
+	    }
+	    m_free(answer);
+	}
 	else
 	    break;
     }
@@ -390,14 +413,53 @@
 	tty_printf(_("rounded up to %u bits\n"), nbits );
     }
 
-  #ifdef TEST_UID
-    uid = m_alloc(strlen(TEST_UID)+1);
-    strcpy(uid, TEST_UID);
-  #else
+    tty_printf(_("Please specify how long the key should be valid.\n"
+		 "         0 = key does not expire\n"
+		 "      <n>  = key expires in n days\n"
+		 "      <n>w = key expires in n weeks\n"
+		 "      <n>m = key expires in n months\n"
+		 "      <n>y = key expires in n years\n"));
+    answer = NULL;
+    for(;;) {
+	int mult;
+
+	m_free(answer);
+	answer = tty_get(_("Key is valid for? (0) "));
+	tty_kill_prompt();
+	trim_spaces(answer);
+	if( !*answer )
+	    valid_days = 0;
+	else if( (mult=check_valid_days(answer)) ) {
+	    valid_days = atoi(answer) * mult;
+	    if( valid_days < 0 || valid_days > 32767 )
+		valid_days = 0;
+	}
+	else {
+	    tty_printf(_("invalid value\n"));
+	    continue;
+	}
+
+	if( !valid_days )
+	    tty_printf(_("Key does not expire at all\n"));
+	else {
+	    tty_printf(_("Key expires at %s\n"), strtimestamp(
+		       add_days_to_timestamp( make_timestamp(), valid_days )));
+	}
+
+	m_free(answer);
+	answer = tty_get(_("Is this correct (y/n)? "));
+	tty_kill_prompt();
+	if( answer_is_yes(answer) )
+	    break;
+    }
+    m_free(answer);
+
+
+
     tty_printf( _("\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
 "from Real Name, Comment and Email Address in this form:\n"
-"    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n\n") );
+"    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n\n") );
     uid = NULL;
     aname=acomment=amail=NULL;
     for(;;) {
@@ -469,6 +531,7 @@
 
 
 	tty_printf(_("You selected this USER-ID:\n    \"%s\"\n\n"), uid);
+	/* fixme: add a warning if this the user-id already exists */
 	for(;;) {
 	    answer = tty_get(_("Edit (N)ame, (C)omment, (E)mail or (O)kay? "));
 	    tty_kill_prompt();
@@ -499,7 +562,6 @@
 	    break;
 	m_free(uid); uid = NULL;
     }
-  #endif
 
 
     tty_printf(_("You need a Passphrase to protect your secret key.\n\n") );
@@ -555,13 +617,13 @@
 "number generator a better chance to gain enough entropy.\n") );
 
     if( algo == PUBKEY_ALGO_ELGAMAL )
-	rc = gen_elg(nbits, pub_root, sec_root, dek, salt,  &skc );
+	rc = gen_elg(nbits, pub_root, sec_root, dek, salt,  &skc, valid_days );
   #ifdef ENABLE_RSA_KEYGEN
     else if( algo == PUBKEY_ALGO_RSA )
-	rc = gen_rsa(nbits, pub_root, sec_root, dek, salt, &skc );
+	rc = gen_rsa(nbits, pub_root, sec_root, dek, salt, &skc, valid_days  );
   #endif
     else if( algo == PUBKEY_ALGO_DSA )
-	rc = gen_dsa(nbits, pub_root, sec_root, dek, salt, &skc );
+	rc = gen_dsa(nbits, pub_root, sec_root, dek, salt, &skc, valid_days  );
     else
 	BUG();
     if( !rc ) {
@@ -588,7 +650,6 @@
 	int rc2 = -1;
 
 	/* we can now write the certificates */
-	/* FIXME: should we check wether the user-id already exists? */
 
 	if( get_keyblock_handle( pub_fname, 0, &pub_kbpos ) ) {
 	    if( add_keyblock_resource( pub_fname, 1, 0 ) ) {
diff -urN gnupg-0.2.13/g10/keyid.c gnupg-0.2.14/g10/keyid.c
--- gnupg-0.2.13/g10/keyid.c	Mon Mar  9 19:57:45 1998
+++ gnupg-0.2.14/g10/keyid.c	Wed Apr  1 11:33:27 1998
@@ -106,6 +106,56 @@
 }
 
 static MD_HANDLE
+elg_fingerprint_md( PKT_public_cert *pkc )
+{
+    MD_HANDLE md;
+    byte *buf1, *buf3, *buf4 ;
+    byte *p1, *p3, *p4;
+    unsigned n1, n3, n4;
+    unsigned nb1, nb3, nb4;
+    unsigned n;
+
+    nb1 = mpi_get_nbits(pkc->d.elg.p);
+    p1 = buf1 = mpi_get_buffer( pkc->d.elg.p, &n1, NULL );
+    for( ; !*p1 && n1; p1++, n1-- )  /* skip leading null bytes */
+	;
+    nb3 = mpi_get_nbits(pkc->d.elg.g);
+    p3 = buf3 = mpi_get_buffer( pkc->d.elg.g, &n3, NULL );
+    for( ; !*p3 && n3; p3++, n3-- )
+	;
+    nb4 = mpi_get_nbits(pkc->d.elg.y);
+    p4 = buf4 = mpi_get_buffer( pkc->d.elg.y, &n4, NULL );
+    for( ; !*p4 && n4; p4++, n4-- )
+	;
+
+    /* calculate length of packet */
+    n = 12 + n1 + n3 +n4 ;
+    md = md_open( DIGEST_ALGO_SHA1, 0);
+
+    md_putc( md, 0x99 );     /* ctb */
+    md_putc( md, n >> 8 );   /* 2 byte length header */
+    md_putc( md, n );
+    md_putc( md, 4 );	     /* version */
+    {	u32 a = pkc->timestamp;
+	md_putc( md, a >> 24 );
+	md_putc( md, a >> 16 );
+	md_putc( md, a >>  8 );
+	md_putc( md, a	     );
+    }
+    md_putc( md, pkc->pubkey_algo );
+    md_putc( md, nb1>>8); md_putc( md, nb1 ); md_write( md, p1, n1 );
+    md_putc( md, nb3>>8); md_putc( md, nb3 ); md_write( md, p3, n3 );
+    md_putc( md, nb4>>8); md_putc( md, nb4 ); md_write( md, p4, n4 );
+    m_free(buf1);
+    m_free(buf3);
+    m_free(buf4);
+    md_final( md );
+
+    return md;
+}
+
+
+static MD_HANDLE
 dsa_fingerprint_md( PKT_public_cert *pkc )
 {
     MD_HANDLE md;
@@ -161,18 +211,22 @@
 }
 
 static MD_HANDLE
-v3_elg_fingerprint_md_skc( PKT_secret_cert *skc )
+elg_fingerprint_md_skc( PKT_secret_cert *skc )
 {
     PKT_public_cert pkc;
 
     pkc.pubkey_algo = skc->pubkey_algo;
+    pkc.version     = skc->version;
     pkc.timestamp = skc->timestamp;
     pkc.valid_days = skc->valid_days;
     pkc.pubkey_algo = skc->pubkey_algo;
     pkc.d.elg.p = skc->d.elg.p;
     pkc.d.elg.g = skc->d.elg.g;
     pkc.d.elg.y = skc->d.elg.y;
-    return v3_elg_fingerprint_md( &pkc );
+    if( pkc.version < 4 )
+	return v3_elg_fingerprint_md( &pkc );
+    else
+	return elg_fingerprint_md( &pkc );
 }
 
 static MD_HANDLE
@@ -207,8 +261,11 @@
     if( skc->pubkey_algo == PUBKEY_ALGO_ELGAMAL ) {
 	const byte *dp;
 	MD_HANDLE md;
-	md = v3_elg_fingerprint_md_skc(skc);
-	dp = md_read( md, DIGEST_ALGO_RMD160 );
+	md = elg_fingerprint_md_skc(skc);
+	if( skc->version < 4 )
+	    dp = md_read( md, DIGEST_ALGO_RMD160 );
+	else
+	    dp = md_read( md, DIGEST_ALGO_SHA1 );
 	keyid[0] = dp[12] << 24 | dp[13] << 16 | dp[14] << 8 | dp[15] ;
 	keyid[1] = dp[16] << 24 | dp[17] << 16 | dp[18] << 8 | dp[19] ;
 	lowbits = keyid[1];
@@ -250,14 +307,20 @@
     if( pkc->pubkey_algo == PUBKEY_ALGO_ELGAMAL ) {
 	const byte *dp;
 	MD_HANDLE md;
-	md = v3_elg_fingerprint_md(pkc);
-	dp = md_read( md, DIGEST_ALGO_RMD160 );
+	if( pkc->version < 4 ) {
+	    md = v3_elg_fingerprint_md(pkc);
+	    dp = md_read( md, DIGEST_ALGO_RMD160 );
+	}
+	else {
+	    md = elg_fingerprint_md(pkc);
+	    dp = md_read( md, DIGEST_ALGO_SHA1 );
+	}
 	keyid[0] = dp[12] << 24 | dp[13] << 16 | dp[14] << 8 | dp[15] ;
 	keyid[1] = dp[16] << 24 | dp[17] << 16 | dp[18] << 8 | dp[19] ;
 	lowbits = keyid[1];
 	md_close(md);
     }
-    else if( pkc->pubkey_algo == PUBKEY_ALGO_DSA ) {
+    else if( pkc->pubkey_algo == PUBKEY_ALGO_DSA  ) {
 	const byte *dp;
 	MD_HANDLE md;
 	md = dsa_fingerprint_md(pkc);
@@ -380,6 +443,7 @@
     byte *p;
 
     pkc.pubkey_algo = skc->pubkey_algo;
+    pkc.version     = skc->version;
     if( pkc.pubkey_algo == PUBKEY_ALGO_ELGAMAL ) {
 	pkc.timestamp = skc->timestamp;
 	pkc.valid_days = skc->valid_days;
@@ -419,8 +483,14 @@
 
     if( pkc->pubkey_algo == PUBKEY_ALGO_ELGAMAL ) {
 	MD_HANDLE md;
-	md = v3_elg_fingerprint_md(pkc);
-	dp = md_read( md, DIGEST_ALGO_RMD160 );
+	if( pkc->version < 4 ) {
+	    md = v3_elg_fingerprint_md(pkc);
+	    dp = md_read( md, DIGEST_ALGO_RMD160 );
+	}
+	else {
+	    md = elg_fingerprint_md(pkc);
+	    dp = md_read( md, DIGEST_ALGO_SHA1 );
+	}
 	array = m_alloc( 20 );
 	len = 20;
 	memcpy(array, dp, 20 );
diff -urN gnupg-0.2.13/g10/keylist.c gnupg-0.2.14/g10/keylist.c
--- gnupg-0.2.13/g10/keylist.c	Sat Mar  7 12:25:31 1998
+++ gnupg-0.2.14/g10/keylist.c	Thu Apr  2 10:58:59 1998
@@ -107,22 +107,24 @@
 	goto leave;
     }
 
+
     /* get the keyid from the keyblock */
     node = find_kbnode( keyblock, PKT_PUBLIC_CERT );
     if( !node ) {
-	log_error("Oops; public key not found anymore!\n");
+	log_error("Oops; public key lost!\n");
 	goto leave;
     }
 
     pkc = node->pkt->pkt.public_cert;
     keyid_from_pkc( pkc, keyid );
     if( opt.with_colons )
-	printf("pub::%u:%d:%08lX%08lX:%s:::",
+	printf("pub::%u:%d:%08lX%08lX:%s:%u:::",
 		/* fixme: add trust value here */
 		nbits_from_pkc( pkc ),
 		pkc->pubkey_algo,
 		(ulong)keyid[0],(ulong)keyid[1],
-		datestr_from_pkc( pkc )
+		datestr_from_pkc( pkc ),
+		(unsigned)pkc->valid_days
 		/* fixme: add LID and ownertrust here */
 					);
     else
@@ -135,7 +137,7 @@
 	if( node->pkt->pkttype == PKT_USER_ID ) {
 	    if( any ) {
 		if( opt.with_colons )
-		    printf("uid::::::::");
+		    printf("uid:::::::::");
 		else
 		    printf("uid%*s", 28, "");
 	    }
@@ -150,6 +152,34 @@
 		any = 1;
 	    }
 	}
+	else if( node->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
+	    u32 keyid2[2];
+	    PKT_public_cert *pkc2 = node->pkt->pkt.public_cert;
+
+	    if( !any ) {
+		putchar('\n');
+		if( opt.fingerprint )
+		    fingerprint( pkc ); /* of the main key */
+		any = 1;
+	    }
+
+	    keyid_from_pkc( pkc2, keyid2 );
+	    if( opt.with_colons )
+		printf("sub::%u:%d:%08lX%08lX:%s:%u:::\n",
+			/* fixme: add trust value here */
+			nbits_from_pkc( pkc2 ),
+			pkc2->pubkey_algo,
+			(ulong)keyid2[0],(ulong)keyid2[1],
+			datestr_from_pkc( pkc2 ),
+			(unsigned)pkc2->valid_days
+			/* fixme: add LID and ownertrust here */
+						);
+	    else
+		printf("sub  %4u%c/%08lX %s\n", nbits_from_pkc( pkc2 ),
+					   pubkey_letter( pkc2->pubkey_algo ),
+					   (ulong)keyid2[1],
+					   datestr_from_pkc( pkc2 ) );
+	}
 	else if( opt.list_sigs && node->pkt->pkttype == PKT_SIGNATURE ) {
 	    PKT_signature *sig = node->pkt->pkt.signature;
 	    int sigrc;
@@ -168,11 +198,13 @@
 		fputs("rev", stdout);
 	    else if( (sig->sig_class&~3) == 0x10 )
 		fputs("sig", stdout);
+	    else if( sig->sig_class == 0x18 )
+		fputs("sig", stdout);
 	    else {
 		if( opt.with_colons )
-		    printf("sig:::::::::%02x:\n",sig->sig_class );
+		    printf("sig::::::::::%02x:\n",sig->sig_class );
 		else
-		    printf("sig                              "
+		    printf("sig                             "
 		       "[unexpected signature class 0x%02x]\n",sig->sig_class );
 		continue;
 	    }
@@ -194,7 +226,7 @@
 		putchar(':');
 		if( sigrc != ' ' )
 		    putchar(sigrc);
-		printf(":::%08lX%08lX:%s:::", (ulong)sig->keyid[0],
+		printf(":::%08lX%08lX:%s::::", (ulong)sig->keyid[0],
 			   (ulong)sig->keyid[1], datestr_from_sig(sig));
 	    }
 	    else
@@ -234,7 +266,7 @@
 
     p = array = fingerprint_from_pkc( pkc, &n );
     if( opt.with_colons ) {
-	printf("fpr::::::::");
+	printf("fpr:::::::::");
 	for(i=0; i < n ; i++, p++ )
 	    printf("%02X", *p );
 	putchar(':');
diff -urN gnupg-0.2.13/g10/mainproc.c gnupg-0.2.14/g10/mainproc.c
--- gnupg-0.2.13/g10/mainproc.c	Tue Mar 10 18:39:32 1998
+++ gnupg-0.2.14/g10/mainproc.c	Thu Apr  2 10:59:21 1998
@@ -93,28 +93,23 @@
 }
 
 
-static int
-add_public_cert( CTX c, PACKET *pkt )
-{
-    release_list( c );
-    c->list = new_kbnode( pkt );
-    return 1;
-}
 
 static int
-add_secret_cert( CTX c, PACKET *pkt )
+add_user_id( CTX c, PACKET *pkt )
 {
-    release_list( c );
-    c->list = new_kbnode( pkt );
+    if( !c->list ) {
+	log_error("orphaned user id\n" );
+	return 0;
+    }
+    add_kbnode( c->list, new_kbnode( pkt ) );
     return 1;
 }
 
-
 static int
-add_user_id( CTX c, PACKET *pkt )
+add_subkey( CTX c, PACKET *pkt )
 {
     if( !c->list ) {
-	log_error("orphaned user id\n" );
+	log_error("subkey w/o mainkey\n" );
 	return 0;
     }
     add_kbnode( c->list, new_kbnode( pkt ) );
@@ -309,30 +304,11 @@
 	    md = md_open( 0, 0 ); /* signature_check() will enable the md*/
     }
     else if( (sig->sig_class&~3) == 0x10
+	     || sig->sig_class == 0x18
 	     || sig->sig_class == 0x20
 	     || sig->sig_class == 0x30	) { /* classes 0x10..0x13,0x20,0x30 */
-	if( c->list->pkt->pkttype == PKT_PUBLIC_CERT ) {
-	  #if 0
-	    KBNODE n1;
-
-	    if( sig->sig_class == 0x20 ) {
-		md = md_open( algo, 0 );
-		hash_public_cert( md, c->list->pkt->pkt.public_cert );
-	    }
-	    else if( (n1=find_prev_kbnode( c->list, node, PKT_USER_ID )) ) {
-		md = md_open( algo, 0 );
-		hash_public_cert( md, c->list->pkt->pkt.public_cert );
-		if( sig->sig_class != 0x20 )
-		    md_write( md, n1->pkt->pkt.user_id->name,
-				  n1->pkt->pkt.user_id->len);
-	    }
-	    else {
-		log_error("invalid parent packet for sigclass %02x\n",
-							sig->sig_class);
-		return G10ERR_SIG_CLASS;
-	    }
-	  #endif
-
+	if( c->list->pkt->pkttype == PKT_PUBLIC_CERT
+	    || c->list->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
 	    return check_key_signature( c->list, node, NULL );
 	}
 	else {
@@ -374,7 +350,7 @@
     p = array = skc? fingerprint_from_skc( skc, &n )
 		   : fingerprint_from_pkc( pkc, &n );
     if( opt.with_colons ) {
-	printf("fpr::::::::");
+	printf("fpr:::::::::");
 	for(i=0; i < n ; i++, p++ )
 	    printf("%02X", *p );
 	putchar(':');
@@ -409,26 +385,32 @@
 list_node( CTX c, KBNODE node )
 {
     int any=0;
+    int mainkey;
 
     if( !node )
 	;
-    else if( node->pkt->pkttype == PKT_PUBLIC_CERT ) {
+    else if( (mainkey = (node->pkt->pkttype == PKT_PUBLIC_CERT) )
+	     || node->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
 	PKT_public_cert *pkc = node->pkt->pkt.public_cert;
 
 	if( opt.with_colons ) {
 	    u32 keyid[2];
 	    keyid_from_pkc( pkc, keyid );
-	    printf("pub::%u:%d:%08lX%08lX:%s:::",
+	    printf("%s::%u:%d:%08lX%08lX:%s:%u:::",
+		    mainkey? "pub":"sub",
 		    /* fixme: add trust value here */
 		    nbits_from_pkc( pkc ),
 		    pkc->pubkey_algo,
 		    (ulong)keyid[0],(ulong)keyid[1],
-		    datestr_from_pkc( pkc )
+		    datestr_from_pkc( pkc ),
+		    (unsigned)pkc->valid_days
 		    /* fixme: add LID and ownertrust here */
 					    );
 	}
 	else
-	    printf("pub  %4u%c/%08lX %s ", nbits_from_pkc( pkc ),
+	    printf("%s  %4u%c/%08lX %s ",
+				      mainkey? "pub":"sub",
+				      nbits_from_pkc( pkc ),
 				      pubkey_letter( pkc->pubkey_algo ),
 				      (ulong)keyid_from_pkc( pkc, NULL ),
 				      datestr_from_pkc( pkc )	  );
@@ -449,7 +431,7 @@
 
 		if( any ) {
 		    if( opt.with_colons )
-			printf("uid::::::::");
+			printf("uid:::::::::");
 		    else
 			printf( "uid%*s", 28, "" );
 		}
@@ -467,17 +449,29 @@
 		}
 		any=2;
 	    }
+	    else if( mainkey && node->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
+		if( !any ) {
+		    putchar('\n');
+		    any = 1;
+		}
+		list_node(c,  node );
+	    }
 	}
-	if( any != 2 )
+	if( any != 2 && mainkey )
 	    printf("ERROR: no user id!\n");
+	else if( any != 2 )
+	    putchar('\n');
     }
-    else if( node->pkt->pkttype == PKT_SECRET_CERT ) {
+    else if( (mainkey = (node->pkt->pkttype == PKT_SECRET_CERT) )
+	     || node->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
 	PKT_secret_cert *skc = node->pkt->pkt.secret_cert;
 
-	printf("sec  %4u%c/%08lX %s ", nbits_from_skc( skc ),
+	printf("%s  %4u%c/%08lX %s ",
+				      mainkey? "sec":"ssb",
+				       nbits_from_skc( skc ),
 				      pubkey_letter( skc->pubkey_algo ),
 				      (ulong)keyid_from_skc( skc, NULL ),
-				      datestr_from_skc( skc )	  );
+				      datestr_from_skc( skc )	);
 	/* and now list all userids */
 	while( (node = find_next_kbnode(node, PKT_USER_ID)) ) {
 	    print_userid( node->pkt );
@@ -486,8 +480,10 @@
 		print_fingerprint( NULL, skc );
 	    any=1;
 	}
-	if( !any )
+	if( !any && mainkey )
 	    printf("ERROR: no user id!\n");
+	else if( !any )
+	    putchar('\n');
     }
     else if( node->pkt->pkttype == PKT_SIGNATURE  ) {
 	PKT_signature *sig = node->pkt->pkt.signature;
@@ -516,7 +512,7 @@
 	    putchar(':');
 	    if( sigrc != ' ' )
 		putchar(sigrc);
-	    printf(":::%08lX%08lX:%s:::", (ulong)sig->keyid[0],
+	    printf(":::%08lX%08lX:%s::::", (ulong)sig->keyid[0],
 		       (ulong)sig->keyid[1], datestr_from_sig(sig));
 	}
 	else
@@ -638,8 +634,16 @@
 	}
 	else {
 	    switch( pkt->pkttype ) {
-	      case PKT_PUBLIC_CERT: newpkt = add_public_cert( c, pkt ); break;
-	      case PKT_SECRET_CERT: newpkt = add_secret_cert( c, pkt ); break;
+	      case PKT_PUBLIC_CERT:
+	      case PKT_SECRET_CERT:
+		release_list( c );
+		c->list = new_kbnode( pkt );
+		newpkt = 1;
+		break;
+	      case PKT_PUBKEY_SUBCERT:
+	      case PKT_SECKEY_SUBCERT:
+		newpkt = add_subkey( c, pkt );
+		break;
 	      case PKT_USER_ID:     newpkt = add_user_id( c, pkt ); break;
 	      case PKT_SIGNATURE:   newpkt = add_signature( c, pkt ); break;
 	      case PKT_PUBKEY_ENC:  proc_pubkey_enc( c, pkt ); break;
@@ -730,7 +734,8 @@
     if( opt.list_packets )
 	return;
 
-    if( node->pkt->pkttype == PKT_PUBLIC_CERT )
+    if( node->pkt->pkttype == PKT_PUBLIC_CERT
+	|| node->pkt->pkttype == PKT_PUBKEY_SUBCERT )
 	list_node( c, node );
     else if( node->pkt->pkttype == PKT_SECRET_CERT )
 	list_node( c, node );
diff -urN gnupg-0.2.13/g10/packet.h gnupg-0.2.14/g10/packet.h
--- gnupg-0.2.13/g10/packet.h	Mon Mar  9 20:06:04 1998
+++ gnupg-0.2.14/g10/packet.h	Wed Apr  1 15:27:19 1998
@@ -50,6 +50,7 @@
 
 typedef struct {
     u32     keyid[2];	    /* 64 bit keyid */
+    byte    version;
     byte    pubkey_algo;    /* algorithm used for public key scheme */
     union {
       struct {
@@ -129,24 +130,24 @@
     byte    hdrbytes;	    /* number of header bytes */
     byte    version;
     byte    pubkey_algo;    /* algorithm used for public key scheme */
+    byte is_protected;	/* The secret infos are protected and must */
+			/* be decrypteded before use, the protected */
+			/* MPIs are simply (void*) pointers to memory */
+			/* and should never be passed to a mpi_xxx() */
+    struct {
+	byte algo;  /* cipher used to protect the secret informations*/
+	byte s2k;
+	byte hash;
+	byte salt[8];
+	byte count;
+	byte iv[8]; /* initialization vector for CFB mode */
+    } protect;
     union {
       struct {
 	MPI p;		    /* prime */
 	MPI g;		    /* group generator */
 	MPI y;		    /* g^x mod p */
 	MPI x;		    /* secret exponent */
-	u16 csum;	    /* checksum */
-	byte is_protected;  /* The above infos are protected and must */
-			    /* be decrypteded before use. */
-	struct {
-	    byte algo;	/* cipher used to protect the secret informations*/
-	    byte s2k;
-	    byte hash;
-	    byte salt[8];
-	    byte count;
-	    byte iv[8]; /* initialization vector for CFB mode */
-	} protect;	    /* when protected, the MPIs above are pointers
-			     * to plain storage */
       } elg;
       struct {
 	MPI p;		    /* prime */
@@ -154,18 +155,6 @@
 	MPI g;		    /* group generator */
 	MPI y;		    /* g^x mod p */
 	MPI x;		    /* secret exponent */
-	u16 csum;	    /* checksum */
-	byte is_protected;  /* The above infos are protected and must */
-			    /* be decrypteded before use. */
-	struct {
-	    byte algo;	/* cipher used to protect the secret informations*/
-	    byte s2k;
-	    byte hash;
-	    byte salt[8];
-	    byte count;
-	    byte iv[8]; /* initialization vector for CFB mode */
-	} protect;	    /* when protected, the MPIs above are pointers
-			     * to plain storage */
       } dsa;
       struct {
 	MPI rsa_n;	    /* public modulus */
@@ -174,19 +163,9 @@
 	MPI rsa_p;	    /* secret first prime number */
 	MPI rsa_q;	    /* secret second prime number */
 	MPI rsa_u;	    /* secret multiplicative inverse */
-	u16 csum;	    /* checksum */
-	byte is_protected;  /* The above infos are protected and must */
-			    /* be decrypteded before use */
-	byte protect_algo;  /* cipher used to protect the secret informations*/
-	union { 	    /* information for the protection */
-	  struct {
-	    byte iv[8];     /* initialization vector for CFB mode */
-			    /* when protected, the MPIs above are pointers
-			     * to plain storage */
-	  } blowfish;
-	} protect;
       } rsa;
     } d;
+    u16 csum;		/* checksum */
 } PKT_secret_cert;
 
 
diff -urN gnupg-0.2.13/g10/parse-packet.c gnupg-0.2.14/g10/parse-packet.c
--- gnupg-0.2.13/g10/parse-packet.c	Mon Mar  9 20:06:48 1998
+++ gnupg-0.2.14/g10/parse-packet.c	Wed Apr  1 15:59:26 1998
@@ -52,7 +52,6 @@
 				      byte *hdr, int hdrlen, PACKET *packet );
 static int  parse_user_id( IOBUF inp, int pkttype, unsigned long pktlen,
 							   PACKET *packet );
-static void parse_subkey( IOBUF inp, int pkttype, unsigned long pktlen );
 static int  parse_comment( IOBUF inp, int pkttype, unsigned long pktlen,
 							   PACKET *packet );
 static void parse_trust( IOBUF inp, int pkttype, unsigned long pktlen );
@@ -289,6 +288,7 @@
     rc = G10ERR_UNKNOWN_PACKET; /* default error */
     switch( pkttype ) {
       case PKT_PUBLIC_CERT:
+      case PKT_PUBKEY_SUBCERT:
 	pkt->pkt.public_cert = m_alloc_clear(sizeof *pkt->pkt.public_cert );
 	rc = parse_certificate(inp, pkttype, pktlen, hdr, hdrlen, pkt );
 	break;
@@ -311,9 +311,6 @@
       case PKT_USER_ID:
 	rc = parse_user_id(inp, pkttype, pktlen, pkt );
 	break;
-      case PKT_PUBKEY_SUBCERT:
-	parse_subkey(inp, pkttype, pktlen);
-	break;
       case PKT_COMMENT:
 	rc = parse_comment(inp, pkttype, pktlen, pkt);
 	break;
@@ -425,7 +422,6 @@
 static int
 parse_publickey( IOBUF inp, int pkttype, unsigned long pktlen, PACKET *packet )
 {
-    int version;
     unsigned n;
     PKT_pubkey_enc *k;
 
@@ -434,17 +430,17 @@
 	log_error("packet(%d) too short\n", pkttype);
 	goto leave;
     }
-    version = iobuf_get_noeof(inp); pktlen--;
-    if( version != 2 && version != 3 ) {
-	log_error("packet(%d) with unknown version %d\n", pkttype, version);
+    k->version = iobuf_get_noeof(inp); pktlen--;
+    if( k->version != 2 && k->version != 3 ) {
+	log_error("packet(%d) with unknown version %d\n", pkttype, k->version);
 	goto leave;
     }
     k->keyid[0] = read_32(inp); pktlen -= 4;
     k->keyid[1] = read_32(inp); pktlen -= 4;
     k->pubkey_algo = iobuf_get_noeof(inp); pktlen--;
     if( list_mode )
-	printf(":public key encoded packet: keyid %08lX%08lX\n",
-				      (ulong)k->keyid[0], (ulong)k->keyid[1]);
+	printf(":public key encoded packet: version %d, keyid %08lX%08lX\n",
+			    k->version, (ulong)k->keyid[0], (ulong)k->keyid[1]);
     if( k->pubkey_algo == PUBKEY_ALGO_ELGAMAL ) {
 	n = pktlen;
 	k->d.elg.a = mpi_read(inp, &n, 0); pktlen -=n;
@@ -768,19 +764,37 @@
     int is_v4=0;
     int rc=0;
 
-
-    if( pktlen < 12 ) {
-	log_error("packet(%d) too short\n", pkttype);
-	goto leave;
-    }
     version = iobuf_get_noeof(inp); pktlen--;
-    if( version == 4 )
+    if( pkttype == PKT_PUBKEY_SUBCERT && version == '#' ) {
+	/* early versions of G10 use old comments packets; luckily all those
+	 * comments are started by a hash */
+	if( list_mode ) {
+	    printf(":old comment packet: \"" );
+	    for( ; pktlen; pktlen-- ) {
+		int c;
+		c = iobuf_get_noeof(inp);
+		if( c >= ' ' && c <= 'z' )
+		    putchar(c);
+		else
+		    printf("\\x%02x", c );
+	    }
+	    printf("\"\n");
+	}
+	skip_rest(inp, pktlen);
+	return 0;
+    }
+    else if( version == 4 )
 	is_v4=1;
     else if( version != 2 && version != 3 ) {
 	log_error("packet(%d) with unknown version %d\n", pkttype, version);
 	goto leave;
     }
 
+    if( pktlen < 11 ) {
+	log_error("packet(%d) too short\n", pkttype);
+	goto leave;
+    }
+
     timestamp = read_32(inp); pktlen -= 4;
     if( is_v4 )
 	valid_period = 0;
@@ -791,9 +805,12 @@
     if( list_mode )
 	printf(":%s key packet:\n"
 	       "\tversion %d, created %lu, valid for %hu days\n",
-		pkttype == PKT_PUBLIC_CERT? "public": "secret",
+		pkttype == PKT_PUBLIC_CERT? "public" :
+		pkttype == PKT_SECRET_CERT? "secret" :
+		pkttype == PKT_PUBKEY_SUBCERT? "public sub" :
+		pkttype == PKT_SECKEY_SUBCERT? "secret sub" : "??",
 		version, timestamp, valid_period );
-    if( pkttype == PKT_SECRET_CERT )  {
+    if( pkttype == PKT_SECRET_CERT || pkttype == PKT_SECKEY_SUBCERT )  {
 	pkt->pkt.secret_cert->timestamp = timestamp;
 	pkt->pkt.secret_cert->valid_days = valid_period;
 	pkt->pkt.secret_cert->hdrbytes = hdrlen;
@@ -822,7 +839,7 @@
 	    mpi_print(stdout, elg_y, mpi_print_mode  );
 	    putchar('\n');
 	}
-	if( pkttype == PKT_PUBLIC_CERT ) {
+	if( pkttype == PKT_PUBLIC_CERT || pkttype == PKT_PUBKEY_SUBCERT ) {
 	    pkt->pkt.public_cert->d.elg.p = elg_p;
 	    pkt->pkt.public_cert->d.elg.g = elg_g;
 	    pkt->pkt.public_cert->d.elg.y = elg_y;
@@ -834,27 +851,27 @@
 	    pkt->pkt.secret_cert->d.elg.p = elg_p;
 	    pkt->pkt.secret_cert->d.elg.g = elg_g;
 	    pkt->pkt.secret_cert->d.elg.y = elg_y;
-	    cert->d.elg.protect.algo = iobuf_get_noeof(inp); pktlen--;
-	    if( cert->d.elg.protect.algo ) {
-		cert->d.elg.is_protected = 1;
-		cert->d.elg.protect.count = 0;
-		if( cert->d.elg.protect.algo == 255 ) {
+	    cert->protect.algo = iobuf_get_noeof(inp); pktlen--;
+	    if( cert->protect.algo ) {
+		cert->is_protected = 1;
+		cert->protect.count = 0;
+		if( cert->protect.algo == 255 ) {
 		    if( pktlen < 3 ) {
 			rc = G10ERR_INVALID_PACKET;
 			goto leave;
 		    }
-		    cert->d.elg.protect.algo = iobuf_get_noeof(inp); pktlen--;
-		    cert->d.elg.protect.s2k  = iobuf_get_noeof(inp); pktlen--;
-		    cert->d.elg.protect.hash = iobuf_get_noeof(inp); pktlen--;
-		    switch( cert->d.elg.protect.s2k ) {
+		    cert->protect.algo = iobuf_get_noeof(inp); pktlen--;
+		    cert->protect.s2k  = iobuf_get_noeof(inp); pktlen--;
+		    cert->protect.hash = iobuf_get_noeof(inp); pktlen--;
+		    switch( cert->protect.s2k ) {
 		      case 1:
 		      case 3:
 			for(i=0; i < 8 && pktlen; i++, pktlen-- )
 			    temp[i] = iobuf_get_noeof(inp);
-			memcpy(cert->d.elg.protect.salt, temp, 8 );
+			memcpy(cert->protect.salt, temp, 8 );
 			break;
 		    }
-		    switch( cert->d.elg.protect.s2k ) {
+		    switch( cert->protect.s2k ) {
 		      case 0: if( list_mode ) printf(  "\tsimple S2K" );
 			break;
 		      case 1: if( list_mode ) printf(  "\tsalted S2K" );
@@ -864,30 +881,30 @@
 		      default:
 			if( list_mode )
 			    printf(  "\tunknown S2K %d\n",
-						cert->d.elg.protect.s2k );
+						cert->protect.s2k );
 			rc = G10ERR_INVALID_PACKET;
 			goto leave;
 		    }
 
 		    if( list_mode ) {
 			printf(", algo: %d, hash: %d",
-					 cert->d.elg.protect.algo,
-					 cert->d.elg.protect.hash );
-			if( cert->d.elg.protect.s2k == 1
-			    || cert->d.elg.protect.s2k == 3 ) {
+					 cert->protect.algo,
+					 cert->protect.hash );
+			if( cert->protect.s2k == 1
+			    || cert->protect.s2k == 3 ) {
 			    printf(", salt: ");
 			    for(i=0; i < 8; i++ )
-				printf("%02x", cert->d.elg.protect.salt[i]);
+				printf("%02x", cert->protect.salt[i]);
 			}
 			putchar('\n');
 		    }
 
-		    if( cert->d.elg.protect.s2k == 3 ) {
+		    if( cert->protect.s2k == 3 ) {
 			if( !pktlen ) {
 			    rc = G10ERR_INVALID_PACKET;
 			    goto leave;
 			}
-			cert->d.elg.protect.count = iobuf_get_noeof(inp);
+			cert->protect.count = iobuf_get_noeof(inp);
 			pktlen--;
 		    }
 
@@ -895,12 +912,12 @@
 		else {
 		    if( list_mode )
 			printf(  "\tprotect algo: %d\n",
-						cert->d.elg.protect.algo);
+						cert->protect.algo);
 		    /* old version, we don't have a S2K, so we fake one */
-		    cert->d.elg.protect.s2k = 0;
+		    cert->protect.s2k = 0;
 		    /* We need this kludge to cope with old GNUPG versions */
-		    cert->d.elg.protect.hash =
-			 cert->d.elg.protect.algo == CIPHER_ALGO_BLOWFISH?
+		    cert->protect.hash =
+			 cert->protect.algo == CIPHER_ALGO_BLOWFISH?
 				      DIGEST_ALGO_RMD160 : DIGEST_ALGO_MD5;
 		}
 		if( pktlen < 8 ) {
@@ -915,20 +932,20 @@
 			printf(" %02x", temp[i] );
 		    putchar('\n');
 		}
-		memcpy(cert->d.elg.protect.iv, temp, 8 );
+		memcpy(cert->protect.iv, temp, 8 );
 	    }
 	    else
-		cert->d.elg.is_protected = 0;
+		cert->is_protected = 0;
 	    /* It does not make sense to read it into secure memory.
 	     * If the user is so careless, not to protect his secret key,
 	     * we can assume, that he operates an open system :=(.
 	     * So we put the key into secure memory when we unprotect him. */
 	    n = pktlen; cert->d.elg.x = mpi_read(inp, &n, 0 ); pktlen -=n;
 
-	    cert->d.elg.csum = read_16(inp); pktlen -= 2;
+	    cert->csum = read_16(inp); pktlen -= 2;
 	    if( list_mode ) {
 		printf("\t[secret value x is not shown]\n"
-		       "\tchecksum: %04hx\n", cert->d.elg.csum);
+		       "\tchecksum: %04hx\n", cert->csum);
 	    }
 	  /*log_mpidump("elg p=", cert->d.elg.p );
 	    log_mpidump("elg g=", cert->d.elg.g );
@@ -953,7 +970,7 @@
 	    mpi_print(stdout, dsa_y, mpi_print_mode  );
 	    putchar('\n');
 	}
-	if( pkttype == PKT_PUBLIC_CERT ) {
+	if( pkttype == PKT_PUBLIC_CERT || pkttype == PKT_PUBKEY_SUBCERT ) {
 	    pkt->pkt.public_cert->d.dsa.p = dsa_p;
 	    pkt->pkt.public_cert->d.dsa.q = dsa_q;
 	    pkt->pkt.public_cert->d.dsa.g = dsa_g;
@@ -967,27 +984,27 @@
 	    pkt->pkt.secret_cert->d.dsa.q = dsa_q;
 	    pkt->pkt.secret_cert->d.dsa.g = dsa_g;
 	    pkt->pkt.secret_cert->d.dsa.y = dsa_y;
-	    cert->d.dsa.protect.algo = iobuf_get_noeof(inp); pktlen--;
-	    if( cert->d.dsa.protect.algo ) {
-		cert->d.dsa.is_protected = 1;
-		cert->d.dsa.protect.count = 0;
-		if( cert->d.dsa.protect.algo == 255 ) {
+	    cert->protect.algo = iobuf_get_noeof(inp); pktlen--;
+	    if( cert->protect.algo ) {
+		cert->is_protected = 1;
+		cert->protect.count = 0;
+		if( cert->protect.algo == 255 ) {
 		    if( pktlen < 3 ) {
 			rc = G10ERR_INVALID_PACKET;
 			goto leave;
 		    }
-		    cert->d.dsa.protect.algo = iobuf_get_noeof(inp); pktlen--;
-		    cert->d.dsa.protect.s2k  = iobuf_get_noeof(inp); pktlen--;
-		    cert->d.dsa.protect.hash = iobuf_get_noeof(inp); pktlen--;
-		    switch( cert->d.dsa.protect.s2k ) {
+		    cert->protect.algo = iobuf_get_noeof(inp); pktlen--;
+		    cert->protect.s2k  = iobuf_get_noeof(inp); pktlen--;
+		    cert->protect.hash = iobuf_get_noeof(inp); pktlen--;
+		    switch( cert->protect.s2k ) {
 		      case 1:
 		      case 3:
 			for(i=0; i < 8 && pktlen; i++, pktlen-- )
 			    temp[i] = iobuf_get_noeof(inp);
-			memcpy(cert->d.dsa.protect.salt, temp, 8 );
+			memcpy(cert->protect.salt, temp, 8 );
 			break;
 		    }
-		    switch( cert->d.dsa.protect.s2k ) {
+		    switch( cert->protect.s2k ) {
 		      case 0: if( list_mode ) printf(  "\tsimple S2K" );
 			break;
 		      case 1: if( list_mode ) printf(  "\tsalted S2K" );
@@ -996,42 +1013,39 @@
 			break;
 		      default:
 			if( list_mode )
-			    printf(  "\tunknown S2K %d\n",
-						cert->d.dsa.protect.s2k );
+			    printf(  "\tunknown S2K %d\n", cert->protect.s2k );
 			rc = G10ERR_INVALID_PACKET;
 			goto leave;
 		    }
 
 		    if( list_mode ) {
 			printf(", algo: %d, hash: %d",
-					 cert->d.dsa.protect.algo,
-					 cert->d.dsa.protect.hash );
-			if( cert->d.dsa.protect.s2k == 1
-			    || cert->d.dsa.protect.s2k == 3 ) {
+					 cert->protect.algo,
+					 cert->protect.hash );
+			if( cert->protect.s2k == 1 || cert->protect.s2k == 3 ){
 			    printf(", salt: ");
 			    for(i=0; i < 8; i++ )
-				printf("%02x", cert->d.dsa.protect.salt[i]);
+				printf("%02x", cert->protect.salt[i]);
 			}
 			putchar('\n');
 		    }
 
-		    if( cert->d.dsa.protect.s2k == 3 ) {
+		    if( cert->protect.s2k == 3 ) {
 			if( !pktlen ) {
 			    rc = G10ERR_INVALID_PACKET;
 			    goto leave;
 			}
-			cert->d.dsa.protect.count = iobuf_get_noeof(inp);
+			cert->protect.count = iobuf_get_noeof(inp);
 			pktlen--;
 		    }
 
 		}
 		else {
 		    if( list_mode )
-			printf(  "\tprotect algo: %d\n",
-						cert->d.dsa.protect.algo);
+			printf(  "\tprotect algo: %d\n", cert->protect.algo);
 		    /* old version, we don't have a S2K, so we fake one */
-		    cert->d.dsa.protect.s2k = 0;
-		    cert->d.dsa.protect.hash = DIGEST_ALGO_MD5;
+		    cert->protect.s2k = 0;
+		    cert->protect.hash = DIGEST_ALGO_MD5;
 		}
 		if( pktlen < 8 ) {
 		    rc = G10ERR_INVALID_PACKET;
@@ -1045,20 +1059,20 @@
 			printf(" %02x", temp[i] );
 		    putchar('\n');
 		}
-		memcpy(cert->d.dsa.protect.iv, temp, 8 );
+		memcpy(cert->protect.iv, temp, 8 );
 	    }
 	    else
-		cert->d.dsa.is_protected = 0;
+		cert->is_protected = 0;
 	    /* It does not make sense to read it into secure memory.
 	     * If the user is so careless, not to protect his secret key,
 	     * we can assume, that he operates an open system :=(.
 	     * So we put the key into secure memory when we unprotect him. */
 	    n = pktlen; cert->d.dsa.x = mpi_read(inp, &n, 0 ); pktlen -=n;
 
-	    cert->d.dsa.csum = read_16(inp); pktlen -= 2;
+	    cert->csum = read_16(inp); pktlen -= 2;
 	    if( list_mode ) {
 		printf("\t[secret value x is not shown]\n"
-		       "\tchecksum: %04hx\n", cert->d.dsa.csum);
+		       "\tchecksum: %04hx\n", cert->csum);
 	    }
 	  /*log_mpidump("dsa p=", cert->d.dsa.p );
 	    log_mpidump("dsa q=", cert->d.dsa.q );
@@ -1079,7 +1093,7 @@
 	    mpi_print(stdout, rsa_pub_exp, mpi_print_mode  );
 	    putchar('\n');
 	}
-	if( pkttype == PKT_PUBLIC_CERT ) {
+	if( pkttype == PKT_PUBLIC_CERT || pkttype == PKT_PUBKEY_SUBCERT ) {
 	    pkt->pkt.public_cert->d.rsa.rsa_n = rsa_pub_mod;
 	    pkt->pkt.public_cert->d.rsa.rsa_e = rsa_pub_exp;
 	}
@@ -1089,11 +1103,11 @@
 
 	    pkt->pkt.secret_cert->d.rsa.rsa_n = rsa_pub_mod;
 	    pkt->pkt.secret_cert->d.rsa.rsa_e = rsa_pub_exp;
-	    cert->d.rsa.protect_algo = iobuf_get_noeof(inp); pktlen--;
+	    cert->protect.algo = iobuf_get_noeof(inp); pktlen--;
 	    if( list_mode )
-		printf(  "\tprotect algo: %d\n", cert->d.rsa.protect_algo);
-	    if( cert->d.rsa.protect_algo ) {
-		cert->d.rsa.is_protected = 1;
+		printf(  "\tprotect algo: %d\n", cert->protect.algo);
+	    if( cert->protect.algo ) {
+		cert->is_protected = 1;
 		for(i=0; i < 8 && pktlen; i++, pktlen-- )
 		    temp[i] = iobuf_get_noeof(inp);
 		if( list_mode ) {
@@ -1102,21 +1116,21 @@
 			printf(" %02x", temp[i] );
 		    putchar('\n');
 		}
-		if( cert->d.rsa.protect_algo == CIPHER_ALGO_BLOWFISH )
-		    memcpy(cert->d.rsa.protect.blowfish.iv, temp, 8 );
+		if( cert->protect.algo == CIPHER_ALGO_BLOWFISH )
+		    memcpy(cert->protect.iv, temp, 8 );
 	    }
 	    else
-		cert->d.rsa.is_protected = 0;
+		cert->is_protected = 0;
 	    /* (See comments at the code for elg keys) */
 	    n = pktlen; cert->d.rsa.rsa_d = mpi_read(inp, &n, 0 ); pktlen -=n;
 	    n = pktlen; cert->d.rsa.rsa_p = mpi_read(inp, &n, 0 ); pktlen -=n;
 	    n = pktlen; cert->d.rsa.rsa_q = mpi_read(inp, &n, 0 ); pktlen -=n;
 	    n = pktlen; cert->d.rsa.rsa_u = mpi_read(inp, &n, 0 ); pktlen -=n;
 
-	    cert->d.rsa.csum = read_16(inp); pktlen -= 2;
+	    cert->csum = read_16(inp); pktlen -= 2;
 	    if( list_mode ) {
 		printf("\t[secret values d,p,q,u are not shown]\n"
-		       "\tchecksum: %04hx\n", cert->d.rsa.csum);
+		       "\tchecksum: %04hx\n", cert->csum);
 	    }
 	 /* log_mpidump("rsa n=", cert->d.rsa.rsa_n );
 	    log_mpidump("rsa e=", cert->d.rsa.rsa_e );
@@ -1159,37 +1173,6 @@
 	printf("\"\n");
     }
     return 0;
-}
-
-
-static void
-parse_subkey( IOBUF inp, int pkttype, unsigned long pktlen )
-{
-    int version;
-
-    version = iobuf_get_noeof(inp); pktlen--;
-    if( pkttype == PKT_PUBKEY_SUBCERT && version == '#' ) {
-	/* early versions of G10 use old comments packets; luckily all those
-	 * comments are started by a hash */
-	if( list_mode ) {
-	    printf(":old comment packet: \"" );
-	    for( ; pktlen; pktlen-- ) {
-		int c;
-		c = iobuf_get_noeof(inp);
-		if( c >= ' ' && c <= 'z' )
-		    putchar(c);
-		else
-		    printf("\\x%02x", c );
-	    }
-	    printf("\"\n");
-	}
-	skip_rest(inp, pktlen);
-	return;
-    }
-
-    if( list_mode )
-	printf(":public subkey packet: \"" );
-    skip_rest(inp, pktlen);
 }
 
 
diff -urN gnupg-0.2.13/g10/pkclist.c gnupg-0.2.14/g10/pkclist.c
--- gnupg-0.2.13/g10/pkclist.c	Mon Mar  2 21:54:49 1998
+++ gnupg-0.2.14/g10/pkclist.c	Thu Apr  2 10:43:09 1998
@@ -202,7 +202,7 @@
 	return do_we_trust( pkc, trustlevel );
 
       case TRUST_EXPIRED:
-	log_info("trust has expired: NOT yet implemented\n");
+	log_info("key has expired\n");
 	return 0; /* no */
 
       case TRUST_UNDEFINED:
@@ -215,11 +215,11 @@
 		if( rc )
 		    log_fatal("trust check after add_ownertrust failed: %s\n",
 							      g10_errstr(rc) );
-		/* FIXME: this is recursive; we better should unroll it */
+		/* fixme: this is recursive; we better should unroll it */
 		return do_we_trust( pkc, trustlevel );
 	    }
 	}
-	return 0; /* no FIXME: add "Proceed anyway?" */
+	return 0;
 
       case TRUST_NEVER:
 	log_info("We do NOT trust this key\n");
diff -urN gnupg-0.2.13/g10/revoke.c gnupg-0.2.14/g10/revoke.c
--- gnupg-0.2.13/g10/revoke.c	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.14/g10/revoke.c	Wed Apr  1 15:18:12 1998
@@ -89,7 +89,7 @@
 	goto leave;
     }
 
-    /* FIXME: should make a function out of this stuff,
+    /* fixme: should make a function out of this stuff,
      * it's used all over the source */
     skc = node->pkt->pkt.secret_cert;
     keyid_from_skc( skc, skc_keyid );
diff -urN gnupg-0.2.13/g10/ringedit.c gnupg-0.2.14/g10/ringedit.c
--- gnupg-0.2.13/g10/ringedit.c	Mon Mar  9 13:21:44 1998
+++ gnupg-0.2.14/g10/ringedit.c	Wed Apr  1 11:11:27 1998
@@ -78,7 +78,7 @@
 static int keyring_search2( PUBKEY_FIND_INFO info, KBPOS *kbpos,
 						   const char *fname);
 static int keyring_read( KBPOS *kbpos, KBNODE *ret_root );
-static int keyring_enum( KBPOS *kbpos, KBNODE *ret_root );
+static int keyring_enum( KBPOS *kbpos, KBNODE *ret_root, int skipsigs );
 static int keyring_copy( KBPOS *kbpos, int mode, KBNODE root );
 
 
@@ -346,11 +346,13 @@
  * Mode is: 0 = open
  *	    1 = read
  *	    2 = close
+ *	    5 = open secret keyrings
+ *	    11 = read but skip signature and comment packets.
  *	    all others are reserved!
- * Note that you do not need a search prior to call this function,
- * only handle is needed.
- * NOTE: It is not alloed to do an insert/update/delte with this
- *	 keyblock, if you want to do this, user search/read!
+ * Note that you do not need a search prior to this function,
+ * only a handle is needed.
+ * NOTE: It is not allowed to do an insert/update/delte with this
+ *	 keyblock, if you want to do this, use search/read!
  */
 int
 enum_keyblocks( int mode, KBPOS *kbpos, KBNODE *ret_root )
@@ -358,15 +360,23 @@
     int rc = 0;
     RESTBL *rentry;
 
-    if( !mode || mode == 100 ) {
+    if( !mode || mode == 5 || mode == 100 ) {
 	int i;
 	kbpos->fp = NULL;
-	if( !mode )
+	if( !mode ) {
+	    kbpos->secret = 0;
 	    i = 0;
+	}
+	else if( mode == 5 ) {
+	    kbpos->secret = 1;
+	    mode = 0;
+	    i = 0;
+	}
 	else
 	    i = kbpos->resno+1;
 	for(; i < MAX_RESOURCES; i++ )
-	    if( resource_table[i].used && !resource_table[i].secret )
+	    if( resource_table[i].used
+		&& !resource_table[i].secret == !kbpos->secret )
 		break;
 	if( i == MAX_RESOURCES )
 	    return -1; /* no resources */
@@ -379,13 +389,13 @@
 	}
 	kbpos->pkt = NULL;
     }
-    else if( mode == 1 ) {
+    else if( mode == 1 || mode == 11 ) {
 	int cont;
 	do {
 	    cont = 0;
 	    if( !kbpos->fp )
 		return G10ERR_GENERAL;
-	    rc = keyring_enum( kbpos, ret_root );
+	    rc = keyring_enum( kbpos, ret_root, mode == 11 );
 	    if( rc == -1 ) {
 		assert( !kbpos->pkt );
 		rentry = check_pos( kbpos );
@@ -664,6 +674,7 @@
 		rc = G10ERR_INV_KEYRING;
 		goto ready;
 	    }
+		log_info("read_keyblock: read error: %s\n", g10_errstr(rc) );
 	    kbpos->count++;
 	    free_packet( pkt );
 	    init_packet( pkt );
@@ -703,13 +714,12 @@
 
 
 static int
-keyring_enum( KBPOS *kbpos, KBNODE *ret_root )
+keyring_enum( KBPOS *kbpos, KBNODE *ret_root, int skipsigs )
 {
     PACKET *pkt;
     int rc;
     RESTBL *rentry;
     KBNODE root = NULL;
-    int in_cert = 0;
 
     if( !(rentry=check_pos(kbpos)) )
 	return G10ERR_GENERAL;
@@ -736,17 +746,28 @@
 	switch( pkt->pkttype ) {
 	  case PKT_PUBLIC_CERT:
 	  case PKT_SECRET_CERT:
-	    if( in_cert ) { /* store this packet */
+	    if( root ) { /* store this packet */
 		kbpos->pkt = pkt;
 		pkt = NULL;
 		goto ready;
 	    }
-	    in_cert = 1;
+	    root = new_kbnode( pkt );
+	    pkt = m_alloc( sizeof *pkt );
+	    init_packet(pkt);
+	    break;
+
 	  default:
-	    if( !root )
-		root = new_kbnode( pkt );
-	    else
-		add_kbnode( root, new_kbnode( pkt ) );
+	    /* skip pakets at the begin of a keyring, until we find
+	     * a start packet; issue a warning if it is not a comment */
+	    if( !root && pkt->pkttype != PKT_COMMENT )
+		log_info("keyring_enum: skipped packet of type %d\n",
+			    pkt->pkttype );
+	    if( !root || (skipsigs && ( pkt->pkttype == PKT_SIGNATURE
+				      ||pkt->pkttype == PKT_COMMENT )) ) {
+		init_packet(pkt);
+		break;
+	    }
+	    add_kbnode( root, new_kbnode( pkt ) );
 	    pkt = m_alloc( sizeof *pkt );
 	    init_packet(pkt);
 	    break;
diff -urN gnupg-0.2.13/g10/seckey-cert.c gnupg-0.2.14/g10/seckey-cert.c
--- gnupg-0.2.13/g10/seckey-cert.c	Mon Mar  9 13:26:33 1998
+++ gnupg-0.2.14/g10/seckey-cert.c	Wed Apr  1 16:06:53 1998
@@ -67,19 +67,18 @@
     ELG_secret_key skey;
     char save_iv[8];
 
-    if( cert->d.elg.is_protected ) { /* remove the protection */
+    if( cert->is_protected ) { /* remove the protection */
 	DEK *dek = NULL;
 	MPI test_x;
 	BLOWFISH_context *blowfish_ctx=NULL;
 
-	switch( cert->d.elg.protect.algo ) {
+	switch( cert->protect.algo ) {
 	  case CIPHER_ALGO_NONE: BUG(); break;
 	  case CIPHER_ALGO_BLOWFISH:
 	    keyid_from_skc( cert, keyid );
-	    if( cert->d.elg.protect.s2k == 1
-		|| cert->d.elg.protect.s2k == 3 )
+	    if( cert->protect.s2k == 1 || cert->protect.s2k == 3 )
 		dek = get_passphrase_hash( keyid, NULL,
-						 cert->d.elg.protect.salt );
+						 cert->protect.salt );
 	    else
 		dek = get_passphrase_hash( keyid, NULL, NULL );
 
@@ -87,10 +86,9 @@
 	    blowfish_setkey( blowfish_ctx, dek->key, dek->keylen );
 	    m_free(dek); /* pw is in secure memory, so m_free() burns it */
 	    blowfish_setiv( blowfish_ctx, NULL );
-	    memcpy(save_iv, cert->d.elg.protect.iv, 8 );
-	    blowfish_decode_cfb( blowfish_ctx,
-				 cert->d.elg.protect.iv,
-				 cert->d.elg.protect.iv, 8 );
+	    memcpy(save_iv, cert->protect.iv, 8 );
+	    blowfish_decode_cfb( blowfish_ctx, cert->protect.iv,
+					       cert->protect.iv, 8 );
 	    mpi_set_secure(cert->d.elg.x );
 	    /*fixme: maybe it is better to set the buffer secure with a
 	     * new get_buffer_secure() function */
@@ -103,9 +101,9 @@
 	    m_free( buffer );
 	    m_free( blowfish_ctx );
 	    /* now let's see wether we have used the right passphrase */
-	    if( csum != cert->d.elg.csum ) {
+	    if( csum != cert->csum ) {
 		mpi_free(test_x);
-		memcpy( cert->d.elg.protect.iv, save_iv, 8 );
+		memcpy( cert->protect.iv, save_iv, 8 );
 		return G10ERR_BAD_PASS;
 	    }
 
@@ -117,16 +115,16 @@
 	    memset( &skey, 0, sizeof skey );
 	    if( !res ) {
 		mpi_free(test_x);
-		memcpy( cert->d.elg.protect.iv, save_iv, 8 );
+		memcpy( cert->protect.iv, save_iv, 8 );
 		return G10ERR_BAD_PASS;
 	    }
 	    mpi_set(cert->d.elg.x, test_x);
 	    mpi_free(test_x);
-	    cert->d.elg.is_protected = 0;
+	    cert->is_protected = 0;
 	    break;
 
 	  default:
-	    return G10ERR_CIPHER_ALGO; /* unsupport protection algorithm */
+	    return G10ERR_CIPHER_ALGO; /* unsupported protection algorithm */
 	}
     }
     else { /* not protected */
@@ -134,7 +132,7 @@
 	csum = checksum_u16( nbytes*8 );
 	csum += checksum( buffer, nbytes );
 	m_free( buffer );
-	if( csum != cert->d.elg.csum )
+	if( csum != cert->csum )
 	    return G10ERR_CHECKSUM;
     }
 
@@ -143,39 +141,6 @@
 
 
 static int
-protect_elg( PKT_secret_cert *cert, DEK *dek )
-{
-    byte *buffer;
-    unsigned nbytes;
-
-    if( !cert->d.elg.is_protected ) { /* add the protection */
-	BLOWFISH_context *blowfish_ctx=NULL;
-
-	switch( cert->d.elg.protect.algo ) {
-	  case CIPHER_ALGO_NONE: BUG(); break;
-	  case CIPHER_ALGO_BLOWFISH:
-	    blowfish_ctx = m_alloc_secure( sizeof *blowfish_ctx );
-	    blowfish_setkey( blowfish_ctx, dek->key, dek->keylen );
-	    blowfish_setiv( blowfish_ctx, NULL );
-	    blowfish_encode_cfb( blowfish_ctx,
-				 cert->d.elg.protect.iv,
-				 cert->d.elg.protect.iv, 8 );
-	    buffer = mpi_get_buffer( cert->d.elg.x, &nbytes, NULL );
-	    blowfish_encode_cfb( blowfish_ctx, buffer, buffer, nbytes );
-	    mpi_set_buffer( cert->d.elg.x, buffer, nbytes, 0 );
-	    m_free( buffer );
-	    m_free( blowfish_ctx );
-	    cert->d.elg.is_protected = 1;
-	    break;
-
-	  default:
-	    return G10ERR_CIPHER_ALGO; /* unsupport protection algorithm */
-	}
-    }
-    return 0;
-}
-
-static int
 check_dsa( PKT_secret_cert *cert )
 {
     byte *buffer;
@@ -186,19 +151,18 @@
     DSA_secret_key skey;
     char save_iv[8];
 
-    if( cert->d.dsa.is_protected ) { /* remove the protection */
+    if( cert->is_protected ) { /* remove the protection */
 	DEK *dek = NULL;
 	MPI test_x;
 	BLOWFISH_context *blowfish_ctx=NULL;
 
-	switch( cert->d.dsa.protect.algo ) {
+	switch( cert->protect.algo ) {
 	  case CIPHER_ALGO_NONE: BUG(); break;
 	  case CIPHER_ALGO_BLOWFISH:
 	    keyid_from_skc( cert, keyid );
-	    if( cert->d.dsa.protect.s2k == 1
-		|| cert->d.dsa.protect.s2k == 3 )
+	    if( cert->protect.s2k == 1 || cert->protect.s2k == 3 )
 		dek = get_passphrase_hash( keyid, NULL,
-						 cert->d.dsa.protect.salt );
+						 cert->protect.salt );
 	    else
 		dek = get_passphrase_hash( keyid, NULL, NULL );
 
@@ -206,10 +170,10 @@
 	    blowfish_setkey( blowfish_ctx, dek->key, dek->keylen );
 	    m_free(dek); /* pw is in secure memory, so m_free() burns it */
 	    blowfish_setiv( blowfish_ctx, NULL );
-	    memcpy(save_iv, cert->d.dsa.protect.iv, 8 );
+	    memcpy(save_iv, cert->protect.iv, 8 );
 	    blowfish_decode_cfb( blowfish_ctx,
-				 cert->d.dsa.protect.iv,
-				 cert->d.dsa.protect.iv, 8 );
+				 cert->protect.iv,
+				 cert->protect.iv, 8 );
 	    mpi_set_secure(cert->d.dsa.x );
 	    /*fixme: maybe it is better to set the buffer secure with a
 	     * new get_buffer_secure() function */
@@ -222,9 +186,9 @@
 	    m_free( buffer );
 	    m_free( blowfish_ctx );
 	    /* now let's see wether we have used the right passphrase */
-	    if( csum != cert->d.dsa.csum ) {
+	    if( csum != cert->csum ) {
 		mpi_free(test_x);
-		memcpy( cert->d.dsa.protect.iv, save_iv, 8 );
+		memcpy( cert->protect.iv, save_iv, 8 );
 		return G10ERR_BAD_PASS;
 	    }
 
@@ -237,12 +201,12 @@
 	    memset( &skey, 0, sizeof skey );
 	    if( !res ) {
 		mpi_free(test_x);
-		memcpy( cert->d.dsa.protect.iv, save_iv, 8 );
+		memcpy( cert->protect.iv, save_iv, 8 );
 		return G10ERR_BAD_PASS;
 	    }
 	    mpi_set(cert->d.dsa.x, test_x);
 	    mpi_free(test_x);
-	    cert->d.dsa.is_protected = 0;
+	    cert->is_protected = 0;
 	    break;
 
 	  default:
@@ -254,7 +218,7 @@
 	csum = checksum_u16( nbytes*8 );
 	csum += checksum( buffer, nbytes );
 	m_free( buffer );
-	if( csum != cert->d.dsa.csum )
+	if( csum != cert->csum )
 	    return G10ERR_CHECKSUM;
     }
 
@@ -262,39 +226,6 @@
 }
 
 
-static int
-protect_dsa( PKT_secret_cert *cert, DEK *dek )
-{
-    byte *buffer;
-    unsigned nbytes;
-
-    if( !cert->d.dsa.is_protected ) { /* add the protection */
-	BLOWFISH_context *blowfish_ctx=NULL;
-
-	switch( cert->d.dsa.protect.algo ) {
-	  case CIPHER_ALGO_NONE: BUG(); break;
-	  case CIPHER_ALGO_BLOWFISH:
-	    blowfish_ctx = m_alloc_secure( sizeof *blowfish_ctx );
-	    blowfish_setkey( blowfish_ctx, dek->key, dek->keylen );
-	    blowfish_setiv( blowfish_ctx, NULL );
-	    blowfish_encode_cfb( blowfish_ctx,
-				 cert->d.dsa.protect.iv,
-				 cert->d.dsa.protect.iv, 8 );
-	    buffer = mpi_get_buffer( cert->d.dsa.x, &nbytes, NULL );
-	    blowfish_encode_cfb( blowfish_ctx, buffer, buffer, nbytes );
-	    mpi_set_buffer( cert->d.dsa.x, buffer, nbytes, 0 );
-	    m_free( buffer );
-	    m_free( blowfish_ctx );
-	    cert->d.dsa.is_protected = 1;
-	    break;
-
-	  default:
-	    return G10ERR_CIPHER_ALGO; /* unsupport protection algorithm */
-	}
-    }
-    return 0;
-}
-
 
 #ifdef HAVE_RSA_CIPHER
 static int
@@ -307,11 +238,11 @@
     u32 keyid[2];
     RSA_secret_key skey;
 
-    if( cert->d.rsa.is_protected ) { /* remove the protection */
+    if( cert->is_protected ) { /* remove the protection */
 	DEK *dek = NULL;
 	BLOWFISH_context *blowfish_ctx=NULL;
 
-	switch( cert->d.rsa.protect_algo ) {
+	switch( cert->protect.algo ) {
 	    /* FIXME: use test variables to check for the correct key */
 	  case CIPHER_ALGO_NONE: BUG(); break;
 	  case CIPHER_ALGO_BLOWFISH:
@@ -321,9 +252,8 @@
 	    blowfish_setkey( blowfish_ctx, dek->key, dek->keylen );
 	    m_free(dek); /* pw is in secure memory, so m_free() burns it */
 	    blowfish_setiv( blowfish_ctx, NULL );
-	    blowfish_decode_cfb( blowfish_ctx,
-				 cert->d.rsa.protect.blowfish.iv,
-				 cert->d.rsa.protect.blowfish.iv, 8 );
+	    blowfish_decode_cfb( blowfish_ctx, cert->protect.iv,
+					       cert->protect.iv, 8 );
 	    csum = 0;
 	    #define X(a) do { \
 		mpi_set_secure(cert->d.rsa.rsa_##a); \
@@ -339,10 +269,10 @@
 	    X(q);
 	    X(u);
 	    #undef X
-	    cert->d.rsa.is_protected = 0;
+	    cert->is_protected = 0;
 	    m_free( blowfish_ctx );
 	    /* now let's see wether we have used the right passphrase */
-	    if( csum != cert->d.rsa.csum )
+	    if( csum != cert->csum )
 		return G10ERR_BAD_PASS;
 
 	    skey.d = cert->d.rsa.rsa_d;
@@ -377,7 +307,7 @@
 	csum += checksum_u16( nbytes*8 );
 	csum += checksum( buffer, nbytes );
 	m_free( buffer );
-	if( csum != cert->d.rsa.csum )
+	if( csum != cert->csum )
 	    return G10ERR_CHECKSUM;
     }
 
@@ -424,16 +354,35 @@
 int
 is_secret_key_protected( PKT_secret_cert *cert )
 {
-    if( cert->pubkey_algo == PUBKEY_ALGO_ELGAMAL )
-	return cert->d.elg.is_protected? cert->d.elg.protect.algo : 0;
-    else if( cert->pubkey_algo == PUBKEY_ALGO_DSA )
-	return cert->d.dsa.is_protected? cert->d.dsa.protect.algo : 0;
-  #ifdef HAVE_RSA_CIPHER
-    else if( cert->pubkey_algo == PUBKEY_ALGO_RSA )
-	return cert->d.rsa.is_protected? cert->d.rsa.protect_algo : 0;
-  #endif
-    else
-	return -1; /* unsupported */
+    return cert->is_protected? cert->protect.algo : 0;
+}
+
+
+static int
+do_protect( void (*fnc)(void *, byte *, byte *, unsigned),
+	    void *fncctx, PKT_secret_cert *cert )
+{
+    byte *buffer;
+    unsigned nbytes;
+
+    switch( cert->pubkey_algo ) {
+      case PUBKEY_ALGO_ELGAMAL:
+	buffer = mpi_get_buffer( cert->d.elg.x, &nbytes, NULL );
+	(*fnc)( fncctx, buffer, buffer, nbytes );
+	mpi_set_buffer( cert->d.elg.x, buffer, nbytes, 0 );
+	m_free( buffer );
+	break;
+
+      case PUBKEY_ALGO_DSA:
+	buffer = mpi_get_buffer( cert->d.dsa.x, &nbytes, NULL );
+	(*fnc)( fncctx, buffer, buffer, nbytes );
+	mpi_set_buffer( cert->d.dsa.x, buffer, nbytes, 0 );
+	m_free( buffer );
+	break;
+
+      default: return G10ERR_PUBKEY_ALGO;
+    }
+    return 0;
 }
 
 
@@ -443,14 +392,33 @@
 int
 protect_secret_key( PKT_secret_cert *cert, DEK *dek )
 {
+    int rc=0;
+
     if( !dek )
 	return 0;
 
-    if( cert->pubkey_algo == PUBKEY_ALGO_ELGAMAL )
-	return protect_elg( cert, dek );
-    else if( cert->pubkey_algo == PUBKEY_ALGO_DSA )
-	return protect_dsa( cert, dek );
-    else
-	return G10ERR_PUBKEY_ALGO;
+    if( !cert->is_protected ) { /* okay, apply the protection */
+	BLOWFISH_context *blowfish_ctx=NULL;
+
+	switch( cert->protect.algo ) {
+	  case CIPHER_ALGO_NONE: BUG(); break;
+	  case CIPHER_ALGO_BLOWFISH:
+	    blowfish_ctx = m_alloc_secure( sizeof *blowfish_ctx );
+	    blowfish_setkey( blowfish_ctx, dek->key, dek->keylen );
+	    blowfish_setiv( blowfish_ctx, NULL );
+	    blowfish_encode_cfb( blowfish_ctx, cert->protect.iv,
+					       cert->protect.iv, 8 );
+	    if( !do_protect( (void (*)(void*,byte*,byte*,unsigned))
+			     &blowfish_encode_cfb, blowfish_ctx, cert ) )
+		cert->is_protected = 1;
+	    m_free( blowfish_ctx );
+	    break;
+
+	  default:
+	    rc = G10ERR_CIPHER_ALGO; /* unsupport protection algorithm */
+	    break;
+	}
+    }
+    return rc;
 }
 
diff -urN gnupg-0.2.13/g10/sig-check.c gnupg-0.2.14/g10/sig-check.c
--- gnupg-0.2.13/g10/sig-check.c	Tue Mar 10 11:35:25 1998
+++ gnupg-0.2.14/g10/sig-check.c	Wed Apr  1 11:45:04 1998
@@ -63,6 +63,10 @@
     MPI result = NULL;
     int rc=0;
 
+
+    if( pkc->timestamp > sig->timestamp )
+	return G10ERR_TIME_CONFLICT; /* pubkey newer that signature */
+
     if( pkc->pubkey_algo == PUBKEY_ALGO_ELGAMAL ) {
 	ELG_public_key pkey;
 
@@ -247,7 +251,6 @@
 int
 check_key_signature( KBNODE root, KBNODE node, int *is_selfsig )
 {
-    KBNODE unode;
     MD_HANDLE md;
     PKT_public_cert *pkc;
     PKT_signature *sig;
@@ -279,8 +282,23 @@
 	rc = do_check( pkc, sig, md );
 	md_close(md);
     }
+    else if( sig->sig_class == 0x18 ) {
+	KBNODE snode = find_prev_kbnode( root, node, PKT_PUBKEY_SUBCERT );
+
+	if( snode ) {
+	    md = md_open( algo, 0 );
+	    hash_public_cert( md, pkc );
+	    hash_public_cert( md, snode->pkt->pkt.public_cert );
+	    rc = do_check( pkc, sig, md );
+	    md_close(md);
+	}
+	else {
+	    log_error("no subkey for key signature packet\n");
+	    rc = G10ERR_SIG_CLASS;
+	}
+    }
     else {
-	unode = find_prev_kbnode( root, node, PKT_USER_ID );
+	KBNODE unode = find_prev_kbnode( root, node, PKT_USER_ID );
 
 	if( unode ) {
 	    PKT_user_id *uid = unode->pkt->pkt.user_id;
diff -urN gnupg-0.2.13/g10/sign.c gnupg-0.2.14/g10/sign.c
--- gnupg-0.2.13/g10/sign.c	Mon Mar  9 13:45:00 1998
+++ gnupg-0.2.14/g10/sign.c	Wed Apr  1 16:06:22 1998
@@ -57,7 +57,8 @@
     else
 	BUG();
 
-    /* fixme: should we check wether the signature is okay? */
+    /* fixme: should we check wether the signature is okay?
+     * maybe by using an option */
 
     return rc;
 }
@@ -871,8 +872,8 @@
     KBNODE keyblock = NULL;
     KBNODE node;
     KBPOS kbpos;
-    PKT_public_cert *pkc;
-    PKT_secret_cert *skc;
+    PKT_public_cert *pkc = NULL;
+    PKT_secret_cert *skc = NULL;
     u32 keyid[2];
     int okay=0;
 
@@ -1072,12 +1073,11 @@
 		break;
 	    }
 	    else { /* okay */
-		/* FIXME: what about dsa */
-		skc->d.elg.protect.algo = CIPHER_ALGO_BLOWFISH;
-		skc->d.elg.protect.s2k	= 1;
-		skc->d.elg.protect.hash = DIGEST_ALGO_RMD160;
-		memcpy(skc->d.elg.protect.salt, salt, 8);
-		randomize_buffer(skc->d.elg.protect.iv, 8, 1);
+		skc->protect.algo = CIPHER_ALGO_BLOWFISH;
+		skc->protect.s2k  = 1;
+		skc->protect.hash = DIGEST_ALGO_RMD160;
+		memcpy(skc->protect.salt, salt, 8);
+		randomize_buffer(skc->protect.iv, 8, 1);
 		rc = protect_secret_key( skc, dek );
 		if( rc )
 		    log_error("protect_secret_key failed: %s\n", g10_errstr(rc) );
diff -urN gnupg-0.2.13/g10/signal.c gnupg-0.2.14/g10/signal.c
--- gnupg-0.2.13/g10/signal.c	Tue Mar 10 18:15:07 1998
+++ gnupg-0.2.14/g10/signal.c	Wed Apr  1 16:27:06 1998
@@ -35,7 +35,7 @@
 #include "ttyio.h"
 
 
-
+#if 0
 static RETSIGTYPE
 print_and_exit( int sig )
 {
@@ -53,7 +53,7 @@
     secmem_term();
     exit(2); /* not correct but .. */
 }
-
+#endif
 
 void
 init_signals()
diff -urN gnupg-0.2.13/g10/trustdb.c gnupg-0.2.14/g10/trustdb.c
--- gnupg-0.2.13/g10/trustdb.c	Sat Mar  7 11:57:50 1998
+++ gnupg-0.2.14/g10/trustdb.c	Thu Apr  2 11:17:19 1998
@@ -38,6 +38,7 @@
 #include "options.h"
 #include "packet.h"
 #include "main.h"
+#include "i18n.h"
 
 
 #define TRUST_RECORD_LEN 40
@@ -1388,8 +1389,8 @@
 
 
 /****************
- * we have the pubkey record but nothing more is known
- * function may re-read dr.
+ * we have the pubkey record but nothing more is known.
+ * (function may re-read dr)
  */
 static int
 do_check( ulong pubkeyid, TRUSTREC *dr, unsigned *trustlevel )
@@ -1708,6 +1709,7 @@
     TRUSTREC rec;
     unsigned trustlevel = TRUST_UNKNOWN;
     int rc=0;
+    int cur_time;
 
     if( DBG_TRUST )
 	log_info("check_trust() called.\n");
@@ -1736,12 +1738,25 @@
 				    pkc->local_id );
 	}
     }
-    /* fixme: do some additional checks on the pubkey record */
+    cur_time = make_timestamp();
+    if( pkc->timestamp > cur_time ) {
+	log_info("public key created in future (time warp or clock problem)\n");
+	return G10ERR_TIME_CONFLICT;
+    }
 
-    rc = do_check( pkc->local_id, &rec, &trustlevel );
-    if( rc ) {
-	log_error("check_trust: do_check failed: %s\n", g10_errstr(rc));
-	return rc;
+    if( pkc->valid_days && add_days_to_timestamp(pkc->timestamp,
+						pkc->valid_days) < cur_time ) {
+	log_info(_("key expiration date is %s\n"), strtimestamp(
+				    add_days_to_timestamp(pkc->timestamp,
+							  pkc->valid_days)));
+	 trustlevel = TRUST_EXPIRED;
+    }
+    else {
+	rc = do_check( pkc->local_id, &rec, &trustlevel );
+	if( rc ) {
+	    log_error("check_trust: do_check failed: %s\n", g10_errstr(rc));
+	    return rc;
+	}
     }
 
 
diff -urN gnupg-0.2.13/include/errors.h gnupg-0.2.14/include/errors.h
--- gnupg-0.2.13/include/errors.h	Fri Feb 27 10:38:43 1998
+++ gnupg-0.2.14/include/errors.h	Thu Mar 12 13:31:28 1998
@@ -59,5 +59,6 @@
 #define G10ERR_RENAME_FILE    37
 #define G10ERR_DELETE_FILE    38
 #define G10ERR_UNEXPECTED     39
+#define G10ERR_TIME_CONFLICT  40
 
 #endif /*G10_ERRORS_H*/
diff -urN gnupg-0.2.13/include/i18n.h gnupg-0.2.14/include/i18n.h
--- gnupg-0.2.13/include/i18n.h	Tue Feb 10 10:42:51 1998
+++ gnupg-0.2.14/include/i18n.h	Thu Mar 12 16:02:07 1998
@@ -25,7 +25,7 @@
   #include <locale.h>	/* suggested by Ernst Molitor */
 #endif
 
-#ifdef HAVE_LIBINTL
+#ifdef ENABLE_NLS
   #include <libintl.h>
   #define _(a) gettext (a)
   #ifdef gettext_noop
diff -urN gnupg-0.2.13/include/util.h gnupg-0.2.14/include/util.h
--- gnupg-0.2.13/include/util.h	Fri Feb 27 10:38:43 1998
+++ gnupg-0.2.14/include/util.h	Fri Feb 27 10:38:43 1998
@@ -107,6 +107,8 @@
 
 /*-- miscutil.c --*/
 u32 make_timestamp(void);
+u32 add_days_to_timestamp( u32 stamp, u16 days );
+const char *strtimestamp( u32 atime );
 void print_string( FILE *fp, byte *p, size_t n, int delim );
 int answer_is_yes( const char *s );
 
@@ -116,7 +118,7 @@
 void add_to_strlist( STRLIST *list, const char *string );
 STRLIST strlist_prev( STRLIST head, STRLIST node );
 STRLIST strlist_last( STRLIST node );
-char *memistr( char *buf, size_t buflen, const char *sub );
+const char *memistr( const char *buf, size_t buflen, const char *sub );
 char *mem2str( char *, const void *, size_t);
 char *trim_spaces( char *string );
 int string_count_chr( const char *string, int c );
diff -urN gnupg-0.2.13/po/ChangeLog gnupg-0.2.14/po/ChangeLog
--- gnupg-0.2.13/po/ChangeLog	Thu Feb 26 16:30:22 1998
+++ gnupg-0.2.14/po/ChangeLog	Fri Mar 13 09:43:30 1998
@@ -1 +1,5 @@
+Fri Mar 13 09:43:19 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* it.po: New
+
 
diff -urN gnupg-0.2.13/po/cat-id-tbl.c gnupg-0.2.14/po/cat-id-tbl.c
--- gnupg-0.2.13/po/cat-id-tbl.c	Fri Mar  6 17:10:31 1998
+++ gnupg-0.2.14/po/cat-id-tbl.c	Thu Apr  2 11:13:32 1998
@@ -58,7 +58,7 @@
   {"use canonical text mode", 36},
   {"use as output file", 37},
   {"verbose", 38},
-  {"don't make any changes", 39},
+  {"do not make any changes", 39},
   {"batch mode: never ask", 40},
   {"assume yes on most questions", 41},
   {"assume no on most questions", 42},
@@ -171,7 +171,7 @@
   {"   (3) RSA cannot be used in the U.S.\n", 105},
   {"Your selection? (1,2,3) ", 106},
   {"Your selection? (1,2) ", 107},
-  {"Sorry; DSA is not yet supported.\n", 108},
+  {"Sorry; DSA key generation is not yet supported.\n", 108},
   {"\
 About to generate a new %s keypair.\n\
               minimum keysize is  768 bits\n\
@@ -183,45 +183,58 @@
   {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 113},
   {"Are you sure, that you want this keysize? ", 114},
   {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 115},
-  {"Requested keysize is %u bits\n", 116},
-  {"rounded up to %u bits\n", 117},
+  {"Do you really need such a large keysize? ", 116},
+  {"Requested keysize is %u bits\n", 117},
+  {"rounded up to %u bits\n", 118},
+  {"\
+Please specify how long the key should be valid.\n\
+         0 = key does not expire\n\
+      <n>  = key expires in n days\n\
+      <n>w = key expires in n weeks\n\
+      <n>m = key expires in n months\n\
+      <n>y = key expires in n years\n", 119},
+  {"Key is valid for? (0) ", 120},
+  {"invalid value\n", 121},
+  {"Key does not expire at all\n", 122},
+  {"Key expires at %s\n", 123},
+  {"Is this correct (y/n)? ", 124},
   {"\
 \n\
 You need a User-ID to identify your key; the software constructs the user id\n\
 from Real Name, Comment and Email Address in this form:\n\
-    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n\
-\n", 118},
-  {"Real name: ", 119},
-  {"Invalid character in name\n", 120},
-  {"Name may not start with a digit\n", 121},
-  {"Name must be at least 5 characters long\n", 122},
-  {"Email address: ", 123},
-  {"Not a valid email address\n", 124},
-  {"Comment: ", 125},
-  {"Invalid character in comment\n", 126},
+    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n\
+\n", 125},
+  {"Real name: ", 126},
+  {"Invalid character in name\n", 127},
+  {"Name may not start with a digit\n", 128},
+  {"Name must be at least 5 characters long\n", 129},
+  {"Email address: ", 130},
+  {"Not a valid email address\n", 131},
+  {"Comment: ", 132},
+  {"Invalid character in comment\n", 133},
   {"\
 You selected this USER-ID:\n\
     \"%s\"\n\
-\n", 127},
-  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 128},
+\n", 134},
+  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 135},
   {"\
 You need a Passphrase to protect your secret key.\n\
-\n", 129},
+\n", 136},
   {"\
 You don't what a passphrase - this is probably a *bad* idea!\n\
 I will do it anyway.  You can change your passphrase at anytime,\n\
 using this program with the option \"--change-passphrase\"\n\
-\n", 130},
-  {"passphrase not correctly repeated; try again.\n", 131},
-  {"writing public certificate to '%s'\n", 132},
-  {"writing secret certificate to '%s'\n", 133},
+\n", 137},
+  {"passphrase not correctly repeated; try again.\n", 138},
+  {"writing public certificate to '%s'\n", 139},
+  {"writing secret certificate to '%s'\n", 140},
   {"\
 We need to generate a lot of random bytes. It is a good idea to perform\n\
 some other action (work in another window, move the mouse, utilize the\n\
 network and the disks) during the prime generation; this gives the random\n\
-number generator a better chance to gain enough entropy.\n", 134},
-  {"public and secret key created and signed.\n", 135},
-  {"Key generation failed: %s\n", 136},
+number generator a better chance to gain enough entropy.\n", 141},
+  {"public and secret key created and signed.\n", 142},
+  {"Key generation failed: %s\n", 143},
 };
 
-int _msg_tbl_length = 136;
+int _msg_tbl_length = 143;
Binary files gnupg-0.2.13/po/de.gmo and gnupg-0.2.14/po/de.gmo differ
diff -urN gnupg-0.2.13/po/de.po gnupg-0.2.14/po/de.po
--- gnupg-0.2.13/po/de.po	Tue Feb 24 15:44:28 1998
+++ gnupg-0.2.14/po/de.po	Thu Apr  2 11:49:48 1998
@@ -45,6 +45,16 @@
 "BENUTZEN SIE DIE DURCH DIESES PROGRAMM ERZEUGTEN DATEN NICHT!\n"
 "\n"
 
+
+#: g10/g10.c:214
+msgid ""
+"Syntax: gpgm [options] [files]\n"
+"GNUPG maintenance utility\n"
+msgstr ""
+"Syntax: gpgm [options] [files]\n"
+"GNUPG Wartungs Hilfsmittel\n"
+
+
 #: g10/g10.c:72
 msgid ""
 "Syntax: gpg [options] [files]\n"
@@ -55,43 +65,43 @@
 "Signieren, prfen, verschlsseln, entschlsseln\n"
 "Die voreingestellte Operation ist abhngig von den Eingabedaten\n"
 
+
 #: g10/g10.c:77
-msgid "Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n"
-msgstr "Berichte ber Wanzen bitte an <g10-bugs@isil.d.shuttle.de>.\n"
+msgid "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"
+msgstr "Berichte ber Wanzen bitte an <gnupg-bugs@isil.d.shuttle.de>.\n"
+
+#: g10/g10.c:207
+msgid "Usage: gpgm [options] [files] (-h for help)"
+msgstr "Aufruf: gpgm [Optionen] [Dateien] (-h fr Hilfe)"
+
+#: g10/g10.c:209
+msgid "Usage: gpg [options] [files] (-h for help)"
+msgstr "Aufruf: gpg [Optionen] [Dateien] (-h fr Hilfe)"
 
-#: g10/g10.c:82
-msgid ""
-"   NOTE: This version is compiled without ZLIB support;\n"
-"         you are not able to process compresssed data!\n"
-"WARNING: This version has RSA support! Your are not allowed to\n"
-"         use it inside the Unites States before Sep 30, 2000!\n"
-msgstr ""
-"Achtung: Komprimierte Daten knnen nicht bearbeiten werden,\n"
-"         da auf diesem System ZLIN nicht installiert ist!\n"
-"         (RSA Verfahren ist vorhanden.)\n"
 
-#: g10/g10.c:88
+#: g10/g10.c:152
+msgid "conflicting commands\n"
+msgstr "Widersprechende Kommandos\n"
+
+
+#: g10/g10.c:57
 msgid ""
-"   NOTE: This version is compiled without ZLIB support;\n"
-"         you are not able to process compresssed data!\n"
+"\\vCommands:\n"
+" "
 msgstr ""
-"Achtung: Komprimierte Daten knnen nicht bearbeiten werden,\n"
-"         da auf diesem System ZLIB nicht installiert ist!\n"
+"\\vKommandos:\n"
+" "
 
 #: g10/g10.c:92
 msgid ""
-"WARNING: This version has RSA support! Your are not allowed to\n"
-"         use it inside the Unites States before Sep 30, 2000!\n"
-msgstr ""
-"         (RSA Verfahren ist vorhanden.)\n"
-
-#: g10/g10.c:116
-msgid "Usage: g10 [options] "
-msgstr "Aufruf: g10 [Opeionen] "
+"\\v\n"
+"Options:\n"
+" "
+msgstr ""
+"\\v\n"
+"Optionen:\n"
+" "
 
-#: g10/g10.c:152
-msgid "conflicting commands\n"
-msgstr "Widersprechende Kommandos\n"
 
 #: g10/g10.c:164
 msgid "create ascii armored output"
@@ -106,7 +116,7 @@
 msgstr "Kompressionspegel sethen (aussschalten mit 0)"
 
 #: g10/g10.c:167
-msgid "don't make any changes"
+msgid "do not make any changes"
 msgstr "Keine wirklichen nderungen durchfhren"
 
 #: g10/g10.c:168
@@ -131,27 +141,27 @@
 
 #: g10/g10.c:173
 msgid "generate a new key pair"
-msgstr "Einen neues Schlsselpaar erzeugen"
+msgstr "Ein neues Schlsselpaar erzeugen"
 
-#: g10/g10.c:174
-msgid "add key to the public keyring"
-msgstr ""
-
-#: g10/g10.c:175
-msgid "remove key from public keyring"
-msgstr "Key entfernen"
+#: g10/g10.c:76
+msgid "remove key from the public keyring"
+msgstr "Schlssel entfernen"
+
+#: g10/g10.c:79
+msgid "generate a revocation certificate"
+msgstr "Ein \"Revocation\" Zertifikat erzeugen"
 
 #: g10/g10.c:176
 msgid "make a signature on a key in the keyring"
-msgstr "key signieren"
+msgstr "Schlssel signieren"
 
 #: g10/g10.c:177
 msgid "store only"
-msgstr ""
+msgstr "nur speichern"
 
 #: g10/g10.c:178
 msgid "check signatures on a key in the keyring"
-msgstr "  "
+msgstr "Schlssel Signaturen prfen"
 
 #: g10/g10.c:179
 msgid "add this keyring to the list of keyrings"
@@ -159,149 +169,264 @@
 
 #: g10/g10.c:180
 msgid "make a signature"
-msgstr ""
+msgstr "Eine Signatur erzeugen"
+
+#: g10/g10.c:61
+msgid "make a clear text signature"
+msgstr "Eine Klartext Signatur erzeugen"
 
 #: g10/g10.c:181
 msgid "use canonical text mode"
-msgstr ""
+msgstr "Text Modus benutzen"
 
 #: g10/g10.c:182
 msgid "make a detached signature"
-msgstr ""
+msgstr "Eine abgetrennte Signatur erzeugen"
 
 #: g10/g10.c:183
 msgid "encrypt data"
-msgstr ""
+msgstr "Daten verschlsseln"
+
+#: g10/g10.c:64
+msgid "encryption only with symmetric cipher"
+msgstr "Daten nur symmetrisch verschlsseln"
 
 #: g10/g10.c:184
 msgid "decrypt data (default)"
-msgstr ""
+msgstr "Daten enschlsseln"
+
+
+#: g10/g10.c:67
+msgid "verify a signature"
+msgstr "Signatur prfen"
 
 #: g10/g10.c:185
 msgid "use this user-id to sign or decrypt"
-msgstr ""
+msgstr "Mit dieser User-ID signieren"
 
 #: g10/g10.c:186
 msgid "use this user-id for encryption"
-msgstr ""
+msgstr "Verschlsseln fr diese User-ID"
 
 #: g10/g10.c:187
 msgid "list keys"
-msgstr ""
+msgstr "Liste der Schlssel"
+
+
+#: g10/g10.c:70
+msgid "list keys and signatures"
+msgstr "Liste der Schlssel und deren Signaturen"
+
+#: g10/g10.c:71
+msgid "check key signatures"
+msgstr "Signaturen der Schlssel prfen"
+
+#: g10/g10.c:72
+msgid "list keys and fingerprints"
+msgstr "Liste der Schlssel und deren \"Fingerprints\""
 
 #: g10/g10.c:188
 msgid "set debugging flags"
-msgstr ""
+msgstr "Debug-Flags einschalten"
 
 #: g10/g10.c:189
 msgid "enable full debugging"
-msgstr ""
-
-#: g10/g10.c:193
-msgid "show the fingerprints"
-msgstr ""
+msgstr "Alle Debug-Flags einschalten"
 
 #: g10/g10.c:194
 msgid "print all message digests"
-msgstr ""
+msgstr "Message-Digests fr die Eingabedaten ausgeben"
 
 #: g10/g10.c:195
 msgid "add this secret keyring to the list"
-msgstr ""
+msgstr "Den geheimen Schlsselring mitbenutzen"
 
 #: g10/g10.c:196
 msgid "read options from file"
-msgstr ""
+msgstr "Optionen aus der Datei lesen"
 
 #: g10/g10.c:199
 msgid "list only the sequence of packets"
-msgstr ""
+msgstr "Lediglich die Struktur der Daten Packete anzeigen"
 
 #: g10/g10.c:202
 msgid "edit a key signature"
-msgstr ""
+msgstr "Editieren de Schlssel Signaturen"
 
 #: g10/g10.c:203
 msgid "change the passphrase of your secret keyring"
-msgstr ""
+msgstr "Die \"Passphrase\" des geheimen Schlssels ndern"
 
 #: g10/g10.c:205
 msgid "select default cipher algorithm"
-msgstr ""
+msgstr "Den Cipher Algorithmus auswhlen"
 
 #: g10/g10.c:206
 msgid "select default puplic key algorithm"
-msgstr ""
+msgstr "Den Public-Key Algorithmus auswhlen"
 
 #: g10/g10.c:207
 msgid "select default message digest algorithm"
-msgstr ""
+msgstr "Den Message-Digest Algorithmus auswhlen"
 
-#: g10/g10.c:208
-msgid "put public keys into the trustdb"
-msgstr ""
 
 #: g10/g10.c:212
 msgid "do not write comment packets"
-msgstr ""
+msgstr "Keine Kommentarpackete schreiben"
 
 #: g10/g10.c:213
 msgid "(default is 1)"
-msgstr ""
+msgstr "(voreingestellt ist 1)"
 
 #: g10/g10.c:214
 msgid "(default is 3)"
-msgstr ""
+msgstr "(voreingestellt ist 3)"
+
+#: g10/g10.c:81
+msgid "export keys"
+msgstr "Schlssel exportieren"
+
+#: g10/g10.c:82
+msgid "import/merge keys"
+msgstr "Schlssel importieren/kombinieren"
+
+#: g10/g10.c:85
+msgid "De-Armor a file or stdin"
+msgstr "\"De-Armor\" einer Datei oder stdin"
+
+#: g10/g10.c:86
+msgid "En-Armor a file or stdin"
+msgstr "\"En-Armor\" einer Datei oder stdin"
 
-#: g10/g10.c:215
-msgid "export all or the given keys"
-msgstr ""
 
 #: g10/g10.c:282
 msgid "note: no default option file '%s'\n"
-msgstr ""
+msgstr "Notiz: Keine voreingestellte Optionen Datei '%s' vorhanden\n"
 
 #: g10/g10.c:285
 msgid "option file '%s': %s\n"
-msgstr ""
+msgstr "Opionen Datei '%s': %s\n"
 
 #: g10/g10.c:290
 msgid "reading options from '%s'\n"
-msgstr ""
+msgstr "Optionen werden von '%s' gelesen\n"
 
 #: g10/g10.c:382
 msgid "selected cipher algorithm is invalid\n"
-msgstr ""
+msgstr "Der ausgewhlte Cipher Algorithmus ist ungltig\n"
 
 #: g10/g10.c:386
 msgid "selected pubkey algorithm is invalid\n"
-msgstr ""
+msgstr "Der ausgewhlte Public-Key Algorithmus ist ungltig\n"
 
 #: g10/g10.c:390
 msgid "selected digest algorithm is invalid\n"
-msgstr ""
+msgstr "Der ausgewhlte Message-Digest Algorithmus ist ungltig\n"
 
 #: g10/g10.c:394
 msgid "completes-needed must be greater than 0\n"
-msgstr ""
+msgstr "completes-needed men grer als 0 sein\n"
 
 #: g10/g10.c:398
 msgid "marginals-needed must be greater than 1\n"
-msgstr ""
+msgstr "marginals-needed men grer als 1 sein\n"
 
 #: g10/g10.c:462
 msgid "failed to initialize the TrustDB: %s\n"
-msgstr ""
+msgstr "Die Trust-DB kann nicht initialisiert werden: %s\n"
 
 #: g10/g10.c:554 g10/g10.c:571 g10/g10.c:660
 msgid "can't open '%s'\n"
+msgstr "Datei '%s' kann nicht geffnet werden\n"
+
+
+#: g10/g10.c:113
+msgid "write status info to this fd"
+msgstr "Status Informationen auf diesen FD schreiben"
+
+#: g10/g10.c:124
+msgid ""
+"\\v\n"
+"Examples:\n"
+"\n"
+" -se -r Bob [file]          sign and encrypt for user Bob\n"
+" -sat [file]                make a clear text signature\n"
+" -sb  [file]                make a detached signature\n"
+" -k   [userid]              show keys\n"
+" -kc  [userid]              show fingerprint\n"
 msgstr ""
+"\\v\n"
+"Beispiele:\n"
+"\n"
+" -se -r Bob [file]          Signieren und verschlsseln fr Benutzer Bob\n"
+" -sat [file]                Eine Klartext Signatur erzeugen\n"
+" -sb  [file]                Eine abgetrennte Signatur erzeugen\n"
+" -k   [userid]              Die Schllssel anzeigen\n"
+" -kc  [userid]              Die \"Fingerprints\" anzeigen\n"
+
+
+
+#: g10/g10.c:666
+msgid "--store [filename]"
+msgstr "--store [Dateiname]"
+
+#. encrypt the given file only with the symmetric cipher
+#: g10/g10.c:674
+msgid "--symmetric [filename]"
+msgstr "--symmetric [Dateiname]"
+
+#: g10/g10.c:682
+msgid "--encrypt [filename]"
+msgstr "--encrypt [Dateiname]"
+
+#: g10/g10.c:695
+msgid "--sign [filename]"
+msgstr "--sign [Dateiname]"
+
+#: g10/g10.c:708
+msgid "--sign --encrypt [filename]"
+msgstr "--sign --encrypt [Dateiname]"
+
+#. make a clearsig
+#: g10/g10.c:722
+msgid "--clearsign [filename]"
+msgstr "--clearsign [Dateiname]"
+
+#: g10/g10.c:734
+msgid "--decrypt [filename]"
+msgstr "--decrypt [Dateiname]"
+
+#: g10/g10.c:742
+msgid "--sign-key username"
+msgstr "--sign-key Benutzername"
+
+#: g10/g10.c:750
+msgid "--edit-sig username"
+msgstr "--edit-sig Benutzername"
+
+#: g10/g10.c:758
+msgid "--delete-secret-key username"
+msgstr "--delete-secret-key Benutzername"
+
+#: g10/g10.c:761
+msgid "--delete-key username"
+msgstr "--delete-key Benutzername"
+
+#. no arg: use default, 1 arg use this one
+#: g10/g10.c:769
+msgid "--change-passphrase [username]"
+msgstr "--change-passphrase [Benutzername]"
+
+
+
 
 #: g10/pkclist.c:65
 msgid ""
 "No ownertrust defined for %lu:\n"
 "%4u%c/%08lX %s \""
 msgstr ""
+"Es ist kein \"Ownertrust\" fr %lu definiert:\n"
+"%4u%c/%08lX %s \""
 
 #: g10/pkclist.c:72
 msgid ""
@@ -344,7 +469,7 @@
 
 #: g10/pkclist.c:108
 msgid "You will see a list of signators etc. here\n"
-msgstr ""
+msgstr "Sie sollten hier eigentlich eine Liste der Signierer sehen.\n"
 
 #: g10/pkclist.c:132
 msgid ""
@@ -358,11 +483,11 @@
 
 #: g10/keygen.c:109
 msgid "writing self signature\n"
-msgstr ""
+msgstr "Die Selbst-Signatur wird geschrieben\n"
 
 #: g10/keygen.c:299
 msgid "Key generation can only be used in interactive mode\n"
-msgstr ""
+msgstr "Die Schlsselerzeugung kann nur im interaktiven Modus benutzt werden\n"
 
 #: g10/keygen.c:301
 msgid ""
@@ -370,22 +495,25 @@
 "   (1) ElGamal is the suggested one.\n"
 "   (2) DSA can only be used for signatures.\n"
 msgstr ""
+"Bitte whlen Sie den zu benutzenden Algorithmus aus:\n"
+"   (1) ElGamal wird empfohlen.\n"
+"   (2) DSA kann nur fr Signaturen verwendet werden.\n"
 
 #: g10/keygen.c:305
 msgid "   (3) RSA cannot be used in the U.S.\n"
-msgstr ""
+msgstr "   (3) RSA darf in den USA nicht benutzt werden\n"
 
 #: g10/keygen.c:314
 msgid "Your selection? (1,2,3) "
-msgstr ""
+msgstr "Ihre Auswahl? (1,2,3) "
 
 #: g10/keygen.c:316
 msgid "Your selection? (1,2) "
-msgstr ""
+msgstr "Ihre Auswahl? (1,2) "
 
 #: g10/keygen.c:330
 msgid "Sorry; DSA is not yet supported.\n"
-msgstr ""
+msgstr "Pardon; DSA wird noch nicht untersttzt.\n"
 
 #: g10/keygen.c:343
 msgid ""
@@ -428,25 +556,25 @@
 
 #: g10/keygen.c:377
 msgid "Requested keysize is %u bits\n"
-msgstr ""
+msgstr "Die verlangte Schlssellnge ist %u Bits\n"
 
 #: g10/keygen.c:380 g10/keygen.c:384
 msgid "rounded up to %u bits\n"
-msgstr ""
+msgstr "aufgerundet auf %u Bits\n"
 
 #: g10/keygen.c:391
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
 "from Real Name, Comment and Email Address in this form:\n"
-"    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n"
+"    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n"
 "\n"
 msgstr ""
 "\n"
 "Sie bentigen einen User-ID um Ihren Schlssel eindeutig zu machen; das\n"
 "Programm baut diese User-ID aus Ihrem echten Namen, einem Kommentar und\n"
 "Ihrer Email Adresse in dieser Form auf:\n"
-"    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n"
+"    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n"
 "\n"
 
 
@@ -526,11 +654,11 @@
 
 #: g10/keygen.c:531
 msgid "writing public certificate to '%s'\n"
-msgstr ""
+msgstr "schreiben des ffentlichen Schlssels nach '%s'\n"
 
 #: g10/keygen.c:532
 msgid "writing secret certificate to '%s'\n"
-msgstr ""
+msgstr "schreiben des geheimen Schlssels nach '%s'\n"
 
 #: g10/keygen.c:544
 msgid ""
@@ -549,4 +677,9 @@
 
 #: g10/keygen.c:622
 msgid "Key generation failed: %s\n"
-msgstr ""
+msgstr "Schlssel-Erzeugung fehlgeschlagen: %s\n"
+
+
+
+
+
diff -urN gnupg-0.2.13/po/gnupg.pot gnupg-0.2.14/po/gnupg.pot
--- gnupg-0.2.13/po/gnupg.pot	Tue Mar 10 17:07:01 1998
+++ gnupg-0.2.14/po/gnupg.pot	Thu Apr  2 11:13:30 1998
@@ -1,6 +1,6 @@
 msgid ""
 msgstr ""
-"Date: 1998-03-10 17:07:01+0100\n"
+"Date: 1998-04-02 11:13:29+0200\n"
 "From: Werner Koch <wk@frodo>\n"
 "Content-Type: text/plain; charset=\n"
 "Xgettext-Options: --default-domain=gnupg --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
@@ -30,208 +30,208 @@
 "\n"
 msgstr ""
 
-#: g10/g10.c:56
+#: g10/g10.c:57
 msgid ""
 "\\vCommands:\n"
 " "
 msgstr ""
 
-#: g10/g10.c:59
+#: g10/g10.c:60
 msgid "make a signature"
 msgstr ""
 
-#: g10/g10.c:60
+#: g10/g10.c:61
 msgid "make a clear text signature"
 msgstr ""
 
-#: g10/g10.c:61
+#: g10/g10.c:62
 msgid "make a detached signature"
 msgstr ""
 
-#: g10/g10.c:62
+#: g10/g10.c:63
 msgid "encrypt data"
 msgstr ""
 
-#: g10/g10.c:63
+#: g10/g10.c:64
 msgid "encryption only with symmetric cipher"
 msgstr ""
 
-#: g10/g10.c:64
+#: g10/g10.c:65
 msgid "store only"
 msgstr ""
 
-#: g10/g10.c:65
+#: g10/g10.c:66
 msgid "decrypt data (default)"
 msgstr ""
 
-#: g10/g10.c:66
+#: g10/g10.c:67
 msgid "verify a signature"
 msgstr ""
 
-#: g10/g10.c:68
+#: g10/g10.c:69
 msgid "list keys"
 msgstr ""
 
-#: g10/g10.c:69
+#: g10/g10.c:70
 msgid "list keys and signatures"
 msgstr ""
 
-#: g10/g10.c:70
+#: g10/g10.c:71
 msgid "check key signatures"
 msgstr ""
 
-#: g10/g10.c:71
+#: g10/g10.c:72
 msgid "list keys and fingerprints"
 msgstr ""
 
-#: g10/g10.c:73
+#: g10/g10.c:74
 msgid "generate a new key pair"
 msgstr ""
 
-#: g10/g10.c:74
+#: g10/g10.c:75
 msgid "make a signature on a key in the keyring"
 msgstr ""
 
-#: g10/g10.c:75
+#: g10/g10.c:76
 msgid "remove key from the public keyring"
 msgstr ""
 
-#: g10/g10.c:76
+#: g10/g10.c:77
 msgid "edit a key signature"
 msgstr ""
 
-#: g10/g10.c:77
+#: g10/g10.c:78
 msgid "change the passphrase of your secret keyring"
 msgstr ""
 
-#: g10/g10.c:78
+#: g10/g10.c:79
 msgid "generate a revocation certificate"
 msgstr ""
 
-#: g10/g10.c:80
+#: g10/g10.c:81
 msgid "export keys"
 msgstr ""
 
-#: g10/g10.c:81
+#: g10/g10.c:82
 msgid "import/merge keys"
 msgstr ""
 
-#: g10/g10.c:82
+#: g10/g10.c:83
 msgid "list only the sequence of packets"
 msgstr ""
 
-#: g10/g10.c:84
+#: g10/g10.c:85
 msgid "De-Armor a file or stdin"
 msgstr ""
 
-#: g10/g10.c:85
+#: g10/g10.c:86
 msgid "En-Armor a file or stdin"
 msgstr ""
 
-#: g10/g10.c:86
+#: g10/g10.c:87
 msgid "print all message digests"
 msgstr ""
 
-#: g10/g10.c:91
+#: g10/g10.c:92
 msgid ""
 "\\v\n"
 "Options:\n"
 " "
 msgstr ""
 
-#: g10/g10.c:94
+#: g10/g10.c:95
 msgid "create ascii armored output"
 msgstr ""
 
-#: g10/g10.c:95
+#: g10/g10.c:96
 msgid "use this user-id to sign or decrypt"
 msgstr ""
 
-#: g10/g10.c:96
+#: g10/g10.c:97
 msgid "use this user-id for encryption"
 msgstr ""
 
-#: g10/g10.c:97
+#: g10/g10.c:98
 msgid "set compress level (0 disables)"
 msgstr ""
 
-#: g10/g10.c:98
+#: g10/g10.c:99
 msgid "use canonical text mode"
 msgstr ""
 
-#: g10/g10.c:100
+#: g10/g10.c:101
 msgid "use as output file"
 msgstr ""
 
-#: g10/g10.c:101
+#: g10/g10.c:102
 msgid "verbose"
 msgstr ""
 
-#: g10/g10.c:102
-msgid "don't make any changes"
+#: g10/g10.c:103
+msgid "do not make any changes"
 msgstr ""
 
-#: g10/g10.c:103
+#: g10/g10.c:104
 msgid "batch mode: never ask"
 msgstr ""
 
-#: g10/g10.c:104
+#: g10/g10.c:105
 msgid "assume yes on most questions"
 msgstr ""
 
-#: g10/g10.c:105
+#: g10/g10.c:106
 msgid "assume no on most questions"
 msgstr ""
 
-#: g10/g10.c:106
+#: g10/g10.c:107
 msgid "add this keyring to the list of keyrings"
 msgstr ""
 
-#: g10/g10.c:107
+#: g10/g10.c:108
 msgid "add this secret keyring to the list"
 msgstr ""
 
-#: g10/g10.c:108
+#: g10/g10.c:109
 msgid "read options from file"
 msgstr ""
 
-#: g10/g10.c:110
+#: g10/g10.c:111
 msgid "set debugging flags"
 msgstr ""
 
-#: g10/g10.c:111
+#: g10/g10.c:112
 msgid "enable full debugging"
 msgstr ""
 
-#: g10/g10.c:112
+#: g10/g10.c:113
 msgid "write status info to this fd"
 msgstr ""
 
-#: g10/g10.c:113
+#: g10/g10.c:114
 msgid "do not write comment packets"
 msgstr ""
 
-#: g10/g10.c:114
+#: g10/g10.c:115
 msgid "(default is 1)"
 msgstr ""
 
-#: g10/g10.c:115
+#: g10/g10.c:116
 msgid "(default is 3)"
 msgstr ""
 
-#: g10/g10.c:117
+#: g10/g10.c:118
 msgid "select default cipher algorithm"
 msgstr ""
 
-#: g10/g10.c:118
+#: g10/g10.c:119
 msgid "select default puplic key algorithm"
 msgstr ""
 
-#: g10/g10.c:119
+#: g10/g10.c:120
 msgid "select default message digest algorithm"
 msgstr ""
 
-#: g10/g10.c:123
+#: g10/g10.c:124
 msgid ""
 "\\v\n"
 "Examples:\n"
@@ -243,156 +243,156 @@
 " -kc  [userid]              show fingerprint\n"
 msgstr ""
 
-#: g10/g10.c:201
+#: g10/g10.c:202
 msgid "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"
 msgstr ""
 
-#: g10/g10.c:206
+#: g10/g10.c:207
 msgid "Usage: gpgm [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:208
+#: g10/g10.c:209
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:213
+#: g10/g10.c:214
 msgid ""
 "Syntax: gpgm [options] [files]\n"
 "GNUPG maintenance utility\n"
 msgstr ""
 
-#: g10/g10.c:216
+#: g10/g10.c:217
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
 "default operation depends on the input data\n"
 msgstr ""
 
-#: g10/g10.c:293
+#: g10/g10.c:294
 msgid "usage: gpgm [options] "
 msgstr ""
 
-#: g10/g10.c:295
+#: g10/g10.c:296
 msgid "usage: gpg [options] "
 msgstr ""
 
-#: g10/g10.c:335
+#: g10/g10.c:336
 msgid "conflicting commands\n"
 msgstr ""
 
-#: g10/g10.c:348
+#: g10/g10.c:349
 msgid "selected cipher algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:350
+#: g10/g10.c:351
 msgid "selected pubkey algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:352
+#: g10/g10.c:353
 msgid "selected digest algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:354
+#: g10/g10.c:355
 msgid "completes-needed must be greater than 0\n"
 msgstr ""
 
-#: g10/g10.c:356
+#: g10/g10.c:357
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:450
+#: g10/g10.c:451
 msgid "note: no default option file '%s'\n"
 msgstr ""
 
-#: g10/g10.c:454
+#: g10/g10.c:455
 msgid "option file '%s': %s\n"
 msgstr ""
 
-#: g10/g10.c:461
+#: g10/g10.c:462
 msgid "reading options from '%s'\n"
 msgstr ""
 
-#: g10/g10.c:657
+#: g10/g10.c:660
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
-#: g10/g10.c:663
+#: g10/g10.c:666
 msgid "--store [filename]"
 msgstr ""
 
 #. encrypt the given file only with the symmetric cipher
-#: g10/g10.c:671
+#: g10/g10.c:674
 msgid "--symmetric [filename]"
 msgstr ""
 
-#: g10/g10.c:679
+#: g10/g10.c:682
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:692
+#: g10/g10.c:695
 msgid "--sign [filename]"
 msgstr ""
 
-#: g10/g10.c:705
+#: g10/g10.c:708
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
 #. make a clearsig
-#: g10/g10.c:719
+#: g10/g10.c:722
 msgid "--clearsign [filename]"
 msgstr ""
 
-#: g10/g10.c:731
+#: g10/g10.c:734
 msgid "--decrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:739
+#: g10/g10.c:742
 msgid "--sign-key username"
 msgstr ""
 
-#: g10/g10.c:747
+#: g10/g10.c:750
 msgid "--edit-sig username"
 msgstr ""
 
-#: g10/g10.c:755
+#: g10/g10.c:758
 msgid "--delete-secret-key username"
 msgstr ""
 
-#: g10/g10.c:758
+#: g10/g10.c:761
 msgid "--delete-key username"
 msgstr ""
 
 #. no arg: use default, 1 arg use this one
-#: g10/g10.c:766
+#: g10/g10.c:769
 msgid "--change-passphrase [username]"
 msgstr ""
 
-#: g10/g10.c:787
+#: g10/g10.c:790
 msgid "can't open %s: %s\n"
 msgstr ""
 
-#: g10/g10.c:798
+#: g10/g10.c:801
 msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr ""
 
-#: g10/g10.c:804
+#: g10/g10.c:807
 msgid "--gen-key"
 msgstr ""
 
-#: g10/g10.c:845
+#: g10/g10.c:848
 msgid "dearmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:853
+#: g10/g10.c:856
 msgid "enarmoring failed: %s\n"
 msgstr ""
 
 #. fixme: g10maint should to regular maintenace tasks here
-#: g10/g10.c:934
+#: g10/g10.c:937
 msgid "[filename]"
 msgstr ""
 
-#: g10/g10.c:936
+#: g10/g10.c:939
 msgid "can't open '%s'\n"
 msgstr ""
 
@@ -464,38 +464,38 @@
 msgid "Enter the user ID: "
 msgstr ""
 
-#: g10/keygen.c:109
+#: g10/keygen.c:104
 msgid "writing self signature\n"
 msgstr ""
 
-#: g10/keygen.c:303
+#: g10/keygen.c:326
 msgid "Key generation can only be used in interactive mode\n"
 msgstr ""
 
-#: g10/keygen.c:307
+#: g10/keygen.c:330
 msgid ""
 "Please select the algorithm to use:\n"
 "   (1) ElGamal is the suggested one.\n"
 "   (2) DSA can only be used for signatures.\n"
 msgstr ""
 
-#: g10/keygen.c:311
+#: g10/keygen.c:334
 msgid "   (3) RSA cannot be used in the U.S.\n"
 msgstr ""
 
-#: g10/keygen.c:320
+#: g10/keygen.c:339
 msgid "Your selection? (1,2,3) "
 msgstr ""
 
-#: g10/keygen.c:322
+#: g10/keygen.c:341
 msgid "Your selection? (1,2) "
 msgstr ""
 
-#: g10/keygen.c:336
-msgid "Sorry; DSA is not yet supported.\n"
+#: g10/keygen.c:354
+msgid "Sorry; DSA key generation is not yet supported.\n"
 msgstr ""
 
-#: g10/keygen.c:349
+#: g10/keygen.c:367
 msgid ""
 "About to generate a new %s keypair.\n"
 "              minimum keysize is  768 bits\n"
@@ -503,97 +503,132 @@
 "    highest suggested keysize is 2048 bits\n"
 msgstr ""
 
-#: g10/keygen.c:357
+#: g10/keygen.c:372
 msgid "What keysize do you want? (1024) "
 msgstr ""
 
-#: g10/keygen.c:363
+#: g10/keygen.c:377
 msgid "DSA does only allow keysizes from 512 to 1024\n"
 msgstr ""
 
-#: g10/keygen.c:365
+#: g10/keygen.c:379
 msgid "keysize too small; 768 is smallest value allowed.\n"
 msgstr ""
 
-#: g10/keygen.c:367
+#: g10/keygen.c:381
 msgid "Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n"
 msgstr ""
 
-#: g10/keygen.c:369
+#: g10/keygen.c:383
 msgid "Are you sure, that you want this keysize? "
 msgstr ""
 
-#: g10/keygen.c:373
+#: g10/keygen.c:387
 msgid "Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n"
 msgstr ""
 
-#: g10/keygen.c:383
+#: g10/keygen.c:395
+msgid "Do you really need such a large keysize? "
+msgstr ""
+
+#: g10/keygen.c:406
 msgid "Requested keysize is %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:386 g10/keygen.c:390
+#: g10/keygen.c:409 g10/keygen.c:413
 msgid "rounded up to %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:397
+#: g10/keygen.c:416
+msgid ""
+"Please specify how long the key should be valid.\n"
+"         0 = key does not expire\n"
+"      <n>  = key expires in n days\n"
+"      <n>w = key expires in n weeks\n"
+"      <n>m = key expires in n months\n"
+"      <n>y = key expires in n years\n"
+msgstr ""
+
+#: g10/keygen.c:427
+msgid "Key is valid for? (0) "
+msgstr ""
+
+#: g10/keygen.c:438
+msgid "invalid value\n"
+msgstr ""
+
+#: g10/keygen.c:443
+msgid "Key does not expire at all\n"
+msgstr ""
+
+#: g10/keygen.c:445
+msgid "Key expires at %s\n"
+msgstr ""
+
+#: g10/keygen.c:450
+msgid "Is this correct (y/n)? "
+msgstr ""
+
+#: g10/keygen.c:459
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
 "from Real Name, Comment and Email Address in this form:\n"
-"    \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n"
+"    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:409
+#: g10/keygen.c:471
 msgid "Real name: "
 msgstr ""
 
-#: g10/keygen.c:413
+#: g10/keygen.c:475
 msgid "Invalid character in name\n"
 msgstr ""
 
-#: g10/keygen.c:415
+#: g10/keygen.c:477
 msgid "Name may not start with a digit\n"
 msgstr ""
 
-#: g10/keygen.c:417
+#: g10/keygen.c:479
 msgid "Name must be at least 5 characters long\n"
 msgstr ""
 
-#: g10/keygen.c:425
+#: g10/keygen.c:487
 msgid "Email address: "
 msgstr ""
 
-#: g10/keygen.c:437
+#: g10/keygen.c:499
 msgid "Not a valid email address\n"
 msgstr ""
 
-#: g10/keygen.c:445
+#: g10/keygen.c:507
 msgid "Comment: "
 msgstr ""
 
-#: g10/keygen.c:451
+#: g10/keygen.c:513
 msgid "Invalid character in comment\n"
 msgstr ""
 
-#: g10/keygen.c:471
+#: g10/keygen.c:533
 msgid ""
 "You selected this USER-ID:\n"
 "    \"%s\"\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:473
+#. fixme: add a warning if this the user-id already exists
+#: g10/keygen.c:536
 msgid "Edit (N)ame, (C)omment, (E)mail or (O)kay? "
 msgstr ""
 
-#: g10/keygen.c:505
+#: g10/keygen.c:567
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:516
+#: g10/keygen.c:578
 msgid ""
 "You don't what a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at anytime,\n"
@@ -601,19 +636,19 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:522
+#: g10/keygen.c:584
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr ""
 
-#: g10/keygen.c:539
+#: g10/keygen.c:601
 msgid "writing public certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:540
+#: g10/keygen.c:602
 msgid "writing secret certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:552
+#: g10/keygen.c:614
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -621,10 +656,10 @@
 "number generator a better chance to gain enough entropy.\n"
 msgstr ""
 
-#: g10/keygen.c:627
+#: g10/keygen.c:688
 msgid "public and secret key created and signed.\n"
 msgstr ""
 
-#: g10/keygen.c:638
+#: g10/keygen.c:699
 msgid "Key generation failed: %s\n"
 msgstr ""
Binary files gnupg-0.2.13/po/it.gmo and gnupg-0.2.14/po/it.gmo differ
diff -urN gnupg-0.2.13/po/it.po gnupg-0.2.14/po/it.po
--- gnupg-0.2.13/po/it.po	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.14/po/it.po	Thu Apr  2 11:13:16 1998
@@ -0,0 +1,726 @@
+msgid ""
+msgstr ""
+"Content-Type: text/plain; charset=iso-8859-1\n"
+"Date: 1998-03-07 12:16:14+0100\n"
+"From: Marco d'Itri <md@linux.it>\n"
+"Xgettext-Options: --default-domain=gnupg --directory=.. --add-comments "
+"--keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
+"Files: util/secmem.c cipher/random.c g10/g10.c g10/pkclist.c g10/keygen.c\n"
+
+#: util/secmem.c:180
+msgid "Warning: using insecure memory!\n"
+msgstr "Attenzione: si sta usando memoria insicura!\n"
+
+#: cipher/random.c:419
+msgid ""
+"\n"
+"Not enough random bytes available.  Please do some other work to give\n"
+"the OS a chance to collect more entropy! (Need %d more bytes)\n"
+msgstr ""
+"\n"
+"Non ci sono abbastanza byte casuali disponibili. Per favore fai\n"
+"qualche altro lavoro per dare al sistema operativo un'occasione per\n"
+"raccogliere altra entropia! (Servono ancora %d byte)\n"
+
+#: cipher/random.c:459
+msgid "warning: using insecure random number generator!!\n"
+msgstr "Attenzione: si sta usando un generatore di numeri casuali insicuro!!\n"
+
+# #### Md - kludge?
+#: cipher/random.c:460
+msgid ""
+"The random number generator is only a kludge to let\n"
+"it compile - it is in no way a strong RNG!\n"
+"\n"
+"DON'T USE ANY DATA GENERATED BY THIS PROGRAM!!\n"
+"\n"
+msgstr ""
+"Il generatore di numeri casuali  solo un ripiego usato\n"
+"per compilare il programma - non  assolutamente un forte RNG!\n"
+"\n"
+"NON USARE ALCUN DATO GENERATO DA QUESTO PROGRAMMA!!\n"
+"\n"
+
+#: g10/g10.c:56
+msgid ""
+"\\vCommands:\n"
+" "
+msgstr ""
+"\\vComandi:\n"
+" "
+
+#: g10/g10.c:59
+msgid "make a signature"
+msgstr "fai una firma"
+
+#: g10/g10.c:60
+msgid "make a clear text signature"
+msgstr "fai una firma al testo in chiaro"
+
+#: g10/g10.c:61
+msgid "make a detached signature"
+msgstr "fai una firma separata"
+
+#: g10/g10.c:62
+msgid "encrypt data"
+msgstr "cifra dati"
+
+#: g10/g10.c:63
+msgid "encryption only with symmetric cipher"
+msgstr "cifra solo con un cifrario simmetrico"
+
+#: g10/g10.c:64
+msgid "store only"
+msgstr "immagazzina solo"
+
+#: g10/g10.c:65
+msgid "decrypt data (default)"
+msgstr "decifra dati (predefinito)"
+
+#: g10/g10.c:66
+msgid "verify a signature"
+msgstr "verifica una firma"
+
+#: g10/g10.c:68
+msgid "list keys"
+msgstr "elenca le chiavi"
+
+#: g10/g10.c:69
+msgid "list keys and signatures"
+msgstr "elenca le chiavi e le firme"
+
+#: g10/g10.c:70
+msgid "check key signatures"
+msgstr "controlla le firme delle chiavi"
+
+#: g10/g10.c:71
+msgid "list keys and fingerprints"
+msgstr "elenca le chiavi e le impronte digitali"
+
+#: g10/g10.c:73
+msgid "generate a new key pair"
+msgstr "genera una nuova coppia di chiavi"
+
+#: g10/g10.c:74
+msgid "make a signature on a key in the keyring"
+msgstr "firma una chiave nel portachiavi"
+
+#: g10/g10.c:75
+msgid "remove key from the public keyring"
+msgstr "rimuovi una chiave dal portachiavi pubblico"
+
+#: g10/g10.c:76
+msgid "edit a key signature"
+msgstr "modifica la firma di una chiave"
+
+#: g10/g10.c:77
+msgid "change the passphrase of your secret keyring"
+msgstr "cambia la passphrase del tuo portachiavi segreto"
+
+#: g10/g10.c:78
+msgid "generate a revocation certificate"
+msgstr "genera un certificato di revoca"
+
+#: g10/g10.c:80
+msgid "export keys"
+msgstr "esporta delle chiavi"
+
+#: g10/g10.c:81
+msgid "import/merge keys"
+msgstr "importa/aggiungi delle chiavi"
+
+#: g10/g10.c:82
+msgid "list only the sequence of packets"
+msgstr "elenca solo la sequenza dei pacchetti"
+
+#: g10/g10.c:84
+msgid "De-Armor a file or stdin"
+msgstr "rimuovi l'armatura a un file o a stdin"
+
+#: g10/g10.c:85
+msgid "En-Armor a file or stdin"
+msgstr "crea l'armatura a un file o a stdin"
+
+#: g10/g10.c:86
+msgid "print all message digests"
+msgstr "stampa tutti i message digests"
+
+#: g10/g10.c:91
+msgid ""
+"\\v\n"
+"Options:\n"
+" "
+msgstr ""
+"\\v\n"
+"Opzioni:\n"
+" "
+
+#: g10/g10.c:94
+msgid "create ascii armored output"
+msgstr "crea un output ascii con armatura"
+
+#: g10/g10.c:95
+msgid "use this user-id to sign or decrypt"
+msgstr "usa questo user-id per firmare o decifrare"
+
+#: g10/g10.c:96
+msgid "use this user-id for encryption"
+msgstr "usa questo user-id per cifrare"
+
+#: g10/g10.c:97
+msgid "set compress level (0 disables)"
+msgstr "imposta il livello di compressione (0 disabilita)"
+
+#: g10/g10.c:98
+msgid "use canonical text mode"
+msgstr "usa il modo testo canonico"
+
+#: g10/g10.c:100
+msgid "use as output file"
+msgstr "usa come un file di output"
+
+#: g10/g10.c:101
+msgid "verbose"
+msgstr "prolisso"
+
+#: g10/g10.c:102
+msgid "don't make any changes"
+msgstr "non fare cambiamenti"
+
+#: g10/g10.c:103
+msgid "batch mode: never ask"
+msgstr "modo batch: non fare domande"
+
+#: g10/g10.c:104
+msgid "assume yes on most questions"
+msgstr "assumi \"si\" a quasi tutte le domande"
+
+#: g10/g10.c:105
+msgid "assume no on most questions"
+msgstr "assumi \"no\" a quasi tutte le domande"
+
+#: g10/g10.c:106
+msgid "add this keyring to the list of keyrings"
+msgstr "aggiungi questo portachiavi alla lista dei portachiavi"
+
+#: g10/g10.c:107
+msgid "add this secret keyring to the list"
+msgstr "aggiungi questo portachiavi segreto alla lista"
+
+#: g10/g10.c:108
+msgid "read options from file"
+msgstr "leggi le opzioni dal file"
+
+#: g10/g10.c:110
+msgid "set debugging flags"
+msgstr "imposa i flag di debugging"
+
+#: g10/g10.c:111
+msgid "enable full debugging"
+msgstr "abilita il debugging completo"
+
+#: g10/g10.c:112
+msgid "write status info to this fd"
+msgstr "scrivi le informazioni di stato su questo fd"
+
+#: g10/g10.c:113
+msgid "do not write comment packets"
+msgstr "non scrivere pacchetti di commento"
+
+#: g10/g10.c:114
+msgid "(default is 1)"
+msgstr "(predefinito  1)"
+
+#: g10/g10.c:115
+msgid "(default is 3)"
+msgstr "(predefinito  3)"
+
+#: g10/g10.c:117
+msgid "select default cipher algorithm"
+msgstr "seleziona l'algoritmo di cifratura predefinito"
+
+#: g10/g10.c:118
+msgid "select default puplic key algorithm"
+msgstr "seleziona l'algoritmo a chiave pubblica predefinito"
+
+#: g10/g10.c:119
+msgid "select default message digest algorithm"
+msgstr "seleziona l'algoritmo di message digest predefinito"
+
+#: g10/g10.c:123
+msgid ""
+"\\v\n"
+"Examples:\n"
+"\n"
+" -se -r Bob [file]          sign and encrypt for user Bob\n"
+" -sat [file]                make a clear text signature\n"
+" -sb  [file]                make a detached signature\n"
+" -k   [userid]              show keys\n"
+" -kc  [userid]              show fingerprint\n"
+msgstr ""
+"\\v\n"
+"Esempi:\n"
+"\n"
+" -se -r Bob [file]          firma e cifra per l'utente Bob\n"
+" -sat [file]                fai una firma al testo in chiaro\n"
+" -sb  [file]                fai una firma separata\n"
+" -k   [userid]              mostra le chiavi\n"
+" -kc  [userid]              mostra le impronte digitali\n"
+
+#: g10/g10.c:201
+msgid "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"
+msgstr "Per favore segnala i bug a <gnupg-bugs@isil.d.shuttle.de>.\n"
+
+#: g10/g10.c:206
+msgid "Usage: gpgm [options] [files] (-h for help)"
+msgstr "Uso: gpgm [opzioni] [file] (-h per l'aiuto)"
+
+#: g10/g10.c:208
+msgid "Usage: gpg [options] [files] (-h for help)"
+msgstr "Uso: gpg [opzioni] [file] (-h per l'aiuto)"
+
+#: g10/g10.c:213
+msgid ""
+"Syntax: gpgm [options] [files]\n"
+"GNUPG maintenance utility\n"
+msgstr ""
+"Sintassi: gpgm [opzioni] [file]\n"
+"Utility di manutenzione di GNUPG\n"
+
+#: g10/g10.c:216
+msgid ""
+"Syntax: gpg [options] [files]\n"
+"sign, check, encrypt or decrypt\n"
+"default operation depends on the input data\n"
+msgstr ""
+"Sintassi: gpg [opzioni] [file]\n"
+"firma, controlla, cifra o decifra\n"
+"l'operazione predefinita dipende dai dati di input\n"
+
+#: g10/g10.c:293
+msgid "usage: gpgm [options] "
+msgstr "uso: gpgm [options] "
+
+#: g10/g10.c:295
+msgid "usage: gpg [options] "
+msgstr "uso: gpg [options] "
+
+#: g10/g10.c:335
+msgid "conflicting commands\n"
+msgstr "comandi in conflitto\n"
+
+#: g10/g10.c:348
+msgid "selected cipher algorithm is invalid\n"
+msgstr "l'algoritmo di cifratura selezionato non  valido\n"
+
+#: g10/g10.c:350
+msgid "selected pubkey algorithm is invalid\n"
+msgstr "l'algoritmo a chiave pubblica selezionato non  valido\n"
+
+#: g10/g10.c:352
+msgid "selected digest algorithm is invalid\n"
+msgstr "l'algoritmo di digest selezionato non  valido\n"
+
+#: g10/g10.c:354
+msgid "completes-needed must be greater than 0\n"
+msgstr "completes-needed deve essere maggiore di 0\n"
+
+#: g10/g10.c:356
+msgid "marginals-needed must be greater than 1\n"
+msgstr "marginals-needed deve essere maggiore di 1\n"
+
+#: g10/g10.c:450
+msgid "note: no default option file '%s'\n"
+msgstr "nota: nessun file con opzioni predefinite '%s'\n"
+
+#: g10/g10.c:454
+msgid "option file '%s': %s\n"
+msgstr "file con opzioni predefinite '%s': %s\n"
+
+#: g10/g10.c:461
+msgid "reading options from '%s'\n"
+msgstr "lettura delle opzioni da '%s'\n"
+
+#: g10/g10.c:657
+msgid "failed to initialize the TrustDB: %s\n"
+msgstr "inizializzazione del TrustDB fallita: %s\n"
+
+#: g10/g10.c:663
+msgid "--store [filename]"
+msgstr "--store [nomefile]"
+
+#. encrypt the given file only with the symmetric cipher
+#: g10/g10.c:671
+msgid "--symmetric [filename]"
+msgstr " [nomefile]"
+
+#: g10/g10.c:679
+msgid "--encrypt [filename]"
+msgstr "--encrypt [nomefile]"
+
+#: g10/g10.c:692
+msgid "--sign [filename]"
+msgstr "--sign [nomefile]"
+
+#: g10/g10.c:705
+msgid "--sign --encrypt [filename]"
+msgstr "--sign --encrypt [nomefile]"
+
+#. make a clearsig
+#: g10/g10.c:719
+msgid "--clearsign [filename]"
+msgstr "--clearsign [nomefile]"
+
+#: g10/g10.c:731
+msgid "--decrypt [filename]"
+msgstr "--decrypt [nomefile]"
+
+#: g10/g10.c:739
+msgid "--sign-key username"
+msgstr ""
+
+#: g10/g10.c:747
+msgid "--edit-sig username"
+msgstr ""
+
+#: g10/g10.c:755
+msgid "--delete-secret-key username"
+msgstr ""
+
+#: g10/g10.c:758
+msgid "--delete-key username"
+msgstr ""
+
+#. no arg: use default, 1 arg use this one
+#: g10/g10.c:766
+msgid "--change-passphrase [username]"
+msgstr ""
+
+#: g10/g10.c:787
+msgid "can't open %s: %s\n"
+msgstr "impossibile aprire '%s': %s\n"
+
+#: g10/g10.c:798
+msgid "-k[v][v][v][c] [userid] [keyring]"
+msgstr "-k[v][v][v][c] [userid] [portachiavi]"
+
+#: g10/g10.c:804
+msgid "--gen-key"
+msgstr ""
+
+#: g10/g10.c:845
+msgid "dearmoring failed: %s\n"
+msgstr "rimozione dell'armatura fallita: %s\n"
+
+#: g10/g10.c:853
+msgid "enarmoring failed: %s\n"
+msgstr "creazione dell'armatura fallita: %s\n"
+
+#. fixme: g10maint should to regular maintenace tasks here
+#: g10/g10.c:934
+msgid "[filename]"
+msgstr "[nomefile]"
+
+#: g10/g10.c:936
+msgid "can't open '%s'\n"
+msgstr "impossibile aprire '%s'"
+
+# #### Md ???
+#: g10/pkclist.c:65
+msgid ""
+"No ownertrust defined for %lu:\n"
+"%4u%c/%08lX %s \""
+msgstr ""
+"Nessun valore di fiducia del proprietario definito per %lu:\n"
+"%4u%c/%08lX %s \""
+
+#: g10/pkclist.c:72
+msgid ""
+"\"\n"
+"\n"
+"Please decide in how far do you trust this user to\n"
+"correctly sign other users keys (looking at his passport,\n"
+"checking the fingerprints from different sources ...)?\n"
+"\n"
+" 1 = Don't know\n"
+" 2 = I do NOT trust\n"
+" 3 = I trust marginally\n"
+" 4 = I trust fully\n"
+" s = please show me more informations\n"
+"\n"
+msgstr ""
+"\"\n"
+"\n"
+"Per favore decidi fino a quanto hai fiducia di questo utente perch\n"
+"firmi correttamente le chiavi di altri utenti (guardando il suo\n"
+"passaporto, controllando le impronte digitali da diverse fonti ...)?\n"
+"\n"
+" 1 = Non lo so\n"
+" 2 = NON mi fido\n"
+" 3 = Mi fido marginalmente\n"
+" 4 = Mi fido completamente\n"
+" s = mostrami ulteriori informazioni\n"
+"\n"
+
+#: g10/pkclist.c:83
+msgid "Your decision? "
+msgstr "La tua decisione? "
+
+#: g10/pkclist.c:90
+msgid ""
+"It's up to you to assign a value here; this value will never be exported\n"
+"to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n"
+"to do with the (implicitly created) web-of-certificates.\n"
+msgstr ""
+" compito tuo assegnare qui un valore; questo valore non sar mai esportato\n"
+"ad alcuna terza persona. Ci serve per implementare la ragnatela-di-fiducia;\n"
+"non ha nulla a che fare con la ragnatela-di-certificati (creata"
+"implicitamente).\n"
+
+#: g10/pkclist.c:108
+msgid "You will see a list of signators etc. here\n"
+msgstr "Qui vedrai una lista di firmatari, ecc...\n"
+
+#: g10/pkclist.c:132
+msgid ""
+"Could not find a valid trust path to the key.  Lets see, wether we\n"
+"can assign some missing owner trust values.\n"
+"\n"
+msgstr ""
+"Impossibile trovare un percorso di fiducia valido fino alla chiave. Vediamo\n"
+"se possiamo assegnare qualche valore di fiducia del proprietario mancante.\n"
+"\n"
+
+#: g10/pkclist.c:157
+msgid ""
+"No ownertrust values changed.\n"
+"\n"
+msgstr ""
+"Nessun valore di fiducia del proprietario modificato.\n"
+"\n"
+
+
+#: g10/pkclist.c:267
+msgid ""
+"It is NOT certain, that the key belongs to his owner.\n"
+"If you *really* know what you are doing, you may answer\n"
+"the next question with yes\n"
+"\n"
+msgstr "NON  sicuro che la chiave appartenga al suo proprietario.\n"
+"Se *veramente* sai cosa stai facendo, puoi rispondere si alla\n"
+"prossima domanda.\n"
+"\n"
+
+#: g10/pkclist.c:304
+msgid ""
+"You did not specify a user ID. (you may use \"-r\")\n"
+"\n"
+msgstr ""
+"Non hai specificato un user ID. (puoi usare \"-r\")\n"
+"\n"
+
+
+#: g10/pkclist.c:308
+msgid "Enter the user ID: "
+msgstr "Inserisci l'user ID: "
+
+#: g10/keygen.c:109
+msgid "writing self signature\n"
+msgstr "scrittura della autofirma\n"
+
+#: g10/keygen.c:303
+msgid "Key generation can only be used in interactive mode\n"
+msgstr "Una chiave pu essere generata solo in modo interattivo\n"
+
+#: g10/keygen.c:307
+msgid ""
+"Please select the algorithm to use:\n"
+"   (1) ElGamal is the suggested one.\n"
+"   (2) DSA can only be used for signatures.\n"
+msgstr ""
+"Per favore seleziona l'algoritmo da usare:\n"
+"   (1) ElGamal  quello consigliato.\n"
+"   (2) DSA pu essere usato solo per firmare.\n"
+
+#: g10/keygen.c:311
+msgid "   (3) RSA cannot be used in the U.S.\n"
+msgstr "   (3) RSA non pu essere usato negli USA.\n"
+
+#: g10/keygen.c:320
+msgid "Your selection? (1,2,3) "
+msgstr "La tua scelta? (1,2,3) "
+
+#: g10/keygen.c:322
+msgid "Your selection? (1,2) "
+msgstr "La tua scelta? (1,2) "
+
+#: g10/keygen.c:336
+msgid "Sorry; DSA is not yet supported.\n"
+msgstr "Mi spiace, DSA non  gestito.\n"
+
+#: g10/keygen.c:349
+msgid ""
+"About to generate a new %s keypair.\n"
+"              minimum keysize is  768 bits\n"
+"              default keysize is 1024 bits\n"
+"    highest suggested keysize is 2048 bits\n"
+msgstr ""
+"Sto per generare una nuova coppia di chiavi %s.\n"
+"               la dimensione minima   768 bit\n"
+"          la dimensione predefinita  1024 bit\n"
+"    la dimensione massima suggerita  2048 bit\n"
+
+#: g10/keygen.c:357
+msgid "What keysize do you want? (1024) "
+msgstr "Di che dimensioni vuoi la chiave? (1024) "
+
+#: g10/keygen.c:363
+msgid "DSA does only allow keysizes from 512 to 1024\n"
+msgstr "DSA permette solo chiavi di dimensioni da 512 a 1024\n"
+
+#: g10/keygen.c:365
+msgid "keysize too small; 768 is smallest value allowed.\n"
+msgstr "le dimensioni della chiave sono troppo piccole; 768  il\n"
+"pi piccolo valore permesso.\n"
+
+#: g10/keygen.c:367
+msgid ""
+"Keysizes larger than 2048 are not suggested, because computations take "
+"REALLY long!\n"
+msgstr ""
+"Chiavi di dimensioni maggiori di 2048 non sono consigliate, perch i "
+"calcoli sono VERAMENTE lunghi!\n"
+
+#: g10/keygen.c:369
+msgid "Are you sure, that you want this keysize? "
+msgstr "Sei sicuro che vuoi una chiave di queste dimensioni? "
+
+#: g10/keygen.c:373
+msgid ""
+"Okay, but keep in mind that your monitor and keyboard radiation is also very "
+"vulnerable to attacks!\n"
+msgstr "Va bene, ma ricordati che anche le radiazioni emesse dal tuo monitor "
+"e dalla tua tastiera sono molto vulnerabili ad attacchi!\n"
+
+#: g10/keygen.c:383
+msgid "Requested keysize is %u bits\n"
+msgstr "Le dimensioni della chiave richieste sono %u bit\n"
+
+#: g10/keygen.c:386 g10/keygen.c:390
+msgid "rounded up to %u bits\n"
+msgstr "arrotondate a %u bit"
+
+#: g10/keygen.c:397
+msgid ""
+"\n"
+"You need a User-ID to identify your key; the software constructs the user "
+"id\n"
+"from Real Name, Comment and Email Address in this form:\n"
+"    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n"
+"\n"
+msgstr ""
+"\n"
+"Ti serve un User ID per identificare la tua chiave; il software costruisce "
+"l'user id a partire da Nome e Cognome, Commento e Indirizzo di Email "
+"indicati in questo modulo:\n"
+"    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n"
+"\n"
+
+#: g10/keygen.c:409
+msgid "Real name: "
+msgstr "Nome e Cognome: "
+
+#: g10/keygen.c:413
+msgid "Invalid character in name\n"
+msgstr "Carattere non valido nel nome\n"
+
+#: g10/keygen.c:415
+msgid "Name may not start with a digit\n"
+msgstr "Il nome non pu iniziare con una cifra\n"
+
+#: g10/keygen.c:417
+msgid "Name must be at least 5 characters long\n"
+msgstr "Il nome deve essere lungo almeno 5 caratteri\n"
+
+#: g10/keygen.c:425
+msgid "Email address: "
+msgstr "Indirizzo di Email: "
+
+#: g10/keygen.c:437
+msgid "Not a valid email address\n"
+msgstr "Non  un indirizzo di email valido\n"
+
+#: g10/keygen.c:445
+msgid "Comment: "
+msgstr "Commento: "
+
+#: g10/keygen.c:451
+msgid "Invalid character in comment\n"
+msgstr "Carattere non valido nel commento\n"
+
+#: g10/keygen.c:471
+msgid ""
+"You selected this USER-ID:\n"
+"    \"%s\"\n"
+"\n"
+msgstr ""
+"Hai selezionato questo User Id:\n"
+"    \"%s\"\n"
+"\n"
+
+#: g10/keygen.c:473
+msgid "Edit (N)ame, (C)omment, (E)mail or (O)kay? "
+msgstr "Modifica (N)ome, (C)ommento, (E)mail oppure (O)kay? "
+
+#: g10/keygen.c:505
+msgid ""
+"You need a Passphrase to protect your secret key.\n"
+"\n"
+msgstr ""
+"Ti serve una passphrase per proteggere la tua chiave segreta.\n"
+"\n"
+
+#: g10/keygen.c:516
+msgid ""
+"You don't what a passphrase - this is probably a *bad* idea!\n"
+"I will do it anyway.  You can change your passphrase at anytime,\n"
+"using this program with the option \"--change-passphrase\"\n"
+"\n"
+msgstr ""
+"Non hai specificato una passphrase - questa  probabilmente una *cattiva*\n"
+"idea! Lo far io comunque. Puoi cambiarla in ogni momento, usando questo\n"
+"programma con l'opzione \"--change-passphrase\"\n"
+"\n"
+
+#: g10/keygen.c:522
+msgid "passphrase not correctly repeated; try again.\n"
+msgstr "passphrase non ripetuta correttamente; riprova.\n"
+
+#: g10/keygen.c:539
+msgid "writing public certificate to '%s'\n"
+msgstr "scrittura del certificato pubblico in '%s'\n"
+
+#: g10/keygen.c:540
+msgid "writing secret certificate to '%s'\n"
+msgstr "scrittura del certificato privato in '%s'\n"
+
+#: g10/keygen.c:552
+msgid ""
+"We need to generate a lot of random bytes. It is a good idea to perform\n"
+"some other action (work in another window, move the mouse, utilize the\n"
+"network and the disks) during the prime generation; this gives the random\n"
+"number generator a better chance to gain enough entropy.\n"
+msgstr ""
+"Dobbiamo generare un mucchio di byte casuali.  una buona idea eseguire\n"
+"qualche altra azione (lavorare in un'altra finestra, muovere il mouse, usare\n"
+"la rete e i dischi) durante la generazione dei numeri primi; questo da al\n"
+"generatore di numeri casuali una maggiore possibilit di raccogliere\n"
+"abbastanza entropia.\n"
+
+#: g10/keygen.c:627
+msgid "public and secret key created and signed.\n"
+msgstr "chiavi pubbliche e segrete create e firmate.\n"
+
+#: g10/keygen.c:638
+msgid "Key generation failed: %s\n"
+msgstr "Generazione della chiave fallita: %s\n"
diff -urN gnupg-0.2.13/tools/Makefile.am gnupg-0.2.14/tools/Makefile.am
--- gnupg-0.2.13/tools/Makefile.am	Fri Feb 13 14:16:29 1998
+++ gnupg-0.2.14/tools/Makefile.am	Wed Apr  1 18:44:31 1998
@@ -1,6 +1,6 @@
 ## Process this file with automake to produce Makefile.in
 
-INCLUDES = -I$(top_srcdir)/include
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a ../mpi/libmpi.a ../util/libutil.a
 
 noinst_PROGRAMS = mpicalc bftest clean-sat
diff -urN gnupg-0.2.13/tools/Makefile.in gnupg-0.2.14/tools/Makefile.in
--- gnupg-0.2.13/tools/Makefile.in	Tue Mar 10 18:48:11 1998
+++ gnupg-0.2.14/tools/Makefile.in	Thu Apr  2 12:06:27 1998
@@ -92,7 +92,7 @@
 ZLIBS = @ZLIBS@
 l = @l@
 
-INCLUDES = -I$(top_srcdir)/include
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a ../mpi/libmpi.a ../util/libutil.a
 
 noinst_PROGRAMS = mpicalc bftest clean-sat
diff -urN gnupg-0.2.13/tools/bftest.c gnupg-0.2.14/tools/bftest.c
--- gnupg-0.2.13/tools/bftest.c	Mon Feb 23 13:22:50 1998
+++ gnupg-0.2.14/tools/bftest.c	Thu Mar 12 16:08:26 1998
@@ -47,7 +47,7 @@
 static void
 i18n_init(void)
 {
-  #ifdef HAVE_LIBINTL
+  #ifdef ENABLE_NLS
     #ifdef HAVE_LC_MESSAGES
        setlocale( LC_MESSAGES, "" );
     #else
diff -urN gnupg-0.2.13/tools/mpicalc.c gnupg-0.2.14/tools/mpicalc.c
--- gnupg-0.2.13/tools/mpicalc.c	Mon Feb 23 13:22:50 1998
+++ gnupg-0.2.14/tools/mpicalc.c	Thu Mar 12 16:10:54 1998
@@ -65,7 +65,7 @@
 static void
 i18n_init(void)
 {
-  #ifdef HAVE_LIBINTL
+  #ifdef ENABLE_NLS
     #ifdef HAVE_LC_MESSAGES
        setlocale( LC_MESSAGES, "" );
     #else
diff -urN gnupg-0.2.13/util/ChangeLog gnupg-0.2.14/util/ChangeLog
--- gnupg-0.2.13/util/ChangeLog	Sat Mar  7 11:55:02 1998
+++ gnupg-0.2.14/util/ChangeLog	Thu Mar 19 11:29:30 1998
@@ -1,3 +1,7 @@
+Thu Mar 19 11:29:03 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* strgutil.c (memistr): Add const to return and first arg.
+
 Sat Mar  7 11:54:35 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* miscutil.c (print_string): New arg delim; changed all callers.
diff -urN gnupg-0.2.13/util/Makefile.am gnupg-0.2.14/util/Makefile.am
--- gnupg-0.2.13/util/Makefile.am	Mon Feb  9 12:12:19 1998
+++ gnupg-0.2.14/util/Makefile.am	Wed Apr  1 18:44:39 1998
@@ -1,6 +1,6 @@
 ## Process this file with automake to produce Makefile.in
 
-INCLUDES = -I$(top_srcdir)/include
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 
 noinst_LIBRARIES = libutil.a
 
diff -urN gnupg-0.2.13/util/Makefile.in gnupg-0.2.14/util/Makefile.in
--- gnupg-0.2.13/util/Makefile.in	Tue Mar 10 18:47:59 1998
+++ gnupg-0.2.14/util/Makefile.in	Thu Apr  2 12:06:16 1998
@@ -92,7 +92,7 @@
 ZLIBS = @ZLIBS@
 l = @l@
 
-INCLUDES = -I$(top_srcdir)/include
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 
 noinst_LIBRARIES = libutil.a
 
diff -urN gnupg-0.2.13/util/errors.c gnupg-0.2.14/util/errors.c
--- gnupg-0.2.13/util/errors.c	Thu Mar  5 12:20:38 1998
+++ gnupg-0.2.14/util/errors.c	Thu Mar 12 13:31:25 1998
@@ -71,6 +71,7 @@
       X(RENAME_FILE    ,"File rename error")
       X(DELETE_FILE    ,"File delete error")
       X(UNEXPECTED     ,"Unexpected data")
+      X(TIME_CONFLICT  ,"Timestamp conflict")
 
       default: p = buf; sprintf(buf, "g10err=%d", err); break;
     }
diff -urN gnupg-0.2.13/util/miscutil.c gnupg-0.2.14/util/miscutil.c
--- gnupg-0.2.13/util/miscutil.c	Sat Mar  7 11:54:32 1998
+++ gnupg-0.2.14/util/miscutil.c	Thu Apr  2 10:51:04 1998
@@ -32,6 +32,24 @@
     return time(NULL);
 }
 
+u32
+add_days_to_timestamp( u32 stamp, u16 days )
+{
+    return stamp + days*86400L;
+}
+
+const char *
+strtimestamp( u32 stamp )
+{
+    static char buffer[11+5];
+    struct tm *tp;
+    time_t atime = stamp;
+
+    tp = gmtime( &atime );
+    sprintf(buffer,"%04d-%02d-%02d",
+		    1900+tp->tm_year, tp->tm_mon+1, tp->tm_mday );
+    return buffer;
+}
 
 /****************
  * Print a string to FP, but filter all control characters out.
diff -urN gnupg-0.2.13/util/strgutil.c gnupg-0.2.14/util/strgutil.c
--- gnupg-0.2.13/util/strgutil.c	Mon Feb 23 13:11:24 1998
+++ gnupg-0.2.14/util/strgutil.c	Thu Mar 19 11:28:10 1998
@@ -77,15 +77,15 @@
  * substring in BUF or NULL if not found.
  * Comparison is case-in-sensitive.
  */
-char *
-memistr( char *buf, size_t buflen, const char *sub )
+const char *
+memistr( const char *buf, size_t buflen, const char *sub )
 {
     const byte *t, *s ;
     size_t n;
 
     for( t=buf, n=buflen, s=sub ; n ; t++, n-- )
 	if( toupper(*t) == toupper(*s) ) {
-	    for( buf=(char*)t++, buflen = n--, s++;
+	    for( buf=t++, buflen = n--, s++;
 		 n && toupper(*t) == toupper(*s); t++, s++, n-- )
 		;
 	    if( !*s )
